searchData={"items":[{"type":"module","title":"Backpex","doc":"Backpex provides an easy way to manage existing resources in your application.","ref":"Backpex.html"},{"type":"function","title":"Backpex.translate/2","doc":"Translates a string.\n\nThe type must be `:general` or `:error`.","ref":"Backpex.html#translate/2"},{"type":"module","title":"Backpex.CookieController","doc":"","ref":"Backpex.CookieController.html"},{"type":"function","title":"Backpex.CookieController.update/2","doc":"","ref":"Backpex.CookieController.html#update/2"},{"type":"module","title":"Backpex.Ecto.Amount.Type","doc":"Provides a type for Ecto to store a amount.\nThe underlying data type should be an integer.","ref":"Backpex.Ecto.Amount.Type.html"},{"type":"module","title":"Migration - Backpex.Ecto.Amount.Type","doc":"create table(:my_table) do\n      add :amount, :integer\n    end","ref":"Backpex.Ecto.Amount.Type.html#module-migration"},{"type":"module","title":"Schema - Backpex.Ecto.Amount.Type","doc":"schema \"my_table\" do\n      field :amount, Backpex.Ecto.Amount.Type\n    end\n\n    schema \"my_table\" do\n      field :amount, Backpex.Ecto.Amount.Type, currency: :EUR, separator: \".\", delimiter: \",\"\n    end","ref":"Backpex.Ecto.Amount.Type.html#module-schema"},{"type":"function","title":"Backpex.Ecto.Amount.Type.cast/2","doc":"","ref":"Backpex.Ecto.Amount.Type.html#cast/2"},{"type":"function","title":"Backpex.Ecto.Amount.Type.dump/3","doc":"","ref":"Backpex.Ecto.Amount.Type.html#dump/3"},{"type":"function","title":"Backpex.Ecto.Amount.Type.init/1","doc":"","ref":"Backpex.Ecto.Amount.Type.html#init/1"},{"type":"function","title":"Backpex.Ecto.Amount.Type.load/3","doc":"","ref":"Backpex.Ecto.Amount.Type.html#load/3"},{"type":"function","title":"Backpex.Ecto.Amount.Type.type/1","doc":"","ref":"Backpex.Ecto.Amount.Type.html#type/1"},{"type":"module","title":"Backpex.Ecto.EctoUtils","doc":"Utilities for working with Ecto schemas and changesets.","ref":"Backpex.Ecto.EctoUtils.html"},{"type":"function","title":"Backpex.Ecto.EctoUtils.get_primary_key_field/1","doc":"Get the primary key field of an Ecto schema.\n\nThis function can handle various input types:\n- Ecto schema module\n- Ecto schema struct\n- Ecto.Changeset","ref":"Backpex.Ecto.EctoUtils.html#get_primary_key_field/1"},{"type":"function","title":"Examples - Backpex.Ecto.EctoUtils.get_primary_key_field/1","doc":"iex> get_primary_key_field(MyApp.User)\n    :id\n\n    iex> get_primary_key_field(%MyApp.User{})\n    :id\n\n    iex> get_primary_key_field(Ecto.Changeset.change(%MyApp.User{}))\n    :id","ref":"Backpex.Ecto.EctoUtils.html#get_primary_key_field/1-examples"},{"type":"function","title":"Errors - Backpex.Ecto.EctoUtils.get_primary_key_field/1","doc":"Raises an error if:\n- No primary key is defined\n- A compound primary key is used (not supported)","ref":"Backpex.Ecto.EctoUtils.html#get_primary_key_field/1-errors"},{"type":"module","title":"Backpex.FormComponent","doc":"The form live component.","ref":"Backpex.FormComponent.html"},{"type":"function","title":"Backpex.FormComponent.handle_event/3","doc":"","ref":"Backpex.FormComponent.html#handle_event/3"},{"type":"function","title":"Backpex.FormComponent.render/1","doc":"","ref":"Backpex.FormComponent.html#render/1"},{"type":"function","title":"Backpex.FormComponent.update/2","doc":"","ref":"Backpex.FormComponent.html#update/2"},{"type":"module","title":"Backpex.InitAssigns","doc":"Ensures Backpex `assigns` are applied to all LiveViews attaching this hook.","ref":"Backpex.InitAssigns.html"},{"type":"function","title":"Backpex.InitAssigns.on_mount/4","doc":"","ref":"Backpex.InitAssigns.html#on_mount/4"},{"type":"behaviour","title":"Backpex.LiveResource","doc":"A LiveResource makes it easy to manage existing resources in your application. It provides extensive configuration options in order to meet everyone's needs. In connection with `Backpex.Components` you can build an individual admin dashboard on top of your application in minutes.\n\n> #### `use Backpex.LiveResource` {: .info}\n>\n> When you `use Backpex.LiveResource`, the `Backpex.LiveResource` module will set `@behavior Backpex.LiveResource`. Additionally it will create a LiveView based on the given configuration in order to create fully functional index, show, new and edit views for a resource. It will also insert fallback functions that can be overridden.","ref":"Backpex.LiveResource.html"},{"type":"macro","title":"Backpex.LiveResource.__using__/1","doc":"Uses LiveResource in the current module to make it a LiveResource.\n\n    use Backpex.LiveResource,\n      layout: {MyAppWeb.LayoutView, :admin},\n      schema: MyApp.User,\n      repo: MyApp.Repo,\n      update_changeset: &MyApp.User.update_changeset/3,\n      create_changeset: &MyApp.User.create_changeset/3","ref":"Backpex.LiveResource.html#__using__/1"},{"type":"macro","title":"Options - Backpex.LiveResource.__using__/1","doc":"* `:layout` - Layout to be used by the LiveResource.\n  * `:schema` - Schema for the resource.\n  * `:repo` - Ecto repo that will be used to perform CRUD operations for the given schema.\n  * `:update_changeset` - Changeset to use when updating items. Additional metadata is passed as a keyword list via the third parameter.\n\n    The list of metadata:\n    - `:assigns` - the assigns\n    - `:target` - the name of the `form` target that triggered the changeset call. Default to `nil` if the call was not triggered by a form field.\n  * `:create_changeset` - Changeset to use when creating items. Additional metadata is passed as a keyword list via the third parameter.\n\n    The list of metadata:\n    - `:assigns` - the assigns\n    - `:target` - the name of the `form` target that triggered the changeset call. Default to `nil` if the call was not triggered by a form field.\n  * `:pubsub` - PubSub name of the project.\n  * `:topic` - The topic for PubSub.\n  * `:event_prefix` - The event prefix for Pubsub, to differentiate between events of different resources when subscribed to multiple resources.\n  * `:per_page_options` - The page size numbers you can choose from.\n    Defaults to `[15, 50, 100]`.\n  * `:per_page_default` - The default page size number.\n    Defaults to the first element of the `per_page_options` list.\n  * `:init_order` - Order that will be used when no other order options are given.\n    Defaults to `%{by: :id, direction: :asc}`.","ref":"Backpex.LiveResource.html#__using__/1-options"},{"type":"function","title":"Backpex.LiveResource.calculate_total_pages/2","doc":"Calculates the total amount of pages.","ref":"Backpex.LiveResource.html#calculate_total_pages/2"},{"type":"function","title":"Examples - Backpex.LiveResource.calculate_total_pages/2","doc":"iex> Backpex.LiveResource.calculate_total_pages(1, 2)\n    1\n    iex> Backpex.LiveResource.calculate_total_pages(10, 10)\n    1\n    iex> Backpex.LiveResource.calculate_total_pages(20, 10)\n    2\n    iex> Backpex.LiveResource.calculate_total_pages(25, 6)\n    5","ref":"Backpex.LiveResource.html#calculate_total_pages/2-examples"},{"type":"function","title":"Backpex.LiveResource.call_changeset_function/4","doc":"Calls the changeset function with the given change and target.","ref":"Backpex.LiveResource.html#call_changeset_function/4"},{"type":"callback","title":"Backpex.LiveResource.can?/3","doc":"The function that can be used to restrict access to certain actions. It will be called before performing\nan action and aborts when the function returns `false`.","ref":"Backpex.LiveResource.html#c:can?/3"},{"type":"function","title":"Backpex.LiveResource.can?/4","doc":"Checks whether user is allowed to perform provided action or not","ref":"Backpex.LiveResource.html#can?/4"},{"type":"callback","title":"Backpex.LiveResource.create_button_label/0","doc":"Customizes the label of the button for creating a new item. Defaults to \"New %{resource}\".","ref":"Backpex.LiveResource.html#c:create_button_label/0"},{"type":"function","title":"Backpex.LiveResource.default_item_actions/0","doc":"","ref":"Backpex.LiveResource.html#default_item_actions/0"},{"type":"callback","title":"Backpex.LiveResource.fields/0","doc":"A list of fields defining your resource. See `Backpex.Field`.","ref":"Backpex.LiveResource.html#c:fields/0"},{"type":"function","title":"Backpex.LiveResource.filter_field_by_action/2","doc":"Filters a field by a given action. It checks whether the field contains the only or\nexcept key and decides whether or not to keep the field.","ref":"Backpex.LiveResource.html#filter_field_by_action/2"},{"type":"function","title":"Examples - Backpex.LiveResource.filter_field_by_action/2","doc":"iex> Backpex.LiveResource.filter_field_by_action(%{only: [:index]}, :index)\n    true\n    iex> Backpex.LiveResource.filter_field_by_action(%{only: [:edit]}, :index)\n    false\n    iex> Backpex.LiveResource.filter_field_by_action(%{except: [:edit]}, :index)\n    true\n    iex> Backpex.LiveResource.filter_field_by_action(%{except: [:index]}, :index)\n    false","ref":"Backpex.LiveResource.html#filter_field_by_action/2-examples"},{"type":"function","title":"Backpex.LiveResource.filter_options/2","doc":"Returns all filter options.","ref":"Backpex.LiveResource.html#filter_options/2"},{"type":"function","title":"Backpex.LiveResource.filtered_fields_by_action/3","doc":"Returns filtered fields by a certain action.","ref":"Backpex.LiveResource.html#filtered_fields_by_action/3"},{"type":"function","title":"Example - Backpex.LiveResource.filtered_fields_by_action/3","doc":"iex> Backpex.LiveResource.filtered_fields_by_action([field1: %{label: \"Field1\"}, field2: %{label: \"Field2\"}], %{}, :index)\n    [field1: %{label: \"Field1\"}, field2: %{label: \"Field2\"}]\n    iex> Backpex.LiveResource.filtered_fields_by_action([field1: %{label: \"Field1\", except: [:show]}, field2: %{label: \"Field2\"}], %{}, :show)\n    [field2: %{label: \"Field2\"}]\n    iex> Backpex.LiveResource.filtered_fields_by_action([field1: %{label: \"Field1\", only: [:index]}, field2: %{label: \"Field2\"}], %{}, :show)\n    [field2: %{label: \"Field2\"}]","ref":"Backpex.LiveResource.html#filtered_fields_by_action/3-example"},{"type":"callback","title":"Backpex.LiveResource.filters/0","doc":"A optional keyword list of [filters](Backpex.Filter.html) to be used on the index view.","ref":"Backpex.LiveResource.html#c:filters/0"},{"type":"callback","title":"Backpex.LiveResource.filters/1","doc":"A optional keyword list of [filters](Backpex.Filter.html) to be used on the index view.","ref":"Backpex.LiveResource.html#c:filters/1"},{"type":"function","title":"Backpex.LiveResource.get_active_filters/2","doc":"Returns list of active filters.","ref":"Backpex.LiveResource.html#get_active_filters/2"},{"type":"function","title":"Backpex.LiveResource.get_filter_options/2","doc":"Returns list of filter options from query options","ref":"Backpex.LiveResource.html#get_filter_options/2"},{"type":"function","title":"Backpex.LiveResource.get_valid_filters_from_params/3","doc":"","ref":"Backpex.LiveResource.html#get_valid_filters_from_params/3"},{"type":"callback","title":"Backpex.LiveResource.index_row_class/4","doc":"An extra class to be added to table rows on the index view.","ref":"Backpex.LiveResource.html#c:index_row_class/4"},{"type":"callback","title":"Backpex.LiveResource.item_actions/1","doc":"A list of [item_actions](Backpex.ItemAction.html) that may be performed on (selected) items.","ref":"Backpex.LiveResource.html#c:item_actions/1"},{"type":"callback","title":"Backpex.LiveResource.item_query/3","doc":"The function that can be used to inject an ecto query. The query will be used when resources are being fetched. This happens on `index`, `edit`\nand `show` view. In most cases this function will be used to filter items on `index` view based on certain criteria, but it may also be used\nto join other tables on `edit` or `show` view.\n\nThe function has to return an `Ecto.Query`. It is recommended to build your `item_query` on top of the incoming query. Otherwise you will likely get binding errors.","ref":"Backpex.LiveResource.html#c:item_query/3"},{"type":"function","title":"Backpex.LiveResource.list_items/3","doc":"List all items for current page with filters and search applied.","ref":"Backpex.LiveResource.html#list_items/3"},{"type":"function","title":"Backpex.LiveResource.maybe_put_empty_filter/2","doc":"","ref":"Backpex.LiveResource.html#maybe_put_empty_filter/2"},{"type":"function","title":"Backpex.LiveResource.maybe_subscribe/2","doc":"Maybe subscribes to pubsub.","ref":"Backpex.LiveResource.html#maybe_subscribe/2"},{"type":"callback","title":"Backpex.LiveResource.metrics/0","doc":"A list of metrics shown on the index view of your resource.","ref":"Backpex.LiveResource.html#c:metrics/0"},{"type":"callback","title":"Backpex.LiveResource.on_item_created/2","doc":"This function is executed when an item has been created.","ref":"Backpex.LiveResource.html#c:on_item_created/2"},{"type":"callback","title":"Backpex.LiveResource.on_item_deleted/2","doc":"This function is executed when an item has been deleted.","ref":"Backpex.LiveResource.html#c:on_item_deleted/2"},{"type":"callback","title":"Backpex.LiveResource.on_item_updated/2","doc":"This function is executed when an item has been updated.","ref":"Backpex.LiveResource.html#c:on_item_updated/2"},{"type":"function","title":"Backpex.LiveResource.order_options_by_params/4","doc":"Returns order options by params.","ref":"Backpex.LiveResource.html#order_options_by_params/4"},{"type":"function","title":"Examples - Backpex.LiveResource.order_options_by_params/4","doc":"iex> Backpex.LiveResource.order_options_by_params(%{\"order_by\" => \"field\", \"order_direction\" => \"asc\"}, [field: %{}], %{by: :id, direction: :asc}, [:asc, :desc])\n    %{order_by: :field, order_direction: :asc}\n    iex> Backpex.LiveResource.order_options_by_params(%{}, [field: %{}], %{by: :id, direction: :desc}, [:asc, :desc])\n    %{order_by: :id, order_direction: :desc}\n    iex> Backpex.LiveResource.order_options_by_params(%{\"order_by\" => \"field\", \"order_direction\" => \"asc\"}, [field: %{orderable: false}], %{by: :id, direction: :asc}, [:asc, :desc])\n    %{order_by: :id, order_direction: :asc}","ref":"Backpex.LiveResource.html#order_options_by_params/4-examples"},{"type":"function","title":"Backpex.LiveResource.orderable?/1","doc":"Checks whether a field is orderable or not.","ref":"Backpex.LiveResource.html#orderable?/1"},{"type":"function","title":"Examples - Backpex.LiveResource.orderable?/1","doc":"iex> Backpex.LiveResource.orderable?({:name, %{orderable: true}})\n    true\n    iex> Backpex.LiveResource.orderable?({:name, %{orderable: false}})\n    false\n    iex> Backpex.LiveResource.orderable?({:name, %{}})\n    true\n    iex> Backpex.LiveResource.orderable?(nil)\n    false","ref":"Backpex.LiveResource.html#orderable?/1-examples"},{"type":"function","title":"Backpex.LiveResource.orderable_fields/1","doc":"Returns all orderable fields. A field is orderable by default.","ref":"Backpex.LiveResource.html#orderable_fields/1"},{"type":"function","title":"Example - Backpex.LiveResource.orderable_fields/1","doc":"iex> Backpex.LiveResource.orderable_fields([field1: %{orderable: true}])\n    [:field1]\n    iex> Backpex.LiveResource.orderable_fields([field1: %{}])\n    [:field1]\n    iex> Backpex.LiveResource.orderable_fields([field1: %{orderable: false}])\n    []","ref":"Backpex.LiveResource.html#orderable_fields/1-example"},{"type":"callback","title":"Backpex.LiveResource.panels/0","doc":"A list of panels to group certain fields together.","ref":"Backpex.LiveResource.html#c:panels/0"},{"type":"function","title":"Backpex.LiveResource.parse_integer/3","doc":"Parses integer text representation map value of the given key. If the map does not contain the given key or parsing fails\nthe default value is returned.","ref":"Backpex.LiveResource.html#parse_integer/3"},{"type":"function","title":"Examples - Backpex.LiveResource.parse_integer/3","doc":"iex> Backpex.LiveResource.parse_integer(%{number: \"1\"}, :number, 2)\n    1\n    iex> Backpex.LiveResource.parse_integer(%{number: \"abc\"}, :number, 1)\n    1","ref":"Backpex.LiveResource.html#parse_integer/3-examples"},{"type":"callback","title":"Backpex.LiveResource.plural_name/0","doc":"The plural name of the resource used for translations and titles.","ref":"Backpex.LiveResource.html#c:plural_name/0"},{"type":"function","title":"Backpex.LiveResource.pubsub_settings/3","doc":"Returns pubsub settings based on configuration.","ref":"Backpex.LiveResource.html#pubsub_settings/3"},{"type":"callback","title":"Backpex.LiveResource.render_resource_slot/3","doc":"The function that can be used to add content to certain positions on Backpex views. It may also be used to overwrite content.\n\nThe following actions are supported: `:index`, `:show`\n\nThe following positions are supported for the `:index` action: `:page_title`, `:actions`, `:filters`, `:metrics` and `:main`.\nThe following positions are supported for the `:show` action: `:page_title` and `:main`.\n\nIn addition to this, content can be inserted between the main positions via the following extra spots: `:before_page_title`, `:before_actions`, `:before_filters`, `:before_metrics` and `:before_main`.","ref":"Backpex.LiveResource.html#c:render_resource_slot/3"},{"type":"callback","title":"Backpex.LiveResource.resource_actions/0","doc":"A list of [resource_actions](Backpex.ResourceAction.html) that may be performed on the given resource.","ref":"Backpex.LiveResource.html#c:resource_actions/0"},{"type":"callback","title":"Backpex.LiveResource.resource_created_message/0","doc":"Customizes the message in the flash message when a resource has been created successfully. Defaults to \"New %{resource} has been created successfully\".","ref":"Backpex.LiveResource.html#c:resource_created_message/0"},{"type":"callback","title":"Backpex.LiveResource.return_to/4","doc":"This function navigates to the specified path when an item has been created or updated. Defaults to the previous resource path (index or edit).","ref":"Backpex.LiveResource.html#c:return_to/4"},{"type":"callback","title":"Backpex.LiveResource.schema/0","doc":"Returns the schema of the live resource.","ref":"Backpex.LiveResource.html#c:schema/0"},{"type":"function","title":"Backpex.LiveResource.search_options/3","doc":"Returns all search options.","ref":"Backpex.LiveResource.html#search_options/3"},{"type":"callback","title":"Backpex.LiveResource.search_placeholder/0","doc":"Replaces the default placeholder for the index search.","ref":"Backpex.LiveResource.html#c:search_placeholder/0"},{"type":"function","title":"Backpex.LiveResource.searchable_fields/1","doc":"Returns all searchable fields. A field is not searchable by default.","ref":"Backpex.LiveResource.html#searchable_fields/1"},{"type":"function","title":"Example - Backpex.LiveResource.searchable_fields/1","doc":"iex> Backpex.LiveResource.searchable_fields([field1: %{searchable: true}])\n    [:field1]\n    iex> Backpex.LiveResource.searchable_fields([field1: %{}])\n    []\n    iex> Backpex.LiveResource.searchable_fields([field1: %{searchable: false}])\n    []","ref":"Backpex.LiveResource.html#searchable_fields/1-example"},{"type":"callback","title":"Backpex.LiveResource.singular_name/0","doc":"The singular name of the resource used for translations and titles.","ref":"Backpex.LiveResource.html#c:singular_name/0"},{"type":"function","title":"Backpex.LiveResource.validate_page/2","doc":"Validates a page number.","ref":"Backpex.LiveResource.html#validate_page/2"},{"type":"function","title":"Examples - Backpex.LiveResource.validate_page/2","doc":"iex> Backpex.LiveResource.validate_page(1, 5)\n    1\n    iex> Backpex.LiveResource.validate_page(-1, 5)\n    1\n    iex> Backpex.LiveResource.validate_page(6, 5)\n    5","ref":"Backpex.LiveResource.html#validate_page/2-examples"},{"type":"function","title":"Backpex.LiveResource.value_in_permitted_or_default/3","doc":"Checks whether the given value is in a list of permitted values. Otherwise return default value.","ref":"Backpex.LiveResource.html#value_in_permitted_or_default/3"},{"type":"function","title":"Examples - Backpex.LiveResource.value_in_permitted_or_default/3","doc":"iex> Backpex.LiveResource.value_in_permitted_or_default(3, [1, 2, 3], 5)\n    3\n    iex> Backpex.LiveResource.value_in_permitted_or_default(3, [1, 2], 5)\n    5","ref":"Backpex.LiveResource.html#value_in_permitted_or_default/3-examples"},{"type":"module","title":"Backpex.Resource","doc":"Generic context module for Backpex resources.","ref":"Backpex.Resource.html"},{"type":"function","title":"Backpex.Resource.apply_criteria/3","doc":"","ref":"Backpex.Resource.html#apply_criteria/3"},{"type":"function","title":"Backpex.Resource.apply_filters/3","doc":"","ref":"Backpex.Resource.html#apply_filters/3"},{"type":"function","title":"Backpex.Resource.apply_search/4","doc":"","ref":"Backpex.Resource.html#apply_search/4"},{"type":"function","title":"Backpex.Resource.before_changesets/6","doc":"","ref":"Backpex.Resource.html#before_changesets/6"},{"type":"function","title":"Backpex.Resource.build_changeset_metadata/2","doc":"Builds metadata passed to changeset functions.","ref":"Backpex.Resource.html#build_changeset_metadata/2"},{"type":"function","title":"Parameters - Backpex.Resource.build_changeset_metadata/2","doc":"* `assigns`: The assigns that will be passed to the changeset function.\n* `target` (optional, default `nil`): The target to be passed to the changeset function.","ref":"Backpex.Resource.html#build_changeset_metadata/2-parameters"},{"type":"function","title":"Backpex.Resource.change/7","doc":"Applies a change to a given item by calling the specified changeset function.\nIn addition, puts the given assocs into the function and calls the `c:Backpex.Field.before_changeset/6` callback for each field.","ref":"Backpex.Resource.html#change/7"},{"type":"function","title":"Parameters - Backpex.Resource.change/7","doc":"* `item`: The initial data structure to be changed.\n* `attrs`: A map of attributes that will be used to modify the item. These attributes are passed to the changeset function.\n* `changeset_function`: A function used to generate the changeset. This function is usually defined elsewhere in your codebase and should follow the changeset Ecto convention.\n* `assigns`: The assigns that will be passed to the changeset function.\n* `opts` (keyword list): A list of options for customizing the behavior of the change function. The available options are:\n  * `assocs` (optional, default `[]`): A list of associations that should be put into the changeset.\n  * `target` (optional, default `nil`): The target to be passed to the changeset function.\n  * `action` (optional, default `:validate`): An atom indicating the action to be performed on the changeset.","ref":"Backpex.Resource.html#change/7-parameters"},{"type":"function","title":"Backpex.Resource.count/5","doc":"Gets the total count of the current live_resource.\nPossibly being constrained the item query and the search- and filter options.","ref":"Backpex.Resource.html#count/5"},{"type":"function","title":"Backpex.Resource.delete/3","doc":"Deletes the given record from the database.\nAdditionally broadcasts the corresponding event, when PubSub config is given.","ref":"Backpex.Resource.html#delete/3"},{"type":"function","title":"Parameters - Backpex.Resource.delete/3","doc":"* `item` (struct): The item to be deleted.\n* `repo` (module): The repository module.\n* `pubsub` (map, default: `nil`): The PubSub config to use for broadcasting events.","ref":"Backpex.Resource.html#delete/3-parameters"},{"type":"function","title":"Backpex.Resource.delete_all/4","doc":"Deletes multiple items from a given repository and schema.\nAdditionally broadcasts the corresponding event, when PubSub config is given.","ref":"Backpex.Resource.html#delete_all/4"},{"type":"function","title":"Parameters - Backpex.Resource.delete_all/4","doc":"* `items` (list): A list of structs, each representing an entity to be deleted. The list must contain items that have an `id` field.\n* `repo` (module): The repository module.\n* `schema` (module): The Ecto schema module corresponding to the entities in `items`.\n* `pubsub` (map, default: `nil`): The PubSub config to use for broadcasting events.","ref":"Backpex.Resource.html#delete_all/4-parameters"},{"type":"function","title":"Backpex.Resource.get/5","doc":"Gets a database record with the given fields by the given id. Returns nil if no result was found.","ref":"Backpex.Resource.html#get/5"},{"type":"function","title":"Parameters - Backpex.Resource.get/5","doc":"* `id`: The identifier for the specific item to be fetched.\n* `repo` (module): The repository module.\n* `schema`: The Ecto schema module corresponding to the item\n* `item_query` (function): A function that modifies the base query. This function should accept an Ecto.Queryable and return an Ecto.Queryable. It's used to apply additional query logic.\n* `fields` (list): A list of atoms representing the fields to be selected and potentially preloaded.","ref":"Backpex.Resource.html#get/5-parameters"},{"type":"function","title":"Backpex.Resource.get!/5","doc":"Gets a database record with the given fields by the given id. Raises `Ecto.NoResultsError` if no record was found.","ref":"Backpex.Resource.html#get!/5"},{"type":"function","title":"Parameters - Backpex.Resource.get!/5","doc":"* `id`: The identifier for the specific item to be fetched.\n* `repo` (module): The repository module.\n* `schema`: The Ecto schema module corresponding to the item\n* `item_query` (function): A function that modifies the base query. This function should accept an Ecto.Queryable and return an Ecto.Queryable. It's used to apply additional query logic.\n* `fields` (list): A list of atoms representing the fields to be selected and potentially preloaded.","ref":"Backpex.Resource.html#get!/5-parameters"},{"type":"function","title":"Backpex.Resource.insert/6","doc":"Inserts a new item into a repository with specific parameters and options. It takes a repo module, a changeset function, an item, parameters for the changeset function, and additional options.","ref":"Backpex.Resource.html#insert/6"},{"type":"function","title":"Parameters - Backpex.Resource.insert/6","doc":"* `item` (struct): The Ecto schema struct.\n* `attrs` (map): A map of parameters that will be passed to the `changeset_function`.\n* `repo` (module): The repository module.\n* `fields` (keyword): The keyword list of fields defined in the live resource.\n* `changeset_function` (function): The function that transforms the item and parameters into a changeset.\n* `opts` (keyword list): A list of options for customizing the behavior of the insert function. The available options are:\n  * `:assigns` (map, default: `%{}`): The assigns that will be passed to the changeset function.\n  * `:pubsub` (map, default: `nil`): The PubSub config to use for broadcasting events.\n  * `:assocs` (list, default: `[]`): A list of associations.\n  * `:after_save` (function, default: `&{:ok, &1}`): A function to handle operations after the save.","ref":"Backpex.Resource.html#insert/6-parameters"},{"type":"function","title":"Backpex.Resource.list/4","doc":"Returns a list of items by given criteria.\n\nExample criteria:\n\n[\n  order: %{by: :item, direction: :asc},\n  pagination: %{page: 1, size: 5},\n  search: {\"hello\", [:title, :description]}\n]","ref":"Backpex.Resource.html#list/4"},{"type":"function","title":"Backpex.Resource.list_query/4","doc":"Returns the main database query for selecting a list of items by given criteria.","ref":"Backpex.Resource.html#list_query/4"},{"type":"function","title":"Backpex.Resource.metric_data/5","doc":"","ref":"Backpex.Resource.html#metric_data/5"},{"type":"function","title":"Backpex.Resource.name_by_schema/1","doc":"Gets name by schema. This is the last part of the module name as a lowercase atom.","ref":"Backpex.Resource.html#name_by_schema/1"},{"type":"function","title":"Examples - Backpex.Resource.name_by_schema/1","doc":"iex> Backpex.Resource.name_by_schema(Backpex.Resource)\n    :resource","ref":"Backpex.Resource.html#name_by_schema/1-examples"},{"type":"function","title":"Backpex.Resource.update/6","doc":"Handles the update of an existing item with specific parameters and options. It takes a repo module, a changeset function, an item, parameters for the changeset function, and additional options.","ref":"Backpex.Resource.html#update/6"},{"type":"function","title":"Parameters - Backpex.Resource.update/6","doc":"* `item` (struct): The Ecto schema struct.\n* `attrs` (map): A map of parameters that will be passed to the `changeset_function`.\n* `repo` (module): The repository module.\n* `fields` (keyword): The keyword list of fields defined in the live resource.\n* `changeset_function` (function): The function that transforms the item and parameters into a changeset.\n* `opts` (keyword list): A list of options for customizing the behavior of the insert function. The available options are:\n  * `:assigns` (map, default: `%{}`): The assigns that will be passed to the changeset function.\n  * `:pubsub` (map, default: `nil`): The PubSub config to use for broadcasting events.\n  * `:assocs` (list, default: `[]`): A list of associations.\n  * `:after_save` (function, default: `&{:ok, &1}`): A function to handle operations after the save.","ref":"Backpex.Resource.html#update/6-parameters"},{"type":"function","title":"Backpex.Resource.update_all/6","doc":"Updates multiple items from a given repository and schema.\nAdditionally broadcasts the corresponding event, when PubSub config is given.","ref":"Backpex.Resource.html#update_all/6"},{"type":"function","title":"Parameters - Backpex.Resource.update_all/6","doc":"* `items` (list): A list of structs, each representing an entity to be updated.\n* `repo` (module): The repository module.\n* `schema` (module): The Ecto schema module corresponding to the entities in `items`.\n* `updates` (list): A list of updates passed to Ecto `update_all` function.\n* `event_name` (string, default: `updated`): The name to be used when broadcasting the event.\n* `pubsub` (map, default: `nil`): The PubSub config to use for broadcasting events.","ref":"Backpex.Resource.html#update_all/6-parameters"},{"type":"module","title":"Backpex.Router","doc":"Provides LiveView routing for Backpex resources.","ref":"Backpex.Router.html"},{"type":"function","title":"Backpex.Router.active?/2","doc":"Checks whether the to path is the same as the current path","ref":"Backpex.Router.html#active?/2"},{"type":"function","title":"Examples - Backpex.Router.active?/2","doc":"iex> Backpex.Router.active?(URI.new!(\"https://example.com/admin/events\"), \"/admin/events\")\n    true\n    iex> Backpex.Router.active?(URI.new!(\"https://example.com/admin/events\"), \"/admin/users\")\n    false","ref":"Backpex.Router.html#active?/2-examples"},{"type":"macro","title":"Backpex.Router.backpex_routes/0","doc":"","ref":"Backpex.Router.html#backpex_routes/0"},{"type":"function","title":"Backpex.Router.cookie_path/1","doc":"Finds the cookie path by the given socket.","ref":"Backpex.Router.html#cookie_path/1"},{"type":"function","title":"Backpex.Router.filter_actions/3","doc":"Filters `actions` based on `only` and `except` parameters.","ref":"Backpex.Router.html#filter_actions/3"},{"type":"function","title":"Examples - Backpex.Router.filter_actions/3","doc":"iex> Backpex.Router.filter_actions([:index, :edit, :show], [:index], nil)\n    [:index]\n    iex> Backpex.Router.filter_actions([:index, :edit, :show], nil, [:index])\n    [:edit, :show]\n    iex> Backpex.Router.filter_actions([:index, :edit, :show], nil, nil)\n    [:index, :edit, :show]\n    iex> Backpex.Router.filter_actions([:index, :edit, :show], [], [])\n    [:index, :edit, :show]","ref":"Backpex.Router.html#filter_actions/3-examples"},{"type":"function","title":"Backpex.Router.get_path/5","doc":"Finds the raw path by the given socket and module and puts the path params into the raw path.","ref":"Backpex.Router.html#get_path/5"},{"type":"function","title":"Backpex.Router.get_path/6","doc":"","ref":"Backpex.Router.html#get_path/6"},{"type":"function","title":"Backpex.Router.has_resource_actions?/2","doc":"","ref":"Backpex.Router.html#has_resource_actions?/2"},{"type":"macro","title":"Backpex.Router.live_resources/3","doc":"Defines \"RESTful\" routes for a Backpex resource.","ref":"Backpex.Router.html#live_resources/3"},{"type":"macro","title":"Options - Backpex.Router.live_resources/3","doc":"* `:only` - List of actions to generate routes for, for example: `[:index, :show]`.\n  * `:except` - List of actions to exclude generated routes from, for example: `[:edit]`.","ref":"Backpex.Router.html#live_resources/3-options"},{"type":"macro","title":"Example - Backpex.Router.live_resources/3","doc":"defmodule MyAppWeb.Router\n      import Backpex.Router\n\n      scope \"/admin\", MyAppWeb do\n        pipe_through :browser\n\n        live_session :default, on_mount: Backpex.InitAssigns do\n          live_resources(\"/users\", UserLive, only: [:index])\n        end\n      end\n    end","ref":"Backpex.Router.html#live_resources/3-example"},{"type":"function","title":"Backpex.Router.member?/3","doc":"Checks whether `item` is member of `list` and returns `default` value if list is `nil` or empty.","ref":"Backpex.Router.html#member?/3"},{"type":"function","title":"Examples - Backpex.Router.member?/3","doc":"iex> Backpex.Router.member?([:index], :index, true)\n    true\n    iex> Backpex.Router.member?([:edit], :index, true)\n    false\n    iex> Backpex.Router.member?([], :index, true)\n    true\n    iex> Backpex.Router.member?(nil, :index, true)\n    true","ref":"Backpex.Router.html#member?/3-examples"},{"type":"function","title":"Backpex.Router.put_route_params/2","doc":"Replace path params with actual params","ref":"Backpex.Router.html#put_route_params/2"},{"type":"function","title":"Examples - Backpex.Router.put_route_params/2","doc":"iex> Backpex.Router.put_route_params(\"/:param1/events/:param2/show\", %{\"param1\" => \"123\", \"param2\" => \"xyz\", \"test\" => \"abcdef\"})\n    \"/123/events/xyz/show\"\n    iex> Backpex.Router.put_route_params(\"/:param1/events/:id/edit\", %{\"param1\" => \"123\", \"id\" => \"xyz\"})\n    \"/123/events/xyz/edit\"\n    iex> Backpex.Router.put_route_params(\"/:param1/events/:id/edit\", %{\"param1\" => \"123\", \"id\" => \"hällö / world\"})\n    \"/123/events/h%C3%A4ll%C3%B6+%2F+world/edit\"\n    iex> Backpex.Router.put_route_params(\"/events\", %{\"param1\" => \"123\", \"param2\" => \"xyz\"})\n    \"/events\"\n    iex> Backpex.Router.put_route_params(\"/events\", %{})\n    \"/events\"","ref":"Backpex.Router.html#put_route_params/2-examples"},{"type":"module","title":"Backpex.ThemeSelectorPlug","doc":"Contains a plug that inserts the theme into the assigns","ref":"Backpex.ThemeSelectorPlug.html"},{"type":"function","title":"Backpex.ThemeSelectorPlug.call/2","doc":"","ref":"Backpex.ThemeSelectorPlug.html#call/2"},{"type":"function","title":"Backpex.ThemeSelectorPlug.init/1","doc":"","ref":"Backpex.ThemeSelectorPlug.html#init/1"},{"type":"module","title":"BackpexWeb","doc":"The entrypoint for defining the web interface of Backpex.","ref":"BackpexWeb.html"},{"type":"module","title":"Example - BackpexWeb","doc":"use BackpexWeb, :html","ref":"BackpexWeb.html#module-example"},{"type":"macro","title":"BackpexWeb.__using__/1","doc":"When used, dispatch to the appropriate function.","ref":"BackpexWeb.html#__using__/1"},{"type":"function","title":"BackpexWeb.field/0","doc":"Includes all globally available field functions and helpers.","ref":"BackpexWeb.html#field/0"},{"type":"function","title":"BackpexWeb.filter/0","doc":"","ref":"BackpexWeb.html#filter/0"},{"type":"function","title":"BackpexWeb.html/0","doc":"Includes all globally available HTML functions and helpers.","ref":"BackpexWeb.html#html/0"},{"type":"function","title":"BackpexWeb.item_action/0","doc":"Includes all globally available item action functions and helpers.","ref":"BackpexWeb.html#item_action/0"},{"type":"function","title":"BackpexWeb.metric/0","doc":"","ref":"BackpexWeb.html#metric/0"},{"type":"module","title":"Backpex.HTML","doc":"Contains common HTML functions.","ref":"Backpex.HTML.html"},{"type":"function","title":"Backpex.HTML.pretty_value/1","doc":"Prettifies any input and show a placeholder in case the value is `nil`.","ref":"Backpex.HTML.html#pretty_value/1"},{"type":"function","title":"Examples - Backpex.HTML.pretty_value/1","doc":"iex> Backpex.HTML.pretty_value(nil)\n    \"—\"\n\n    iex> Backpex.HTML.pretty_value(\"\")\n    \"—\"\n\n    iex> Backpex.HTML.pretty_value(1_000_000)\n    1000000\n\n    iex> Backpex.HTML.pretty_value(1.11)\n    1.11\n\n    iex> Backpex.HTML.pretty_value(\"Hello, universe\")\n    \"Hello, universe\"","ref":"Backpex.HTML.html#pretty_value/1-examples"},{"type":"module","title":"Backpex.HTML.CoreComponents","doc":"Provides core components for Backpex.","ref":"Backpex.HTML.CoreComponents.html"},{"type":"function","title":"Backpex.HTML.CoreComponents.filter_badge/1","doc":"Renders a filter_badge component.","ref":"Backpex.HTML.CoreComponents.html#filter_badge/1"},{"type":"function","title":"Attributes - Backpex.HTML.CoreComponents.filter_badge/1","doc":"* `clear_event` (`:string`) - event name for removing the badge. Defaults to `\"clear-filter\"`.\n* `filter_name` (`:string`) (required)\n* `label` (`:string`) (required)","ref":"Backpex.HTML.CoreComponents.html#filter_badge/1-attributes"},{"type":"function","title":"Slots - Backpex.HTML.CoreComponents.filter_badge/1","doc":"* `inner_block`","ref":"Backpex.HTML.CoreComponents.html#filter_badge/1-slots"},{"type":"function","title":"Backpex.HTML.CoreComponents.icon/1","doc":"","ref":"Backpex.HTML.CoreComponents.html#icon/1"},{"type":"function","title":"Attributes - Backpex.HTML.CoreComponents.icon/1","doc":"* `name` (`:string`) (required)\n* `class` (`:any`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"Backpex.HTML.CoreComponents.html#icon/1-attributes"},{"type":"module","title":"Backpex.HTML.Form","doc":"Contains all Backpex form components.","ref":"Backpex.HTML.Form.html"},{"type":"function","title":"Backpex.HTML.Form.error/1","doc":"Generates a generic error message.","ref":"Backpex.HTML.Form.html#error/1"},{"type":"function","title":"Slots - Backpex.HTML.Form.error/1","doc":"* `inner_block` (required)","ref":"Backpex.HTML.Form.html#error/1-slots"},{"type":"function","title":"Backpex.HTML.Form.field_input/1","doc":"Renders an input.","ref":"Backpex.HTML.Form.html#field_input/1"},{"type":"function","title":"Attributes - Backpex.HTML.Form.field_input/1","doc":"* `id` (`:any`) - Defaults to `nil`.\n* `name` (`:any`)\n* `label` (`:string`) - Defaults to `nil`.\n* `value` (`:any`)\n* `type` (`:string`) - Defaults to `\"text\"`.\n* `field` (`Phoenix.HTML.FormField`) - a form field struct retrieved from the form, for example: @form[:email].\n* `errors` (`:list`) - Defaults to `[]`.\n* `checked` (`:boolean`) - the checked flag for checkbox inputs.\n* `prompt` (`:string`) - the prompt for select inputs. Defaults to `nil`.\n* `options` (`:list`) - the options to pass to Phoenix.HTML.Form.options_for_select/2.\n* `multiple` (`:boolean`) - the multiple flag for select inputs. Defaults to `false`.\n* `class` (`:string`) - additional class. Defaults to `nil`.\n* `input_class` (`:string`) - additional class for the input element. Defaults to `nil`.\n* `input_wrapper_class` (`:string`) - additional class for the input wrapper element, currently only used in select type. Defaults to `nil`.\n* `field_options` (`:map`) - field options map. Defaults to `%{}`.\n* `hide_errors` (`:boolean`) - if errors should be hidden. Defaults to `false`.\n* Global attributes are accepted. Supports all globals plus: `[\"accept\", \"autocomplete\", \"capture\", \"cols\", \"disabled\", \"form\", \"list\", \"max\", \"maxlength\", \"min\", \"minlength\", \"multiple\", \"pattern\", \"placeholder\", \"readonly\", \"required\", \"rows\", \"size\", \"step\"]`.","ref":"Backpex.HTML.Form.html#field_input/1-attributes"},{"type":"function","title":"Slots - Backpex.HTML.Form.field_input/1","doc":"* `inner_block`","ref":"Backpex.HTML.Form.html#field_input/1-slots"},{"type":"function","title":"Backpex.HTML.Form.form_errors?/2","doc":"","ref":"Backpex.HTML.Form.html#form_errors?/2"},{"type":"function","title":"Backpex.HTML.Form.multi_select/1","doc":"Renders a searchable multi select.","ref":"Backpex.HTML.Form.html#multi_select/1"},{"type":"function","title":"Attributes - Backpex.HTML.Form.multi_select/1","doc":"* `prompt` (`:string`) (required) - string that will be shown when no option is selected.\n* `not_found_text` (`:string`) (required) - string that will be shown when there are no options.\n* `options` (`:list`) (required) - a list of options for the select.\n* `search_input` (`:string`) (required) - to prefill and or persist the search term for rerendering.\n* `event_target` (`:any`) (required) - the target that handles the events of this component.\n* `field_options` (`:map`) (required) - field options for the corresponding field.\n* `field` (`:any`) (required) - form field the select should be for.\n* `selected` (`:list`) (required) - the selected values.\n* `show_select_all` (`:boolean`) (required) - whether to display the select all button.\n* `show_more` (`:boolean`) (required) - whether there are more options to show.\n* `search_event` (`:string`) - the event that will be sent when the search input changes. Defaults to `\"search\"`.\n* `hide_errors` (`:boolean`) - if errors should be hidden. Defaults to `false`.","ref":"Backpex.HTML.Form.html#multi_select/1-attributes"},{"type":"function","title":"Backpex.HTML.Form.translate_form_errors/2","doc":"","ref":"Backpex.HTML.Form.html#translate_form_errors/2"},{"type":"module","title":"Backpex.HTML.Layout","doc":"Contains all Backpex layout components.","ref":"Backpex.HTML.Layout.html"},{"type":"function","title":"Backpex.HTML.Layout.app_shell/1","doc":"Renders an app shell representing the base of your layout.","ref":"Backpex.HTML.Layout.html#app_shell/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.app_shell/1","doc":"* `fluid` (`:boolean`) - toggles fluid layout. Defaults to `false`.","ref":"Backpex.HTML.Layout.html#app_shell/1-attributes"},{"type":"function","title":"Slots - Backpex.HTML.Layout.app_shell/1","doc":"* `inner_block`\n* `topbar` - content to be displayed in the topbar. Accepts attributes:\n\n  * `class` (`:string`) - additional class that will be added to the component.\n* `sidebar` - content to be displayed in the sidebar. Accepts attributes:\n\n  * `class` (`:string`) - additional class that will be added to the component.\n* `footer` - content to be displayed in the footer.","ref":"Backpex.HTML.Layout.html#app_shell/1-slots"},{"type":"function","title":"Backpex.HTML.Layout.backpex_logo/1","doc":"Get the Backpex logo SVG.","ref":"Backpex.HTML.Layout.html#backpex_logo/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.backpex_logo/1","doc":"* `class` (`:string`) - class that will be added to the SVG element. Defaults to `nil`.","ref":"Backpex.HTML.Layout.html#backpex_logo/1-attributes"},{"type":"function","title":"Backpex.HTML.Layout.field_container/1","doc":"Renders the form label and input with corresponding margin and alignment.","ref":"Backpex.HTML.Layout.html#field_container/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.field_container/1","doc":"* `class` (`:string`) - extra classes to be added. Defaults to `\"\"`.","ref":"Backpex.HTML.Layout.html#field_container/1-attributes"},{"type":"function","title":"Slots - Backpex.HTML.Layout.field_container/1","doc":"* `label` (required) - Accepts attributes:\n\n  * `align` (`:atom`) - Must be one of `:top`, `:center`, or `:bottom`.\n* `inner_block`","ref":"Backpex.HTML.Layout.html#field_container/1-slots"},{"type":"function","title":"Backpex.HTML.Layout.flash_messages/1","doc":"Renders flash messages.","ref":"Backpex.HTML.Layout.html#flash_messages/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.flash_messages/1","doc":"* `flash` (`:map`) (required) - flash map that will be passed to `Phoenix.Flash.get/2`.","ref":"Backpex.HTML.Layout.html#flash_messages/1-attributes"},{"type":"function","title":"Backpex.HTML.Layout.footer/1","doc":"Renders a footer. It provides a default look when no content is provided.","ref":"Backpex.HTML.Layout.html#footer/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.footer/1","doc":"* `class` (`:string`) - additional class that will be added to the component. Defaults to `\"\"`.","ref":"Backpex.HTML.Layout.html#footer/1-attributes"},{"type":"function","title":"Slots - Backpex.HTML.Layout.footer/1","doc":"* `inner_block`","ref":"Backpex.HTML.Layout.html#footer/1-slots"},{"type":"function","title":"Backpex.HTML.Layout.hide_modal/2","doc":"","ref":"Backpex.HTML.Layout.html#hide_modal/2"},{"type":"function","title":"Backpex.HTML.Layout.input_label/1","doc":"Renders a text to be used as a label for an input.","ref":"Backpex.HTML.Layout.html#input_label/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.input_label/1","doc":"* `text` (`:string`) - text of the label.","ref":"Backpex.HTML.Layout.html#input_label/1-attributes"},{"type":"function","title":"Backpex.HTML.Layout.main_container/1","doc":"Container to wrap main elements and add margin.","ref":"Backpex.HTML.Layout.html#main_container/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.main_container/1","doc":"* `class` (`:string`) - additional class that will be added to the component. Defaults to `\"\"`.","ref":"Backpex.HTML.Layout.html#main_container/1-attributes"},{"type":"function","title":"Slots - Backpex.HTML.Layout.main_container/1","doc":"* `inner_block`","ref":"Backpex.HTML.Layout.html#main_container/1-slots"},{"type":"function","title":"Backpex.HTML.Layout.main_title/1","doc":"Renders a title.","ref":"Backpex.HTML.Layout.html#main_title/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.main_title/1","doc":"* `class` (`:string`) - additional class that will be added to the component. Defaults to `\"\"`.","ref":"Backpex.HTML.Layout.html#main_title/1-attributes"},{"type":"function","title":"Slots - Backpex.HTML.Layout.main_title/1","doc":"* `inner_block`","ref":"Backpex.HTML.Layout.html#main_title/1-slots"},{"type":"function","title":"Backpex.HTML.Layout.modal/1","doc":"Renders a modal.","ref":"Backpex.HTML.Layout.html#modal/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.modal/1","doc":"* `title` (`:string`) - modal title. Defaults to `nil`.\n* `target` (`:string`) - live component for the close event to go to. Defaults to `nil`.\n* `close_event_name` (`:string`) - close event name. Defaults to `\"close-modal\"`.\n* `max_width` (`:string`) - modal max width. Defaults to `\"md\"`.\n* `open` (`:boolean`) - modal open. Defaults to `true`.\n* Global attributes are accepted.","ref":"Backpex.HTML.Layout.html#modal/1-attributes"},{"type":"function","title":"Slots - Backpex.HTML.Layout.modal/1","doc":"* `inner_block`","ref":"Backpex.HTML.Layout.html#modal/1-slots"},{"type":"function","title":"Backpex.HTML.Layout.sidebar_item/1","doc":"Renders a sidebar item. It uses `Phoenix.Component.link/1` component, so you can can use link and href navigation.","ref":"Backpex.HTML.Layout.html#sidebar_item/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.sidebar_item/1","doc":"* `class` (`:string`) - additional class that will be added to the component. Defaults to `\"\"`.\n* `current_url` (`:string`) - the current url.\n* `navigate` (`:string`)\n* `patch` (`:string`)\n* `href` (`:any`)","ref":"Backpex.HTML.Layout.html#sidebar_item/1-attributes"},{"type":"function","title":"Slots - Backpex.HTML.Layout.sidebar_item/1","doc":"* `inner_block`","ref":"Backpex.HTML.Layout.html#sidebar_item/1-slots"},{"type":"function","title":"Backpex.HTML.Layout.sidebar_section/1","doc":"Renders a sidebar section.","ref":"Backpex.HTML.Layout.html#sidebar_section/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.sidebar_section/1","doc":"* `class` (`:string`) - additional class that will be added to the component. Defaults to `\"\"`.\n* `id` (`:string`) - The id for this section. It will be used to save and load the opening state of this section from local storage. Defaults to `\"section\"`.","ref":"Backpex.HTML.Layout.html#sidebar_section/1-attributes"},{"type":"function","title":"Slots - Backpex.HTML.Layout.sidebar_section/1","doc":"* `inner_block`\n* `label` (required) - label to be displayed on the section.","ref":"Backpex.HTML.Layout.html#sidebar_section/1-slots"},{"type":"function","title":"Backpex.HTML.Layout.theme_selector/1","doc":"Renders a theme selector.","ref":"Backpex.HTML.Layout.html#theme_selector/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.theme_selector/1","doc":"* `socket` (`:any`) (required)\n* `themes` (`:list`) - A list of tuples with {theme_label, theme_name} format.Examples include `[{\"Light\", \"light\"}, {\"Dark\", \"dark\"}]`.","ref":"Backpex.HTML.Layout.html#theme_selector/1-attributes"},{"type":"function","title":"Backpex.HTML.Layout.topbar/1","doc":"Renders a topbar.","ref":"Backpex.HTML.Layout.html#topbar/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.topbar/1","doc":"* `class` (`:string`) - additional class to be added to the component. Defaults to `\"\"`.","ref":"Backpex.HTML.Layout.html#topbar/1-attributes"},{"type":"function","title":"Slots - Backpex.HTML.Layout.topbar/1","doc":"* `inner_block`","ref":"Backpex.HTML.Layout.html#topbar/1-slots"},{"type":"function","title":"Backpex.HTML.Layout.topbar_branding/1","doc":"Renders the topbar branding.","ref":"Backpex.HTML.Layout.html#topbar_branding/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.topbar_branding/1","doc":"* `class` (`:string`) - additional class that will be added to the component. Defaults to `\"\"`.\n* `title` (`:string`) - title that will be displayed next to the logo. Defaults to `\"Backpex\"`.\n* `hide_title` (`:boolean`) - if the title should be hidden. Defaults to `false`.","ref":"Backpex.HTML.Layout.html#topbar_branding/1-attributes"},{"type":"function","title":"Slots - Backpex.HTML.Layout.topbar_branding/1","doc":"* `logo` - the logo of the branding.","ref":"Backpex.HTML.Layout.html#topbar_branding/1-slots"},{"type":"function","title":"Backpex.HTML.Layout.topbar_dropdown/1","doc":"Renders a topbar dropdown.","ref":"Backpex.HTML.Layout.html#topbar_dropdown/1"},{"type":"function","title":"Attributes - Backpex.HTML.Layout.topbar_dropdown/1","doc":"* `class` (`:string`) - additional class that will be added to the component. Defaults to `\"\"`.","ref":"Backpex.HTML.Layout.html#topbar_dropdown/1-attributes"},{"type":"function","title":"Slots - Backpex.HTML.Layout.topbar_dropdown/1","doc":"* `label` (required) - label of the dropdown.","ref":"Backpex.HTML.Layout.html#topbar_dropdown/1-slots"},{"type":"function","title":"Backpex.HTML.Layout.visible_fields_by_panel/3","doc":"Filters fields by certain panel.","ref":"Backpex.HTML.Layout.html#visible_fields_by_panel/3"},{"type":"function","title":"Examples - Backpex.HTML.Layout.visible_fields_by_panel/3","doc":"iex> Backpex.HTML.Layout.visible_fields_by_panel([field1: %{panel: :default}, field2: %{panel: :panel}], :default, nil)\n    [field1: %{panel: :default}]\n\n    iex> Backpex.HTML.Layout.visible_fields_by_panel([field1: %{panel: :default, visible: fn _assigns -> false end}, field2: %{panel: :panel}], :default, nil)\n    []\n\n    iex> Backpex.HTML.Layout.visible_fields_by_panel([field1: %{panel: :default}], :panel, nil)\n    []","ref":"Backpex.HTML.Layout.html#visible_fields_by_panel/3-examples"},{"type":"module","title":"Backpex.HTML.Resource","doc":"Contains all Backpex resource components.","ref":"Backpex.HTML.Resource.html"},{"type":"function","title":"Backpex.HTML.Resource.edit_panel/1","doc":"Renders an edit panel.","ref":"Backpex.HTML.Resource.html#edit_panel/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.edit_panel/1","doc":"* `form` (`:any`)\n* `class` (`:string`) - extra class to be added. Defaults to `\"\"`.\n* `panel_fields` (`:list`) (required) - list of fields to be rendered in the panel.\n* `label` (`:any`) - optional label for the panel. Defaults to `nil`.","ref":"Backpex.HTML.Resource.html#edit_panel/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.empty_state/1","doc":"Renders an info block to indicate that no items are found.","ref":"Backpex.HTML.Resource.html#empty_state/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.empty_state/1","doc":"* `socket` (`:any`) (required)\n* `live_resource` (`:atom`) (required) - live resource module.\n* `params` (`:map`) (required) - query params.\n* `singular_name` (`:string`) (required) - singular name of the resource.","ref":"Backpex.HTML.Resource.html#empty_state/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.form_component/1","doc":"","ref":"Backpex.HTML.Resource.html#form_component/1"},{"type":"function","title":"Backpex.HTML.Resource.has_modal?/1","doc":"Checks the given module if it has a `confirm/1` function exported or a list with fields.","ref":"Backpex.HTML.Resource.html#has_modal?/1"},{"type":"function","title":"Backpex.HTML.Resource.index_filter/1","doc":"Renders the index filters if the `filter/0` callback is defined in the resource.","ref":"Backpex.HTML.Resource.html#index_filter/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.index_filter/1","doc":"* `live_resource` (`:any`) (required) - module of the live resource.\n* `filter_options` (`:map`) (required) - filter options.\n* `filters` (`:list`) (required) - list of active filters.","ref":"Backpex.HTML.Resource.html#index_filter/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.index_search_form/1","doc":"Renders form with a search field. Emits the `simple-search-input` event on change.","ref":"Backpex.HTML.Resource.html#index_search_form/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.index_search_form/1","doc":"* `searchable_fields` (`:list`) - The fields that can be searched. Here only used to hide the component when empty. Defaults to `[]`.\n* `full_text_search` (`:string`) - full text search column name. Defaults to `nil`.\n* `value` (`:string`) (required) - value binding for the search input.\n* `placeholder` (`:string`) (required) - placeholder for the search input.","ref":"Backpex.HTML.Resource.html#index_search_form/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.order_link/1","doc":"Renders a link to change the order direction for a given column.","ref":"Backpex.HTML.Resource.html#order_link/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.order_link/1","doc":"* `socket` (`:map`) (required)\n* `live_resource` (`:any`) (required) - module of the live resource.\n* `params` (`:string`) (required) - query parameters.\n* `query_options` (`:map`) (required) - query options.\n* `label` (`:string`) (required) - label to be displayed on the link.\n* `name` (`:atom`) (required) - name of the column the link should change order for.","ref":"Backpex.HTML.Resource.html#order_link/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.pagination/1","doc":"Renders pagination buttons. You are required to provide a `:page` pattern in the URL. It will be replaced\nwith the corresponding page number.","ref":"Backpex.HTML.Resource.html#pagination/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.pagination/1","doc":"* `current_page` (`:integer`) (required) - current page number.\n* `total_pages` (`:integer`) (required) - number of total pages.\n* `path` (`:string`) (required) - path to be used for page links.","ref":"Backpex.HTML.Resource.html#pagination/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.pagination_info/1","doc":"Renders pagination info about the current page.","ref":"Backpex.HTML.Resource.html#pagination_info/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.pagination_info/1","doc":"* `total` (`:integer`) (required) - total number of items.\n* `query_options` (`:map`) (required) - query options.","ref":"Backpex.HTML.Resource.html#pagination_info/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.pagination_items/2","doc":"Creates a list of pagination items based on the current page and the total number of pages. A maximum of five pages will be displayed.","ref":"Backpex.HTML.Resource.html#pagination_items/2"},{"type":"function","title":"Example - Backpex.HTML.Resource.pagination_items/2","doc":"iex> Backpex.HTML.Resource.pagination_items(1, 1)\n    [%{type: :number, number: 1}]\n\n    iex> Backpex.HTML.Resource.pagination_items(1, 2)\n    [%{type: :number, number: 1}, %{type: :number, number: 2}, %{type: :next, number: nil}]\n\n    iex> Backpex.HTML.Resource.pagination_items(2, 2)\n    [%{type: :prev, number: nil}, %{type: :number, number: 1}, %{type: :number, number: 2}]\n\n    iex> Backpex.HTML.Resource.pagination_items(2, 8)\n    [%{type: :prev, number: nil}, %{type: :number, number: 1}, %{type: :number, number: 2}, %{type: :number, number: 3}, %{type: :number, number: 4}, %{type: :placeholder, number: nil}, %{type: :number, number: 8}, %{type: :next, number: nil}]\n\n    iex> Backpex.HTML.Resource.pagination_items(5, 10)\n    [%{type: :prev, number: nil}, %{type: :number, number: 1}, %{type: :placeholder, number: nil}, %{type: :number, number: 4}, %{type: :number, number: 5}, %{type: :number, number: 6}, %{type: :placeholder, number: nil}, %{type: :number, number: 10}, %{type: :next, number: nil}]\n\n    iex> Backpex.HTML.Resource.pagination_items(9, 10)\n    [%{type: :prev, number: nil}, %{type: :number, number: 1}, %{type: :placeholder, number: nil}, %{type: :number, number: 7}, %{type: :number, number: 8}, %{type: :number, number: 9}, %{type: :number, number: 10}, %{type: :next, number: nil}]","ref":"Backpex.HTML.Resource.html#pagination_items/2-example"},{"type":"function","title":"Backpex.HTML.Resource.resource_buttons/1","doc":"Renders a button group with create and resource action buttons.","ref":"Backpex.HTML.Resource.html#resource_buttons/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.resource_buttons/1","doc":"* `socket` (`:any`) (required)\n* `live_resource` (`:any`) (required) - module of the live resource.\n* `params` (`:string`) (required) - query parameters.\n* `query_options` (`:map`) - query options. Defaults to `%{}`.\n* `resource_actions` (`:list`) - list of all resource actions provided by the resource configuration. Defaults to `[]`.\n* `singular_name` (`:string`) (required) - singular name of the resource.","ref":"Backpex.HTML.Resource.html#resource_buttons/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.resource_field/1","doc":"Renders the field of the given resource.","ref":"Backpex.HTML.Resource.html#resource_field/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.resource_field/1","doc":"* `name` (`:string`) (required) - name / key of the item field.\n* `item` (`:map`) (required) - the item which provides the value to be rendered.\n* `fields` (`:list`) (required) - list of all fields provided by the resource configuration.","ref":"Backpex.HTML.Resource.html#resource_field/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.resource_filters/1","doc":"Renders the input fields for filters and search.","ref":"Backpex.HTML.Resource.html#resource_filters/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.resource_filters/1","doc":"* `live_resource` (`:any`) (required) - module of the live resource.\n* `searchable_fields` (`:list`) - The fields that can be searched. Here only used to hide the component when empty. Defaults to `[]`.\n* `full_text_search` (`:string`) - full text search column name. Defaults to `nil`.\n* `query_options` (`:map`) - query options. Defaults to `%{}`.\n* `search_placeholder` (`:string`) (required) - placeholder for the search input.","ref":"Backpex.HTML.Resource.html#resource_filters/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.resource_form/1","doc":"","ref":"Backpex.HTML.Resource.html#resource_form/1"},{"type":"function","title":"Backpex.HTML.Resource.resource_form_field/1","doc":"Renders a resource form field.","ref":"Backpex.HTML.Resource.html#resource_form_field/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.resource_form_field/1","doc":"* `name` (`:string`) (required) - name / key of the item field.\n* `form` (`:map`) (required) - form that will be used by the form field.\n* `repo` (`:any`) - ecto repo.\n* `uploads` (`:map`) - map that contains upload information. Defaults to `%{}`.\n* `fields` (`:list`) (required) - list of all fields provided by the resource configuration.","ref":"Backpex.HTML.Resource.html#resource_form_field/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.resource_form_main/1","doc":"","ref":"Backpex.HTML.Resource.html#resource_form_main/1"},{"type":"function","title":"Backpex.HTML.Resource.resource_index/1","doc":"","ref":"Backpex.HTML.Resource.html#resource_index/1"},{"type":"function","title":"Backpex.HTML.Resource.resource_index_main/1","doc":"Renders the main resource index content.","ref":"Backpex.HTML.Resource.html#resource_index_main/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.resource_index_main/1","doc":"* `socket` (`:any`) (required)\n* `live_resource` (`:any`) (required) - module of the live resource.\n* `params` (`:string`) (required) - query parameters.\n* `query_options` (`:map`) - query options. Defaults to `%{}`.\n* `total_pages` (`:integer`) - amount of total pages. Defaults to `1`.\n* `resource_actions` (`:list`) - list of all resource actions provided by the resource configuration. Defaults to `[]`.\n* `singular_name` (`:string`) (required) - singular name of the resource.\n* `orderable_fields` (`:list`) - list of orderable fields. Defaults to `[]`.\n* `items` (`:list`) - items that will be displayed in the table. Defaults to `[]`.\n* `fields` (`:list`) - list of fields to be displayed in the table on index view. Defaults to `[]`.","ref":"Backpex.HTML.Resource.html#resource_index_main/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.resource_index_table/1","doc":"Renders a resource table.","ref":"Backpex.HTML.Resource.html#resource_index_table/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.resource_index_table/1","doc":"* `socket` (`:any`) (required)\n* `live_resource` (`:any`) (required) - module of the live resource.\n* `params` (`:string`) (required) - query parameters.\n* `query_options` (`:map`) - query options. Defaults to `%{}`.\n* `fields` (`:list`) (required) - list of fields to be displayed in the table on index view.\n* `orderable_fields` (`:list`) - list of orderable fields. Defaults to `[]`.\n* `searchable_fields` (`:list`) - list of searchable fields. Defaults to `[]`.\n* `items` (`:list`) - items that will be displayed in the table. Defaults to `[]`.\n* `active_fields` (`:list`) (required) - list of active fields.\n* `selected_items` (`:list`) (required) - list of selected items.","ref":"Backpex.HTML.Resource.html#resource_index_table/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.resource_metrics/1","doc":"Renders the metrics area for the current resource.","ref":"Backpex.HTML.Resource.html#resource_metrics/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.resource_metrics/1","doc":"* `metrics` (`:list`) - list of metrics to be displayed. Defaults to `[]`.","ref":"Backpex.HTML.Resource.html#resource_metrics/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.resource_show/1","doc":"","ref":"Backpex.HTML.Resource.html#resource_show/1"},{"type":"function","title":"Backpex.HTML.Resource.resource_show_main/1","doc":"Renders a show card.","ref":"Backpex.HTML.Resource.html#resource_show_main/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.resource_show_main/1","doc":"* `socket` (`:any`) (required)\n* `live_resource` (`:any`) (required) - module of the live resource.\n* `params` (`:string`) (required) - query parameters.\n* `item` (`:map`) (required) - item that will be rendered on the card.\n* `fields` (`:list`) (required) - list of fields to be displayed on the card.","ref":"Backpex.HTML.Resource.html#resource_show_main/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.select_per_page/1","doc":"Renders a select per page button.","ref":"Backpex.HTML.Resource.html#select_per_page/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.select_per_page/1","doc":"* `options` (`:list`) (required) - A list of per page options.\n* `query_options` (`:map`) - The query options. Defaults to `%{}`.\n* `class` (`:string`) - Extra class to be added to the select. Defaults to `\"\"`.","ref":"Backpex.HTML.Resource.html#select_per_page/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.show_panel/1","doc":"Renders a show panel.","ref":"Backpex.HTML.Resource.html#show_panel/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.show_panel/1","doc":"* `panel_fields` (`:list`) (required) - list of fields to be rendered in the panel.\n* `class` (`:string`) - extra class to be added. Defaults to `\"\"`.\n* `label` (`:any`) - optional label for the panel. Defaults to `nil`.","ref":"Backpex.HTML.Resource.html#show_panel/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.toggle_columns/1","doc":"Renders the toggle columns dropdown.","ref":"Backpex.HTML.Resource.html#toggle_columns/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.toggle_columns/1","doc":"* `socket` (`:any`) (required)\n* `active_fields` (`:list`) (required) - list of active fields.\n* `live_resource` (`:atom`) (required) - the live resource.\n* `current_url` (`:string`) (required) - the current url.\n* `class` (`:string`) - additional class to be added to the component. Defaults to `\"\"`.\n* `x_style` (`:string`) - alpine-bound inline styles for the root div. Defaults to `\"\"`.","ref":"Backpex.HTML.Resource.html#toggle_columns/1-attributes"},{"type":"function","title":"Backpex.HTML.Resource.toggle_columns_inputs/1","doc":"Renders the toggle columns inputs.","ref":"Backpex.HTML.Resource.html#toggle_columns_inputs/1"},{"type":"function","title":"Attributes - Backpex.HTML.Resource.toggle_columns_inputs/1","doc":"* `form` (`:any`) (required) - the form.\n* `active_fields` (`:list`) (required) - list of active fields to be displayed.","ref":"Backpex.HTML.Resource.html#toggle_columns_inputs/1-attributes"},{"type":"behaviour","title":"Backpex.Field","doc":"Behaviour implemented by all fields.\n\nA field defines how a column is rendered on index, show and edit views. In the resource configuration file you can configure a list of fields. You may create your own field by implementing this behaviour. A field has to be a [LiveComponent](https://hexdocs.pm/phoenix_live_view/Phoenix.LiveComponent.html).","ref":"Backpex.Field.html"},{"type":"behaviour","title":"Example - Backpex.Field","doc":"def fields do\n      [\n        rating: %{\n          module: Backpex.Fields.Text,\n          label: \"Rating\"\n        }\n      ]\n    end","ref":"Backpex.Field.html#module-example"},{"type":"macro","title":"Backpex.Field.__using__/1","doc":"Defines `Backpex.Field` behaviour and provides default implementations.","ref":"Backpex.Field.html#__using__/1"},{"type":"function","title":"Backpex.Field.align_label/3","doc":"Gets alignment option for label.","ref":"Backpex.Field.html#align_label/3"},{"type":"callback","title":"Backpex.Field.assign_uploads/2","doc":"This function will be called in the `FormComponent` and may be used to assign uploads.","ref":"Backpex.Field.html#c:assign_uploads/2"},{"type":"callback","title":"Backpex.Field.association?/1","doc":"Determines whether the field is an association or not.","ref":"Backpex.Field.html#c:association?/1"},{"type":"callback","title":"Backpex.Field.before_changeset/6","doc":"This function is called before the changeset function is called. This allows fields to modify the changeset.\nThe `Backpex.Fields.HasMany` uses this callback to put the linked associations into the changeset.","ref":"Backpex.Field.html#c:before_changeset/6"},{"type":"function","title":"Backpex.Field.changeset_types/1","doc":"Returns a map of types from a list of fields used for the Ecto changeset.","ref":"Backpex.Field.html#changeset_types/1"},{"type":"function","title":"Backpex.Field.debounce/2","doc":"Defines debounce timeout value.","ref":"Backpex.Field.html#debounce/2"},{"type":"callback","title":"Backpex.Field.display_field/1","doc":"The field to be displayed on index views. In most cases this is the name / key configured in the corresponding field definition.\nIn fields with associations this value often differs from the name / key. The function will receive the field definition.","ref":"Backpex.Field.html#c:display_field/1"},{"type":"function","title":"Backpex.Field.handle_index_editable/3","doc":"Handles index editable.","ref":"Backpex.Field.html#handle_index_editable/3"},{"type":"function","title":"Backpex.Field.index_editable_enabled?/3","doc":"Checks whether index editable is enabled or not.","ref":"Backpex.Field.html#index_editable_enabled?/3"},{"type":"function","title":"Backpex.Field.placeholder/2","doc":"Defines placeholder value.","ref":"Backpex.Field.html#placeholder/2"},{"type":"function","title":"Backpex.Field.readonly?/2","doc":"Determines whether the field should be rendered as readonly version.","ref":"Backpex.Field.html#readonly?/2"},{"type":"callback","title":"Backpex.Field.render_form/1","doc":"Will be used on edit views to render a form for the value of the provided item. This has to be a heex template.","ref":"Backpex.Field.html#c:render_form/1"},{"type":"callback","title":"Backpex.Field.render_form_readonly/1","doc":"Used to render the readonly version of the field.","ref":"Backpex.Field.html#c:render_form_readonly/1"},{"type":"callback","title":"Backpex.Field.render_index_form/1","doc":"Used to render form on index to support index editable.","ref":"Backpex.Field.html#c:render_index_form/1"},{"type":"callback","title":"Backpex.Field.render_value/1","doc":"Will be used on index and show views to render a value from the provided item. This has to be a heex template.","ref":"Backpex.Field.html#c:render_value/1"},{"type":"callback","title":"Backpex.Field.schema/2","doc":"The schema to be used in queries. In most cases this is the schema defined in the resource configuration.\nIn fields with associations this is the schema of the corresponding relation. The function will receive the field definition and the schema defined in the resource configuration.","ref":"Backpex.Field.html#c:schema/2"},{"type":"callback","title":"Backpex.Field.search_condition/3","doc":"Defines the search condition. Defaults to an ilike condition with text comparison. The function has to return a query wrapped into a `Ecto.Query.dynamic/2` which is then passed into a `Ecto.Query.where/3`.","ref":"Backpex.Field.html#c:search_condition/3"},{"type":"callback","title":"Example - Backpex.Field.search_condition/3","doc":"Imagine the underlying database type of the field is an integer. Before text comparison in an ilike condition you have to cast the integer to text.\n\nThe function could return the following query to make the field searchable.\n\n    dynamic(\n      [{^schema_name, schema_name}],\n      ilike(fragment(\"CAST(? AS TEXT)\", schema_name |> field(^field_name)), ^search_string)\n    )","ref":"Backpex.Field.html#c:search_condition/3-example"},{"type":"function","title":"Backpex.Field.throttle/2","doc":"Defines throttle timeout value.","ref":"Backpex.Field.html#throttle/2"},{"type":"module","title":"Backpex.Fields.BelongsTo","doc":"A field for handling a `belongs_to` relation.","ref":"Backpex.Fields.BelongsTo.html"},{"type":"module","title":"Options - Backpex.Fields.BelongsTo","doc":"* `:display_field` - The field of the relation to be used for searching, ordering and displaying values.\n  * `:display_field_form` - Optional field to be used to display form values.\n  * `:live_resource` - The live resource of the association. Used to generate links navigating to the association.\n  * `:options_query` - Manipulates the list of available options in the select.\n    Defaults to `fn (query, _field) -> query end` which returns all entries.\n  * `:prompt` - The text to be displayed when no option is selected or function that receives the assigns.","ref":"Backpex.Fields.BelongsTo.html#module-options"},{"type":"module","title":"Example - Backpex.Fields.BelongsTo","doc":"@impl Backpex.LiveResource\n    def fields do\n    [\n      user: %{\n        module: Backpex.Fields.BelongsTo,\n        label: \"Username\",\n        display_field: :username,\n        options_query: &where(&1, [user], user.role == :admin),\n        live_resource: DemoWeb.UserLive\n      }\n    ]\n    end","ref":"Backpex.Fields.BelongsTo.html#module-example"},{"type":"module","title":"Backpex.Fields.Boolean","doc":"A field for handling a boolean value.","ref":"Backpex.Fields.Boolean.html"},{"type":"module","title":"Options - Backpex.Fields.Boolean","doc":"* `:debounce` - Optional integer timeout value (in milliseconds), \"blur\" or function that receives the assigns.\n* `:throttle` - Optional integer timeout value (in milliseconds) or function that receives the assigns.","ref":"Backpex.Fields.Boolean.html#module-options"},{"type":"module","title":"Backpex.Fields.Currency","doc":"A field for handling a currency value.","ref":"Backpex.Fields.Currency.html"},{"type":"module","title":"Options - Backpex.Fields.Currency","doc":"* `:debounce` - Optional integer timeout value (in milliseconds), \"blur\" or function that receives the assigns.\n* `:throttle` - Optional integer timeout value (in milliseconds) or function that receives the assigns.","ref":"Backpex.Fields.Currency.html#module-options"},{"type":"module","title":"Schema - Backpex.Fields.Currency","doc":"`Backpex.Ecto.Amount.Type` provides a type for Ecto to store a amount. The underlying data type should be an integer.\nFor a full list of configuration options see: https://hexdocs.pm/money/Money.html#module-configuration\n\n    schema \"article\" do\n      field :price, Backpex.Ecto.Amount.Type\n      ...\n    end\n\n    schema \"article\" do\n      field :price, Backpex.Ecto.Amount.Type, currency: :EUR, opts: [separator: \".\", delimiter: \",\"]\n      ...\n    end","ref":"Backpex.Fields.Currency.html#module-schema"},{"type":"module","title":"Example - Backpex.Fields.Currency","doc":"@impl Backpex.LiveResource\n    def fields do\n      [\n        price: %{\n          module: Backpex.Fields.Currency,\n          label: \"Price\"\n        }\n      ]\n    end","ref":"Backpex.Fields.Currency.html#module-example"},{"type":"module","title":"Backpex.Fields.Date","doc":"A field for handling a date value.","ref":"Backpex.Fields.Date.html"},{"type":"module","title":"Options - Backpex.Fields.Date","doc":"* `:format` - Defines the date format printed on the index view.\n    Defaults to `%Y-%m-%d`.\n  * `:debounce` - Optional integer timeout value (in milliseconds), \"blur\" or function that receives the assigns.\n  * `:throttle` - Optional integer timeout value (in milliseconds) or function that receives the assigns.","ref":"Backpex.Fields.Date.html#module-options"},{"type":"module","title":"Example - Backpex.Fields.Date","doc":"@impl Backpex.LiveResource\n    def fields do\n      [\n        created_at: %{\n          module: Backpex.Fields.Date,\n          label: \"Created At\",\n          format: \"%d.%m.%Y\"\n        }\n      ]\n    end","ref":"Backpex.Fields.Date.html#module-example"},{"type":"module","title":"Backpex.Fields.DateTime","doc":"A field for handling a date time value.","ref":"Backpex.Fields.DateTime.html"},{"type":"module","title":"Options - Backpex.Fields.DateTime","doc":"* `:format` - Format string which will be used to format the date time value.\n    Defaults to `%Y-%m-%d %I:%M %p`\n  * `:debounce` - Optional integer timeout value (in milliseconds), \"blur\" or function that receives the assigns.\n  * `:throttle` - Optional integer timeout value (in milliseconds) or function that receives the assigns.","ref":"Backpex.Fields.DateTime.html#module-options"},{"type":"module","title":"Example - Backpex.Fields.DateTime","doc":"@impl Backpex.LiveResource\n    def fields do\n      [\n        created_at: %{\n          module: Backpex.Fields.DateTime,\n          label: \"Created At\",\n          format: \"%Y.%m.%d %I:%M %p\" # optional\n        }\n      ]\n    end","ref":"Backpex.Fields.DateTime.html#module-example"},{"type":"module","title":"Backpex.Fields.HasMany","doc":"A field for handling a `has_many` or `many_to_many` relation.\n\nThis field can not be orderable or searchable.","ref":"Backpex.Fields.HasMany.html"},{"type":"module","title":"Options - Backpex.Fields.HasMany","doc":"* `:display_field` - The field of the relation to be used for searching, ordering and displaying values.\n  * `:display_field_form` - Optional field to be used to display form values.\n  * `:live_resource` - The live resource of the association.\n  * `:link_assocs` - Whether to automatically generate links to the association items.\n    Defaults to true.\n  * `:options_query` - Manipulates the list of available options in the multi select.\n    Defaults to `fn (query, _field) -> query end` which returns all entries.\n  * `:prompt` - The text to be displayed when no options are selected or function that receives the assigns.\n    Defaults to \"Select options...\".\n  * `:not_found_text` - The text to be displayed when no options are found.\n    Defaults to \"No options found\".\n  * `:query_limit` - Optional limit passed to the query to fetch new items. Set to `nil` to have no limit.\n    Defaults to 10.","ref":"Backpex.Fields.HasMany.html#module-options"},{"type":"module","title":"Example - Backpex.Fields.HasMany","doc":"@impl Backpex.LiveResource\n    def fields do\n    [\n      posts: %{\n        module: Backpex.Fields.HasMany,\n        label: \"Posts\",\n        display_field: :title,\n        options_query: &where(&1, [user], user.role == :admin),\n        live_resource: DemoWeb.PostLive\n      }\n    ]\n    end","ref":"Backpex.Fields.HasMany.html#module-example"},{"type":"function","title":"Backpex.Fields.HasMany.assign_selected/1","doc":"","ref":"Backpex.Fields.HasMany.html#assign_selected/1"},{"type":"module","title":"Backpex.Fields.HasManyThrough","doc":"A field for handling a `has_many` (`through`) relation.\n\nThis field is not orderable or searchable.\n\n> #### Warning {: .warning}\n>\n> This field is in beta state. Use at your own risk.","ref":"Backpex.Fields.HasManyThrough.html"},{"type":"module","title":"Options - Backpex.Fields.HasManyThrough","doc":"* `:display_field` - The field of the relation to be used for displaying options in the select.\n  * `:live_resource` - The corresponding live resource of the association. Used to display the title of the modal and generate defaults for `:child_fields` fields.\n  * `:sort_by` - A list of columns by which the child element output will be sorted. The sorting takes place in ascending order.\n  * `:child_fields` - WIP\n  * `:pivot_fields` - List to map additional data of the pivot table to Backpex fields.\n  * `:options_query` - Manipulates the list of available options in the select. Can be used to select additional data for the `display_field` option or to limit the available entries.\n    Defaults to `fn (query, _field) -> query end` which returns all entries.","ref":"Backpex.Fields.HasManyThrough.html#module-options"},{"type":"module","title":"Example - Backpex.Fields.HasManyThrough","doc":"@impl Backpex.LiveResource\n    def fields do\n    [\n      addresses: %{\n        module: Backpex.Fields.HasManyThrough,\n        label: \"Addresses\",\n        display_field: :street,\n        live_resource: DemoWeb.AddressLive,\n        sort_by: [:zip, :city],\n        pivot_fields: [\n          type: %{\n            module: Backpex.Fields.Select,\n            label: \"Address Type\",\n            options: [Shipping: \"shipping\", Billing: \"billing\"]\n          }\n        ]\n      }\n    ]\n    end\n\nThe field requires a [`Ecto.Schema.has_many/3`](https://hexdocs.pm/ecto/Ecto.Schema.html#has_many/3) relation with a mandatory `through` option in the main schema. Any extra column in the pivot table besides the relational id's must be mapped in the `pivot_fields` option or given a default value.","ref":"Backpex.Fields.HasManyThrough.html#module-example"},{"type":"module","title":"Backpex.Fields.InlineCRUD","doc":"A field to handle inline CRUD operations. It can be used with either an `embeds_many` or `has_many` (association) type column.","ref":"Backpex.Fields.InlineCRUD.html"},{"type":"module","title":"Options - Backpex.Fields.InlineCRUD","doc":"* `:type` - The type of the field. Either `:embed` or `:assoc`.\n* `:child_fields` - A list of input fields to be used. Currently only support `Backpex.Fields.Text` fields.\n\nYou can add additional classes to child field inputs by setting the class option in the list of `child_fields`.\nThe class can be a string or a function that takes the assigns and must return a string.\nIn addition, you can optionally specify the input type of child field inputs with the `input_type` option. We currently\nsupport `:text` and `:textarea`. The `input_type` defaults to `:text`.\n\n> #### Important {: .info}\n>\n> Everything is currently handled by plain text input.","ref":"Backpex.Fields.InlineCRUD.html#module-options"},{"type":"module","title":"EmbedsMany - Backpex.Fields.InlineCRUD","doc":"The field in the migration must be of type `:map`. You also need to use ecto's `cast_embed/2` in the changeset.","ref":"Backpex.Fields.InlineCRUD.html#module-embedsmany"},{"type":"module","title":"Example - Backpex.Fields.InlineCRUD","doc":"def changeset(your_schema, attrs) do\n      your_schema\n      ...\n      |> cast_embed(:your_field,\n        with: &your_field_changeset/2,\n        sort_param: :your_field_order,\n        drop_param: :your_field_delete\n      )\n      ...\n    end\n\n> #### Important {: .info}\n>\n> We use the Ecto `:sort_param` and `:drop_param` to keep track of order and dropped items. Therefore, you need to use these options as well in your changeset. The name has to be ` _order` and ` _delete`.","ref":"Backpex.Fields.InlineCRUD.html#module-example"},{"type":"module","title":"HasMany (Association) - Backpex.Fields.InlineCRUD","doc":"A HasMany relation does not require any special configuration. You can simply define a basic `Ecto.Schema.has_many/3` relation to be used with the Backpex.Fields.InlineCRUD field.\n\n> #### Important {: .info}\n>\n> You need to set `on_replace: :delete` to be able to delete items, and `on_delete: :delete_all` to be able to delete a resource with existing items. It is recommended that you also add `on_delete: :delete_all` to your migration.","ref":"Backpex.Fields.InlineCRUD.html#module-hasmany-association"},{"type":"module","title":"Example - Backpex.Fields.InlineCRUD","doc":"@impl Backpex.LiveResource\n    def fields do\n      [\n        embeds_many: %{\n          module: Backpex.Fields.InlineCRUD,\n          label: \"EmbedsMany\",\n          type: :embed,\n          except: [:index],\n          child_fields: [\n            field1: %{\n              module: Backpex.Fields.Text,\n              label: \"Label1\"\n            },\n            field2: %{\n              module: Backpex.Fields.Text,\n              label: \"Label2\"\n            }\n          ]\n        }\n      ]\n    end","ref":"Backpex.Fields.InlineCRUD.html#module-example"},{"type":"module","title":"Backpex.Fields.MultiSelect","doc":"A field for handling a multi select with predefined options.\n\nThis field can not be searchable.","ref":"Backpex.Fields.MultiSelect.html"},{"type":"module","title":"Options - Backpex.Fields.MultiSelect","doc":"* `:options` - Required (keyword) list of options to be used for the select.\n  * `:prompt` - The text to be displayed when no options are selected or function that receives the assigns.\n    Defaults to \"Select options...\".\n  * `:not_found_text` - The text to be displayed when no options are found.\n    Defaults to \"No options found\".","ref":"Backpex.Fields.MultiSelect.html#module-options"},{"type":"module","title":"Example - Backpex.Fields.MultiSelect","doc":"@impl Backpex.LiveResource\n    def fields do\n      [\n        users: %{\n          module: Backpex.Fields.MultiSelect,\n          label: \"Users\",\n          options: fn _assigns -> [{\"Alex\", \"user_id_alex\"}, {\"Bob\", \"user_id_bob\"}] end\n        },\n      ]","ref":"Backpex.Fields.MultiSelect.html#module-example"},{"type":"module","title":"Backpex.Fields.Number","doc":"A field for handling a number value.","ref":"Backpex.Fields.Number.html"},{"type":"module","title":"Options - Backpex.Fields.Number","doc":"* `:placeholder` - Optional placeholder value or function that receives the assigns.\n* `:debounce` - Optional integer timeout value (in milliseconds), \"blur\" or function that receives the assigns.\n* `:throttle` - Optional integer timeout value (in milliseconds) or function that receives the assigns.","ref":"Backpex.Fields.Number.html#module-options"},{"type":"module","title":"Backpex.Fields.Select","doc":"A field for handling a select value.","ref":"Backpex.Fields.Select.html"},{"type":"module","title":"Options - Backpex.Fields.Select","doc":"* `:options` - Required (keyword) list of options or function that receives the assigns.\n  * `:prompt` - The text to be displayed when no option is selected or function that receives the assigns.","ref":"Backpex.Fields.Select.html#module-options"},{"type":"module","title":"Example - Backpex.Fields.Select","doc":"@impl Backpex.LiveResource\n    def fields do\n      [\n        role: %{\n          module: Backpex.Fields.Select,\n          label: \"Role\",\n          options: [Admin: admin, User: user]\n        }\n      ]\n    end","ref":"Backpex.Fields.Select.html#module-example"},{"type":"module","title":"Backpex.Fields.Text","doc":"A field for handling a text value.","ref":"Backpex.Fields.Text.html"},{"type":"module","title":"Options - Backpex.Fields.Text","doc":"* `:placeholder` - Optional placeholder value or function that receives the assigns.\n* `:debounce` - Optional integer timeout value (in milliseconds), \"blur\" or function that receives the assigns.\n* `:throttle` - Optional integer timeout value (in milliseconds) or function that receives the assigns.","ref":"Backpex.Fields.Text.html#module-options"},{"type":"module","title":"Backpex.Fields.Textarea","doc":"A field for handling long text values.","ref":"Backpex.Fields.Textarea.html"},{"type":"module","title":"Options - Backpex.Fields.Textarea","doc":"* `:placeholder` - Optional placeholder value or function that receives the assigns.\n* `:debounce` - Optional integer timeout value (in milliseconds), \"blur\" or function that receives the assigns.\n* `:throttle` - Optional integer timeout value (in milliseconds) or function that receives the assigns.","ref":"Backpex.Fields.Textarea.html#module-options"},{"type":"module","title":"Backpex.Fields.URL","doc":"A field for handling an URL value.","ref":"Backpex.Fields.URL.html"},{"type":"module","title":"Options - Backpex.Fields.URL","doc":"* `:placeholder` - Optional placeholder value or function that receives the assigns.\n* `:debounce` - Optional integer timeout value (in milliseconds), \"blur\" or function that receives the assigns.\n* `:throttle` - Optional integer timeout value (in milliseconds) or function that receives the assigns.","ref":"Backpex.Fields.URL.html#module-options"},{"type":"module","title":"Backpex.Fields.Upload","doc":"A field for handling uploads.\n\n> #### Warning {: .warning}\n>\n> This field does **not** currently support `Phoenix.LiveView.UploadWriter` and direct / external uploads.","ref":"Backpex.Fields.Upload.html"},{"type":"module","title":"Options - Backpex.Fields.Upload","doc":"* `:upload_key` (atom) - Required identifier for the upload field (the name of the upload).\n  * `:accept` (list) - Required filetypes that will be accepted.\n  * `:max_entries` (integer) - Required number of max files that can be uploaded.\n  * `:max_file_size` (integer) - Optional maximum file size in bytes to be allowed to uploaded. Defaults 8 MB (`8_000_000`).\n  * `:list_existing_files` (function) - Required function that returns a list of all uploaded files based on an item.\n  * `:file_label` (function) - Optional function to get the label of a single file.\n  * `:consume_upload` (function) - Required function to consume file uploads.\n  * `:put_upload_change` (function) - Required function to add file paths to the params.\n  * `:remove_uploads` (function) - Required function that is being called after saving an item to be able to delete removed files\n\n\n> #### Info {: .info}\n>\n> The following examples copy uploads to a static folder in the application. In a production environment, you should consider uploading files to an appropriate object store.","ref":"Backpex.Fields.Upload.html#module-options"},{"type":"module","title":"Options in detail - Backpex.Fields.Upload","doc":"The `upload_key`, `accept`, `max_entries` and `max_file_size` options are forwarded to https://hexdocs.pm/phoenix_live_view/Phoenix.LiveView.html#allow_upload/3. See the documentation for more information.\n\n### `list_existing_files`\n\n**Parameters**\n* `:socket` - The socket.\n* `:item` (struct) - The item without its changes.\n\nThe function is being used to display existing uploads. The function receives the socket and the item and has to return a list of strings. Removed files during an edit of an item are automatically removed from the list. This option is required.\n\n**Example**\n\n    def list_existing_files(_socket, item), do: item.files\n\n### `file_label`\n\n**Parameters**\n* `:file` (string) - The file.\n\nThe function can be used to modify a file label based on a file. In the following example each file will have an \"_upload\" suffix. This option is optional.\n\n**Example**\n\n    def file_label(file), do: file <> \"_upload\"\n\n### `consume_upload`\n\n**Parameters**\n* `:socket` - The socket.\n* `:item` (struct) - The saved item (with its changes).\n* `:meta` - The upload meta.\n* `:entry` - The upload entry.\n\nThe function is used to consume uploads. It is called after the item has been saved and is used to copy the files to a specific destination. Backpex will use this function as a callback for `consume_uploaded_entries`. See https://hexdocs.pm/phoenix_live_view/uploads.html#consume-uploaded-entries for more details. This option is required.\n\n**Example**\n\n    defp consume_upload(_socket, _item, %{path: path} = _meta, entry) do\n      file_name = ...\n      file_url = ...\n      static_dir = ...\n      dest = Path.join([:code.priv_dir(:demo), \"static\", static_dir, file_name])\n\n      File.cp!(path, dest)\n\n      {:ok, file_url}\n    end\n\n### `put_upload_change`\n\n**Parameters**\n  * `:socket` - The socket.\n  * `:params` (map) - The current params that will be passed to the changeset function.\n  * `:item` (struct) - The item without its changes. On create will this will be an empty map.\n  * `uploaded_entries` (tuple) - The completed and in progress entries for the upload.\n  * `removed_entries` (list) - A list of removed uploads during edit.\n  * `action` (atom) - The action (`:validate` or `:insert`)\n\nThis function is used to modify the params based on certain parameters. It is important because it ensures that file paths are added to the item change and therefore persisted in the database. This option is required.\n\n**Example**\n\n    def put_upload_change(_socket, params, item, uploaded_entries, removed_entries, action) do\n      existing_files = item.files -- removed_entries\n\n      new_entries =\n        case action do\n          :validate ->\n            elem(uploaded_entries, 1)\n\n          :insert ->\n            elem(uploaded_entries, 0)\n        end\n\n      files = existing_files ++ Enum.map(new_entries, fn entry -> file_name(entry) end)\n\n      Map.put(params, \"images\", files)\n    end\n\n### `remove_uploads`\n\n**Parameters**\n* `:socket` - The socket.\n* `:item` (struct) - The item without its changes.\n* `removed_entries` (list) - A list of removed uploads during edit.\n\n**Example**\n\n    defp remove_uploads(_socket, _item, removed_entries) do\n      for file <- removed_entries do\n        file_path = ...\n        File.rm!(file_path)\n      end\n    end","ref":"Backpex.Fields.Upload.html#module-options-in-detail"},{"type":"module","title":"Full Single File Example - Backpex.Fields.Upload","doc":"In this example we are adding an avatar upload for a user. We implement it so that exactly one avatar must exist.\n\n    defmodule Demo.Repo.Migrations.AddAvatarToUsers do\n      use Ecto.Migration\n\n      def change do\n        alter table(:users) do\n          add(:avatar, :string, null: false, default: \"\")\n        end\n      end\n    end\n\n    defmodule Demo.User do\n      use Ecto.Schema\n\n      schema \"users\" do\n        field(:avatar, :string, default: \"\")\n        ...\n      end\n\n      def changeset(user, attrs, _metadata \\\\ []) do\n        user\n        |> cast(attrs, [:avatar])\n        |> validate_required([:avatar])\n        |> validate_change(:avatar, fn\n          :avatar, \"too_many_files\" ->\n            [avatar: \"has to be exactly one\"]\n\n          :avatar, \"\" ->\n            [avatar: \"can't be blank\"]\n\n          :avatar, _avatar ->\n            []\n        end)\n      end\n    end\n\n    defmodule DemoWeb.UserLive do\n      use Backpex.LiveResource,\n        ...\n\n      @impl Backpex.LiveResource\n      def fields do\n        [\n          avatar: %{\n            module: Backpex.Fields.Upload,\n            label: \"Avatar\",\n            upload_key: :avatar,\n            accept: ~w(.jpg .jpeg .png),\n            max_entries: 1,\n            max_file_size: 512_000,\n            put_upload_change: &put_upload_change/6,\n            consume_upload: &consume_upload/4,\n            remove_uploads: &remove_uploads/3,\n            list_existing_files: &list_existing_files/1,\n            render: fn\n              %{value: value} = assigns when value == \"\" or is_nil(value) ->\n                ~H\" <%= Backpex.HTML.pretty_value(@value) %> \"\n\n              assigns ->\n                ~H' '\n            end\n          },\n          ...\n        ]\n      end\n\n      defp list_existing_files(%{avatar: avatar} = _item) when avatar != \"\" and not is_nil(avatar), do: [avatar]\n      defp list_existing_files(_item), do: []\n\n      def put_upload_change(_socket, params, item, uploaded_entries, removed_entries, action) do\n        existing_files = list_existing_files(item) -- removed_entries\n\n        new_entries =\n          case action do\n            :validate ->\n              elem(uploaded_entries, 1)\n\n            :insert ->\n              elem(uploaded_entries, 0)\n          end\n\n        files = existing_files ++ Enum.map(new_entries, fn entry -> file_name(entry) end)\n\n        case files do\n          [file] ->\n            Map.put(params, \"avatar\", file)\n\n          [_file | _other_files] ->\n            Map.put(params, \"avatar\", \"too_many_files\")\n\n          [] ->\n            Map.put(params, \"avatar\", \"\")\n        end\n      end\n\n      defp consume_upload(_socket, _item, %{path: path} = _meta, entry) do\n        file_name = file_name(entry)\n        dest = Path.join([:code.priv_dir(:demo), \"static\", upload_dir(), file_name])\n\n        File.cp!(path, dest)\n\n        {:ok, file_url(file_name)}\n      end\n\n      defp remove_uploads(_socket, _item, removed_entries) do\n        for file <- removed_entries do\n          path = Path.join([:code.priv_dir(:demo), \"static\", upload_dir(), file])\n          File.rm!(path)\n        end\n      end\n\n      defp file_url(file_name) do\n        static_path = Path.join([upload_dir(), file_name])\n        Phoenix.VerifiedRoutes.static_url(DemoWeb.Endpoint, \"/\" <> static_path)\n      end\n\n      defp file_name(entry) do\n        [ext | _] = MIME.extensions(entry.client_type)\n        \"#{entry.uuid}.#{ext}\"\n      end\n\n      defp upload_dir, do: Path.join([\"uploads\", \"user\", \"avatar\"])\n    end","ref":"Backpex.Fields.Upload.html#module-full-single-file-example"},{"type":"module","title":"Full Multi File Example - Backpex.Fields.Upload","doc":"In this example, we are adding images to a product resource. We limit the images to a maximum of 2.\n\n    defmodule Demo.Repo.Migrations.AddImagesToProducts do\n      use Ecto.Migration\n\n      def change do\n        alter table(:products) do\n          add(:images, {:array, :string})\n        end\n      end\n    end\n\n    defmodule Demo.Product do\n      use Ecto.Schema\n\n      schema \"products\" do\n        field(:images, {:array, :string})\n        ...\n      end\n\n      def changeset(user, attrs, _metadata \\\\ []) do\n        user\n        |> cast(attrs, [:images])\n        |> validate_length(:images, max: 2)\n      end\n    end\n\n    defmodule DemoWeb.ProductLive do\n      use Backpex.LiveResource,\n        ...\n\n      @impl Backpex.LiveResource\n      def fields do\n        [\n          images: %{\n            module: Backpex.Fields.Upload,\n            label: \"Images\",\n            upload_key: :images,\n            accept: ~w(.jpg .jpeg .png),\n            max_entries: 2,\n            max_file_size: 512_000,\n            put_upload_change: &put_upload_change/6,\n            consume_upload: &consume_upload/4,\n            remove_uploads: &remove_uploads/3,\n            list_existing_files: &list_existing_files/1,\n            render: fn\n              %{value: value} = assigns when is_list(value) ->\n                ~H'''\n                 \n                   \n                 \n                '''\n\n              assigns ->\n                ~H' <%= Backpex.HTML.pretty_value(@value) %> '\n            end,\n            except: [:index, :resource_action],\n            align: :center\n          },\n          ...\n        ]\n      end\n\n      defp list_existing_files(%{images: images} = _item) when is_list(images), do: images\n      defp list_existing_files(_item), do: []\n\n      defp put_upload_change(_socket, params, item, uploaded_entries, removed_entries, action) do\n        existing_files = list_existing_files(item) -- removed_entries\n\n        new_entries =\n          case action do\n            :validate ->\n              elem(uploaded_entries, 1)\n\n            :insert ->\n              elem(uploaded_entries, 0)\n          end\n\n        files = existing_files ++ Enum.map(new_entries, fn entry -> file_name(entry) end)\n\n        Map.put(params, \"images\", files)\n      end\n\n      defp consume_upload(_socket, _item, %{path: path} = _meta, entry) do\n        file_name = file_name(entry)\n        dest = Path.join([:code.priv_dir(:demo), \"static\", upload_dir(), file_name])\n\n        File.cp!(path, dest)\n\n        {:ok, file_url(file_name)}\n      end\n\n      defp remove_uploads(_socket, _item, removed_entries) do\n        for file <- removed_entries do\n          path = Path.join([:code.priv_dir(:demo), \"static\", upload_dir(), file])\n          File.rm!(path)\n        end\n      end\n\n      defp file_url(file_name) do\n        static_path = Path.join([upload_dir(), file_name])\n        Phoenix.VerifiedRoutes.static_url(DemoWeb.Endpoint, \"/\" <> static_path)\n      end\n\n      defp file_name(entry) do\n        [ext | _] = MIME.extensions(entry.client_type)\n        \"#{entry.uuid}.#{ext}\"\n      end\n\n      defp upload_dir, do: Path.join([\"uploads\", \"product\", \"images\"])\n    end","ref":"Backpex.Fields.Upload.html#module-full-multi-file-example"},{"type":"function","title":"Backpex.Fields.Upload.existing_file_paths/3","doc":"Returns a list of existing files mapped to a label.","ref":"Backpex.Fields.Upload.html#existing_file_paths/3"},{"type":"function","title":"Backpex.Fields.Upload.label_from_file/2","doc":"Calls field option function to get label from filename. Defaults to filename.","ref":"Backpex.Fields.Upload.html#label_from_file/2"},{"type":"function","title":"Examples - Backpex.Fields.Upload.label_from_file/2","doc":"iex> Backpex.Fields.Upload.label_from_file(%{file_label: fn file -> file <> \"xyz\" end}, \"file\")\n    \"filexyz\"\n    iex> Backpex.Fields.Upload.label_from_file(%{}, \"file\")\n    \"file\"","ref":"Backpex.Fields.Upload.html#label_from_file/2-examples"},{"type":"function","title":"Backpex.Fields.Upload.list_existing_files/3","doc":"Lists existing files based on item and list of removed files.","ref":"Backpex.Fields.Upload.html#list_existing_files/3"},{"type":"function","title":"Backpex.Fields.Upload.map_file_paths/2","doc":"Maps uploaded files to keyword list with identifier and label.","ref":"Backpex.Fields.Upload.html#map_file_paths/2"},{"type":"behaviour","title":"Backpex.ItemAction","doc":"Behaviour implemented by all item actions.","ref":"Backpex.ItemAction.html"},{"type":"macro","title":"Backpex.ItemAction.__using__/1","doc":"Defines `Backpex.ItemAction` behaviour and provides default implementations.","ref":"Backpex.ItemAction.html#__using__/1"},{"type":"callback","title":"Backpex.ItemAction.cancel_label/1","doc":"cancel button label","ref":"Backpex.ItemAction.html#c:cancel_label/1"},{"type":"callback","title":"Backpex.ItemAction.changeset/3","doc":"The changeset to be used in the resource action. It may be used to validate form inputs.\n\nAdditional metadata is passed as a keyword list via the third parameter.\n\nThe list of metadata:\n- `:assigns` - the assigns\n- `:target` - the name of the `form` target that triggered the changeset call. Default to `nil` if the call was not triggered by a form field.","ref":"Backpex.ItemAction.html#c:changeset/3"},{"type":"callback","title":"Backpex.ItemAction.confirm/1","doc":"This text is being displayed in the confirm dialog.\n\nThere won't be any confirmation when this function is not defined.","ref":"Backpex.ItemAction.html#c:confirm/1"},{"type":"callback","title":"Backpex.ItemAction.confirm_label/1","doc":"Confirm button label","ref":"Backpex.ItemAction.html#c:confirm_label/1"},{"type":"callback","title":"Backpex.ItemAction.fields/0","doc":"A list of fields to be displayed in the item action. See `Backpex.Field`. In addition you have to provide\na `type` for each field in order to support changeset generation.\n\nThe following fields are currently not supported:\n\n- `Backpex.Fields.BelongsTo`\n- `Backpex.Fields.HasMany`\n- `Backpex.Fields.HasManyThrough`\n- `Backpex.Fields.Upload`","ref":"Backpex.ItemAction.html#c:fields/0"},{"type":"callback","title":"Backpex.ItemAction.handle/3","doc":"Performs the action. It takes the socket and the casted and validated data (received from [`Ecto.Changeset.apply_action/2`](https://hexdocs.pm/ecto/Ecto.Changeset.html#apply_action/2)).","ref":"Backpex.ItemAction.html#c:handle/3"},{"type":"callback","title":"Backpex.ItemAction.icon/2","doc":"Action icon","ref":"Backpex.ItemAction.html#c:icon/2"},{"type":"callback","title":"Backpex.ItemAction.init_change/1","doc":"Initial change. The result will be passed to `c:changeset/3` in order to generate a changeset.\n\nThis function is optional and can be used to use changesets with schemas in item actions. If this function\nis not provided a changeset will be generated automatically based on the provided types in `c:fields/0`.","ref":"Backpex.ItemAction.html#c:init_change/1"},{"type":"callback","title":"Backpex.ItemAction.label/2","doc":"Action label (Show label on hover)","ref":"Backpex.ItemAction.html#c:label/2"},{"type":"module","title":"Backpex.ItemActions.Delete","doc":"Inline item action to redirect to show view.","ref":"Backpex.ItemActions.Delete.html"},{"type":"module","title":"Backpex.ItemActions.Edit","doc":"Inline item action to redirect to show view.","ref":"Backpex.ItemActions.Edit.html"},{"type":"module","title":"Backpex.ItemActions.Show","doc":"Inline item action to redirect to show view.","ref":"Backpex.ItemActions.Show.html"},{"type":"behaviour","title":"Backpex.ResourceAction","doc":"Behaviour implemented by all resource action modules.\n\n> #### `use Backpex.ResourceAction` {: .info}\n>\n> When you `use Backpex.ResourceAction`, the `Backpex.ResourceAction` module will set `@behavior Backpex.ResourceAction`.\n> In addition it will implement the `Backpex.ResourceAction.init_change` function in order to generate a schemaless changeset by default.","ref":"Backpex.ResourceAction.html"},{"type":"macro","title":"Backpex.ResourceAction.__using__/1","doc":"Defines `Backpex.ResourceAction` behaviour.","ref":"Backpex.ResourceAction.html#__using__/1"},{"type":"callback","title":"Backpex.ResourceAction.changeset/3","doc":"The changeset to be used in the resource action. It may be used to validate form inputs.\n\nAdditional metadata is passed as a keyword list via the third parameter.\n\nThe list of metadata:\n- `:assigns` - the assigns\n- `:target` - the name of the `form` target that triggered the changeset call. Default to `nil` if the call was not triggered by a form field.","ref":"Backpex.ResourceAction.html#c:changeset/3"},{"type":"callback","title":"Backpex.ResourceAction.fields/0","doc":"A list of fields to be displayed in the resource action. See `Backpex.Field`. In addition you have to provide\na `type` for each field in order to support changeset generation.","ref":"Backpex.ResourceAction.html#c:fields/0"},{"type":"callback","title":"Backpex.ResourceAction.handle/2","doc":"The handle function for the corresponding action. It receives the socket and casted and validated data (received from [`Ecto.Changeset.apply_action/2`](https://hexdocs.pm/ecto/Ecto.Changeset.html#apply_action/2)) and will be called when the form is valid and submitted.\n\nIt must return either `{:ok, binary()}` or `{:error, binary()}`","ref":"Backpex.ResourceAction.html#c:handle/2"},{"type":"callback","title":"Backpex.ResourceAction.init_change/1","doc":"Initial change. The result will be passed to `c:changeset/3` in order to generate a changeset.\n\nThis function is optional and can be used to use changesets with schemas in resource actions. If this function\nis not provided a changeset will be generated automatically based on the provided types in `c:fields/0`.","ref":"Backpex.ResourceAction.html#c:init_change/1"},{"type":"callback","title":"Backpex.ResourceAction.label/0","doc":"The label of the resource action. It will be the label for the resource action button.","ref":"Backpex.ResourceAction.html#c:label/0"},{"type":"function","title":"Backpex.ResourceAction.name/2","doc":"Gets the name of a resource action.","ref":"Backpex.ResourceAction.html#name/2"},{"type":"callback","title":"Backpex.ResourceAction.title/0","doc":"The title of the resource action. It will be part of the page header and slide over title.","ref":"Backpex.ResourceAction.html#c:title/0"},{"type":"behaviour","title":"Backpex.Filter","doc":"The base behaviour for all filters. Injects also basic layout, form and delete button for a filters rendering.","ref":"Backpex.Filter.html"},{"type":"callback","title":"Backpex.Filter.can?/1","doc":"Defines whether the filter can be used or not.","ref":"Backpex.Filter.html#c:can?/1"},{"type":"callback","title":"Backpex.Filter.label/0","doc":"If no label is defined on the filter map, this value is used as the filter label.","ref":"Backpex.Filter.html#c:label/0"},{"type":"callback","title":"Backpex.Filter.query/3","doc":"The filter query that is executed if an option was selected.","ref":"Backpex.Filter.html#c:query/3"},{"type":"callback","title":"Backpex.Filter.render/1","doc":"Renders the filters selected value(s).","ref":"Backpex.Filter.html#c:render/1"},{"type":"callback","title":"Backpex.Filter.render_form/1","doc":"Renders the filters options form.","ref":"Backpex.Filter.html#c:render_form/1"},{"type":"behaviour","title":"Backpex.Filters.Boolean","doc":"The boolean filter renders one checkbox per given option, hence multiple options can apply at the same time.\nInstead of implementing a `query` callback, you need to define predicates for each option leveraging [`Ecto.Query.dynamic/2`](https://hexdocs.pm/ecto/Ecto.Query.html#dynamic/2).\n\n> #### Warning {: .warning}\n>\n> Note that only query elements will work as a predicate that also work in an [`Ecto.Query.where/3`](https://hexdocs.pm/ecto/Ecto.Query.html#where/3).\n\nIf none is selected, the filter does not change the query. If multiple options are selected they are logically reduced via `orWhere`.\n\nSee the following example for an implementation of a boolean filter for a published field.\n\n    defmodule MyAppWeb.Filters.EventPublished do\n      use Backpex.Filters.Boolean\n\n      @impl Backpex.Filter\n      def label, do: \"Published?\"\n\n      @impl Backpex.Filters.Boolean\n      def options do\n        [\n          %{\n            label: \"Published\",\n            key: \"published\",\n            predicate: dynamic([x], x.published)\n          },\n          %{\n            label: \"Not published\",\n            key: \"not_published\",\n            predicate: dynamic([x], not x.published)\n          }\n        ]\n      end\n    end\n\n> #### `use Backpex.Filters.Boolean` {: .info}\n>\n> When you `use Backpex.Filters.Boolean`, the `Backpex.Filters.Boolean` module will set `@behavior Backpex.Filters.Boolean`.\n> In addition it will add a `render` and `render_form` function in order to display the corresponding filter.\n> It will also implement the `Backpex.Filter.query` function to define a boolean query.","ref":"Backpex.Filters.Boolean.html"},{"type":"function","title":"Backpex.Filters.Boolean.find_option_label/2","doc":"","ref":"Backpex.Filters.Boolean.html#find_option_label/2"},{"type":"function","title":"Backpex.Filters.Boolean.maybe_query/2","doc":"","ref":"Backpex.Filters.Boolean.html#maybe_query/2"},{"type":"function","title":"Backpex.Filters.Boolean.option_value_to_label/2","doc":"","ref":"Backpex.Filters.Boolean.html#option_value_to_label/2"},{"type":"callback","title":"Backpex.Filters.Boolean.options/0","doc":"The list of options for the select filter.","ref":"Backpex.Filters.Boolean.html#c:options/0"},{"type":"function","title":"Backpex.Filters.Boolean.predicates/1","doc":"","ref":"Backpex.Filters.Boolean.html#predicates/1"},{"type":"function","title":"Backpex.Filters.Boolean.query/4","doc":"","ref":"Backpex.Filters.Boolean.html#query/4"},{"type":"function","title":"Backpex.Filters.Boolean.render/1","doc":"","ref":"Backpex.Filters.Boolean.html#render/1"},{"type":"function","title":"Attributes - Backpex.Filters.Boolean.render/1","doc":"* `value` (`:any`) (required)\n* `options` (`:list`) (required)","ref":"Backpex.Filters.Boolean.html#render/1-attributes"},{"type":"function","title":"Backpex.Filters.Boolean.render_form/1","doc":"","ref":"Backpex.Filters.Boolean.html#render_form/1"},{"type":"function","title":"Attributes - Backpex.Filters.Boolean.render_form/1","doc":"* `form` (`:any`) (required)\n* `field` (`:atom`) (required)\n* `value` (`:any`) (required)\n* `options` (`:list`) (required)","ref":"Backpex.Filters.Boolean.html#render_form/1-attributes"},{"type":"behaviour","title":"Backpex.Filters.MultiSelect","doc":"The multi select filter renders checkboxes for a given list of options, hence allowing the user to select multiple values.\n\nSee the following example for an implementation of a multi select user filter.\n\n    defmodule MyAppWeb.Filters.MultiUserSelect do\n      use Backpex.Filters.MultiSelect\n\n      @impl Backpex.Filter\n      def label, do: \"User\"\n\n      @impl Backpex.Filters.MultiSelect\n      def prompt, do: \"Select user ...\"\n\n      @impl Backpex.Filters.MultiSelect\n      def options, do: [\n        {\"John Doe\", \"acdd1860-65ce-4ed6-a37c-433851cf68d7\"},\n        {\"Jane Doe\", \"9d78ce5e-9334-4a6c-a076-f1e72522de2\"}\n      ]\n    end\n\n> #### `use Backpex.Filters.MultiSelect` {: .info}\n>\n> When you `use Backpex.Filters.MultiSelect`, the `Backpex.Filters.MultiSelect` module will set `@behavior Backpex.Filters.Select`. In addition it will add a `render` and `render_form` function in order to display the corresponding filter.","ref":"Backpex.Filters.MultiSelect.html"},{"type":"function","title":"Backpex.Filters.MultiSelect.find_option_label/2","doc":"","ref":"Backpex.Filters.MultiSelect.html#find_option_label/2"},{"type":"function","title":"Backpex.Filters.MultiSelect.maybe_query/2","doc":"","ref":"Backpex.Filters.MultiSelect.html#maybe_query/2"},{"type":"function","title":"Backpex.Filters.MultiSelect.option_value_to_label/2","doc":"","ref":"Backpex.Filters.MultiSelect.html#option_value_to_label/2"},{"type":"callback","title":"Backpex.Filters.MultiSelect.options/0","doc":"The list of options for the multi select filter.","ref":"Backpex.Filters.MultiSelect.html#c:options/0"},{"type":"function","title":"Backpex.Filters.MultiSelect.query/3","doc":"","ref":"Backpex.Filters.MultiSelect.html#query/3"},{"type":"function","title":"Backpex.Filters.MultiSelect.render/1","doc":"","ref":"Backpex.Filters.MultiSelect.html#render/1"},{"type":"function","title":"Attributes - Backpex.Filters.MultiSelect.render/1","doc":"* `value` (`:any`) (required)\n* `options` (`:list`) (required)","ref":"Backpex.Filters.MultiSelect.html#render/1-attributes"},{"type":"function","title":"Backpex.Filters.MultiSelect.render_form/1","doc":"","ref":"Backpex.Filters.MultiSelect.html#render_form/1"},{"type":"function","title":"Attributes - Backpex.Filters.MultiSelect.render_form/1","doc":"* `form` (`:any`) (required)\n* `field` (`:atom`) (required)\n* `value` (`:any`) (required)\n* `options` (`:list`) (required)\n* `prompt` (`:string`) (required)","ref":"Backpex.Filters.MultiSelect.html#render_form/1-attributes"},{"type":"behaviour","title":"Backpex.Filters.Range","doc":"The range filter renders two input fields of the same type. Backpex offers the `:date`, `:datetime` and the `number` type.\n\nSee the following example for an implementation of a date range filter.\n\n    defmodule MyAppWeb.Filters.DateRange do\n      use Backpex.Filters.Range\n\n      @impl Backpex.Filters.Range\n      def type, do: :date\n\n      @impl Backpex.Filter\n      def label, do: \"Date Range (begins at)\"\n    end\n\n> #### Information {: .info}\n>\n> Note that the query function is already implemented via `Backpex.Filters.Range`.\n\n> #### `use Backpex.Filters.Range` {: .info}\n>\n> When you `use Backpex.Filters.Range`, the `Backpex.Filters.Range` module will set `@behavior Backpex.Filters.Range`.\n> In addition it will add a `render` and `render_form` function in order to display the corresponding filter.\n> It will also implement the `Backpex.Filter.query` function to define a range query.","ref":"Backpex.Filters.Range.html"},{"type":"function","title":"Backpex.Filters.Range.date?/1","doc":"","ref":"Backpex.Filters.Range.html#date?/1"},{"type":"function","title":"Backpex.Filters.Range.do_query/3","doc":"","ref":"Backpex.Filters.Range.html#do_query/3"},{"type":"function","title":"Backpex.Filters.Range.maybe_parse/3","doc":"","ref":"Backpex.Filters.Range.html#maybe_parse/3"},{"type":"function","title":"Backpex.Filters.Range.maybe_parse_range/3","doc":"","ref":"Backpex.Filters.Range.html#maybe_parse_range/3"},{"type":"function","title":"Backpex.Filters.Range.parse_float_or_int/1","doc":"","ref":"Backpex.Filters.Range.html#parse_float_or_int/1"},{"type":"function","title":"Backpex.Filters.Range.query/4","doc":"","ref":"Backpex.Filters.Range.html#query/4"},{"type":"function","title":"Backpex.Filters.Range.range_input_set/1","doc":"","ref":"Backpex.Filters.Range.html#range_input_set/1"},{"type":"function","title":"Attributes - Backpex.Filters.Range.range_input_set/1","doc":"* `form` (`:any`) (required)\n* `type` (`:atom`) (required)\n* `value` (`:any`) (required)","ref":"Backpex.Filters.Range.html#range_input_set/1-attributes"},{"type":"function","title":"Backpex.Filters.Range.render/1","doc":"","ref":"Backpex.Filters.Range.html#render/1"},{"type":"function","title":"Attributes - Backpex.Filters.Range.render/1","doc":"* `value` (`:map`) (required)","ref":"Backpex.Filters.Range.html#render/1-attributes"},{"type":"function","title":"Backpex.Filters.Range.render_form/1","doc":"","ref":"Backpex.Filters.Range.html#render_form/1"},{"type":"function","title":"Attributes - Backpex.Filters.Range.render_form/1","doc":"* `form` (`:any`) (required)\n* `field` (`:atom`) (required)\n* `value` (`:any`) (required)\n* `type` (`:atom`) (required)","ref":"Backpex.Filters.Range.html#render_form/1-attributes"},{"type":"function","title":"Backpex.Filters.Range.render_type/1","doc":"","ref":"Backpex.Filters.Range.html#render_type/1"},{"type":"callback","title":"Backpex.Filters.Range.type/0","doc":"The type return value defines the rendered input fields of the range filter.","ref":"Backpex.Filters.Range.html#c:type/0"},{"type":"behaviour","title":"Backpex.Filters.Select","doc":"Tbe select filter renders a select box for the implemented `options/0` and `prompt/0` callbacks. The `prompt/0` callback defines the key for the `nil` value added as first option.\n\nSee the following example for an implementation of an event status filter.\n\n    defmodule MyAppWeb.Filters.EventStatusSelect do\n      use Backpex.Filters.Select\n\n      @impl Backpex.Filter\n      def label, do: \"Event status\"\n\n      @impl Backpex.Filters.Select\n      def prompt, do: \"Select an option...\"\n\n      @impl Backpex.Filters.Select\n      def options, do: [\n        {\"Open\", :open},\n        {\"Close\", :close},\n      ]\n\n      @impl Backpex.Filter\n      def query(query, attribute, value) do\n          where(query, [x], field(x, ^attribute) == ^value)\n      end\n    end\n\n> #### `use Backpex.Filters.Select` {: .info}\n>\n> When you `use Backpex.Filters.Select`, the `Backpex.Filters.Select` module will set `@behavior Backpex.Filters.Select`.\n> In addition it will add a `render` and `render_form` function in order to display the corresponding filter.","ref":"Backpex.Filters.Select.html"},{"type":"function","title":"Backpex.Filters.Select.option_value_to_label/2","doc":"","ref":"Backpex.Filters.Select.html#option_value_to_label/2"},{"type":"callback","title":"Backpex.Filters.Select.options/0","doc":"The list of options for the select filter.","ref":"Backpex.Filters.Select.html#c:options/0"},{"type":"callback","title":"Backpex.Filters.Select.prompt/0","doc":"The select's default option.","ref":"Backpex.Filters.Select.html#c:prompt/0"},{"type":"function","title":"Backpex.Filters.Select.query/3","doc":"","ref":"Backpex.Filters.Select.html#query/3"},{"type":"function","title":"Backpex.Filters.Select.render/1","doc":"","ref":"Backpex.Filters.Select.html#render/1"},{"type":"function","title":"Attributes - Backpex.Filters.Select.render/1","doc":"* `value` (`:any`) (required)\n* `options` (`:list`) (required)","ref":"Backpex.Filters.Select.html#render/1-attributes"},{"type":"function","title":"Backpex.Filters.Select.render_form/1","doc":"","ref":"Backpex.Filters.Select.html#render_form/1"},{"type":"function","title":"Attributes - Backpex.Filters.Select.render_form/1","doc":"* `form` (`:any`) (required)\n* `field` (`:atom`) (required)\n* `value` (`:any`) (required)\n* `options` (`:list`) (required)\n* `prompt` (`:string`) (required)","ref":"Backpex.Filters.Select.html#render_form/1-attributes"},{"type":"function","title":"Backpex.Filters.Select.selected/1","doc":"","ref":"Backpex.Filters.Select.html#selected/1"},{"type":"behaviour","title":"Backpex.Metric","doc":"Behaviour implemented by all metrics.\n\nMetrics are info boxes for your resources displaying key indicators prominently on the index view in your application.\nAn example could be to show the current total of all orders received today. You may create your own metrics by\nimplementing this behaviour.","ref":"Backpex.Metric.html"},{"type":"callback","title":"Backpex.Metric.format/2","doc":"","ref":"Backpex.Metric.html#c:format/2"},{"type":"function","title":"Backpex.Metric.load_data_for_visible/5","doc":"Load and append the corresponding metric value(s) via the module's query for\nevery metric in the given list. Query's are only performed if metrics are\nmarked as visible for the give live resource.","ref":"Backpex.Metric.html#load_data_for_visible/5"},{"type":"function","title":"Backpex.Metric.metric_box_class/1","doc":"Builds string of css classes for basic metric box","ref":"Backpex.Metric.html#metric_box_class/1"},{"type":"function","title":"Backpex.Metric.metrics_visible?/2","doc":"Determine if metrics are visible for given live_resource.","ref":"Backpex.Metric.html#metrics_visible?/2"},{"type":"callback","title":"Backpex.Metric.query/3","doc":"","ref":"Backpex.Metric.html#c:query/3"},{"type":"callback","title":"Backpex.Metric.render/1","doc":"Used to render the metric as a heex template on the index views.","ref":"Backpex.Metric.html#c:render/1"},{"type":"module","title":"Backpex.Metrics.Value","doc":"Value metrics display only a single value. This value is generated from the current index query by applying the given\naggregate function. The selected value is processed by the specified formatting function and output in the frontend.","ref":"Backpex.Metrics.Value.html"},{"type":"module","title":"Options - Backpex.Metrics.Value","doc":"* `:module` - Defines the module to handle the metric.\n  * `:label` - Label text to define a headline for the metric.\n  * `:select` - Dynamic query expression defining the column to select. This is usually an aggregate function.\n  * `:format` - Optional format function to post-process the selected value from the database to display in frontend.\n  * `:class` - Optional extra css classes to be passed to the metric box.","ref":"Backpex.Metrics.Value.html#module-options"},{"type":"module","title":"Example - Backpex.Metrics.Value","doc":"In the following example we have a live resource `products` with a value `quantity`. We use the `select` option here\nto pass an aggregate function that adds up the `quantity` value of all products currently active in the index view.\n\n    @impl Backpex.LiveResource\n    def metrics do\n      [\n        total_quantity: %{\n          module: Backpex.Metrics.Value,\n          label: \"In Stock\",\n          class: \"w-1/3\",\n          select: dynamic([i], sum(i.quantity)),\n          format: fn value ->\n            Integer.to_string(value) <> \" Products\"\n          end\n        }\n      ]\n    end","ref":"Backpex.Metrics.Value.html#module-example"},{"type":"function","title":"Backpex.Metrics.Value.format/2","doc":"Formats the selected data to display in frontend.","ref":"Backpex.Metrics.Value.html#format/2"},{"type":"function","title":"Backpex.Metrics.Value.query/3","doc":"Performs database select to query the value of the metric","ref":"Backpex.Metrics.Value.html#query/3"},{"type":"function","title":"Backpex.Metrics.Value.render/1","doc":"","ref":"Backpex.Metrics.Value.html#render/1"},{"type":"function","title":"Attributes - Backpex.Metrics.Value.render/1","doc":"* `metric` (`:any`) (required) - the metric to be rendered.","ref":"Backpex.Metrics.Value.html#render/1-attributes"},{"type":"exception","title":"Backpex.ForbiddenError","doc":"Raised when action can not be performed due to missing permission.\n\nIf you are seeing this error, you should check if you have the permission necessary to perform the action.","ref":"Backpex.ForbiddenError.html"},{"type":"exception","title":"Backpex.NoResourceError","doc":"Raised when resource can not be found.\n\nIf you are seeing this error, you should check if you provided the correct identifier for the requested resource.","ref":"Backpex.NoResourceError.html"},{"type":"extras","title":"Introduction","doc":"[![CI](https://github.com/naymspace/backpex/actions/workflows/ci.yml/badge.svg)](https://github.com/naymspace/backpex/actions/workflows/ci.yml)\n[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://github.com/naymspace/backpex/blob/develop/LICENSE.md)\n[![Hex](https://img.shields.io/hexpm/v/backpex.svg)](https://hex.pm/packages/backpex)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-green)](https://hexdocs.pm/backpex)\n\n \n   \n   \n   \n  Phoenix Admin Panel built with PETAL · Backpex\n   \n   \n   📚  Documentation  \n  •\n   🛠️  Installation Guide  \n  •\n   🩵  Contribute  \n \n\n# Backpex\n\nWelcome! Backpex is a highly customizable administration panel for Phoenix LiveView applications. Quickly create beautiful CRUD views for your existing data using configurable *LiveResources*. Backpex integrates seamlessly with your existing Phoenix application and provides a simple way to manage your resources. It is highly customizable and can be extended with your own layouts, views, field types, filters and more.\n\n![Backpex Screenshot](https://github.com/naymspace/backpex/blob/develop/priv/static/images/screenshot.png?raw=true)\n\n \n    Visit our Live Demo →","ref":"readme.html"},{"type":"extras","title":"Key Features - Introduction","doc":"- 📊 **LiveResources**: Quickly create LiveResource modules for your database tables with fully customizable CRUD views. Bring your own layout or use our components.\n- 🔍 **Search and Filters**: Define searchable fields and add custom filters for instant, LiveView-powered results.\n- ⚡ **Resource Actions**: Implement global custom actions like user invitations or exports, with support for additional form fields.\n- 🔒 **Authorization**: Handle CRUD and custom action authorization via simple pattern matching, with optional integration for external authorization libraries.\n- 🧩 **Field Types**: Out-of-the-box support for Text, Number, Date, Upload, and more. Easily extend with your own custom field type modules.\n- 🔗 **Associations**: Effortlessly handle HasOne, BelongsTo, and HasMany(Through) associations with minimal configuration. Customize available options and rendered columns.\n- 📈 **Metrics**: Add value metrics such as sums or averages for quick data insights, with more metric types on the horizon.","ref":"readme.html#key-features"},{"type":"extras","title":"Installation & Documentation - Introduction","doc":"See our comprehensive [installation guide](https://hexdocs.pm/backpex/installation.html) for more information on how to install and configure Backpex in your Phoenix application.\n\nWe also provide a detailed [documentation](https://hexdocs.pm/backpex) with guides on how to use Backpex and how to customize it to your needs.","ref":"readme.html#installation-documentation"},{"type":"extras","title":"Learn More - Introduction","doc":"- [What is Backpex?](https://hexdocs.pm/backpex/what-is-backpex.html)\n- [Why we built Backpex?](https://hexdocs.pm/backpex/what-is-backpex.html)\n- [Contribute to Backpex](https://hexdocs.pm/backpex/contribute-to-backpex.html)","ref":"readme.html#learn-more"},{"type":"extras","title":"License - Introduction","doc":"Backpex is open-source software, licensed under the [MIT License](https://github.com/naymspace/backpex/blob/main/LICENSE.md).","ref":"readme.html#license"},{"type":"extras","title":"What is Backpex?","doc":"# What is Backpex?\n\nBackpex is a highly customizable administration panel for Phoenix LiveView applications. It allows you to quickly create CRUD views of your existing data using configurable *LiveResources*. Backpex integrates seamlessly with your existing Phoenix LiveView application and provides an easy way to manage your resources. It is highly customizable and can be extended with your own layouts, views, field types, filters and more.\n\nBackpex is built on top of Phoenix LiveView and provides a rich set of features to manage your resources. With Backpex, you can set up an administration panel for your application in hours, not days.\n\nWhether you want to quickly scaffold CRUD views for your existing data or build a full-fledged administration panel, Backpex has you covered.\n\nTODO: add screenshots of key features here","ref":"what-is-backpex.html"},{"type":"extras","title":"Why we built Backpex?","doc":"# Why we built Backpex?\n\nAfter building several Phoenix applications, we realized that we were repeating ourselves when it came to building administration panels. We were writing the same CRUD views, search and filter functionality over and over again. We wanted a tool that would allow us to quickly scaffold these views and focus on building the core functionality of our applications.\n\nThe tool we wanted had to be able to serve as a simple backend administration panel in one project, while being the core of the application in another.\n\nWe looked at existing solutions, but found that none of them offered the flexibility and customization we were looking for. We decided to develop Backpex to solve this problem and provide a highly customizable administration panel for Phoenix LiveView applications.","ref":"why-we-built-backpex.html"},{"type":"extras","title":"Contribute to Backpex","doc":"# Contribute to Backpex\n\nWe are excited to have you contribute to Backpex! We are always looking for ways to improve the project and welcome any contributions in the form of bug reports, feature requests, documentation improvements, code contributions, and more.","ref":"contribute-to-backpex.html"},{"type":"extras","title":"What can I contribute? - Contribute to Backpex","doc":"We provide a roadmap and a list of issues that you can work on to contribute to Backpex.\n\n- Roadmap: https://github.com/orgs/naymspace/projects/2\n- Issues: https://github.com/naymspace/backpex/issues\n\nEspecially, [issues labeled with `good-first-issue`](https://github.com/naymspace/backpex/labels/good-first-issue) are a good starting point for new contributors.\n\nWe also use GitHub's discussion feature to discuss new ideas and features.\n\n- Discussions: https://github.com/naymspace/backpex/discussions\n\nIf you don't find an issue that you want to work on, you can always contribute to Backpex by:\n\n- Reporting bugs (create an issue)\n- Requesting new features (use the discussions)\n- Improving the documentation\n- Improving the demo application","ref":"contribute-to-backpex.html#what-can-i-contribute"},{"type":"extras","title":"Fork the repository - Contribute to Backpex","doc":"In order to contribute to Backpex, you need to fork the repository. You can do this by clicking the \"Fork\" button in the top right corner of the repository page at [https://github.com/naymspace/backpex](https://github.com/naymspace/backpex).","ref":"contribute-to-backpex.html#fork-the-repository"},{"type":"extras","title":"Clone the repository - Contribute to Backpex","doc":"After forking the repository, you need to clone it to your local machine. You can do this by running the `git clone` command along with the URL of your forked repository.","ref":"contribute-to-backpex.html#clone-the-repository"},{"type":"extras","title":"Setting up your development environment - Contribute to Backpex","doc":"You first need to create a `.env` file in the `demo` directory of the project with the following content:\n\n```bash\nSECRET_KEY_BASE= \nLIVE_VIEW_SIGNING_SALT= \n```\n\nFor development purposes you can copy the values from the `demo/.env.example` file.\n\nYou can then start the development environment by running the following command in the root directory of the project:\n\n```bash\ndocker compose up\n```\n\nBackpex comes with a demo application that you can use to test the features of the project. The command will start a PostgreSQL database and the demo application on [http://localhost:4000](http://localhost:4000).\n\nTo insert some demo data into the database, you can run the following command:\n\n```bash\ndocker compose exec app mix ecto.seed\n```","ref":"contribute-to-backpex.html#setting-up-your-development-environment"},{"type":"extras","title":"Making changes - Contribute to Backpex","doc":"After setting up your development environment, you can start making changes to the project. We recommend creating a new branch for your changes. After submitting your changes to your forked repository, you can create a pull request to the `develop` branch of the main repository.","ref":"contribute-to-backpex.html#making-changes"},{"type":"extras","title":"Installation","doc":"# Installation\n\nThe following guide will help you to install Backpex in your Phoenix application. We will guide you through the installation process and show you how to create a simple resource.","ref":"installation.html"},{"type":"extras","title":"Prerequisites - Installation","doc":"Backpex integrates seamlessly with your existing Phoenix LiveView application, but there are a few prerequisites you need to meet before you can start using it.","ref":"installation.html#prerequisites"},{"type":"extras","title":"Phoenix LiveView - Installation","doc":"Backpex is built on top of Phoenix LiveView, so you need to have Phoenix LiveView installed in your application. If you generate a new Phoenix application using the latest version of the `mix phx.new` generator, Phoenix LiveView is included by default.","ref":"installation.html#phoenix-liveview"},{"type":"extras","title":"Alpine.js - Installation","doc":"Backpex uses [Alpine.js](https://alpinejs.dev/) for some interactivity. Make sure you have Alpine.js installed in your application.\n\nYou can install Alpine.js by installing it via npm:\n\n```bash\ncd assets && npm install alpinejs\n```\n\nThen, import Alpine.js in your `app.js` file, start it and adjust your LiveView configuration:\n\n```javascript\nimport Alpine from \"alpinejs\";\n\nwindow.Alpine = Alpine;\nAlpine.start();\n\nconst liveSocket = new LiveSocket('/live', Socket, {\n  // add this\n  dom: {\n    onBeforeElUpdated (from, to) {\n      if (from._x_dataStack) {\n        window.Alpine.clone(from, to)\n      }\n    },\n  },\n  params: { _csrf_token: csrfToken },\n})\n```","ref":"installation.html#alpine-js"},{"type":"extras","title":"Tailwind CSS - Installation","doc":"Backpex uses Tailwind CSS for styling. Make sure you have Tailwind CSS installed in your application. You can install Tailwind CSS by following the [official installation guide](https://tailwindcss.com/docs/installation). If you generate a new Phoenix application using the latest version of the `mix phx.new` generator, Tailwind CSS is included by default.","ref":"installation.html#tailwind-css"},{"type":"extras","title":"daisyUI - Installation","doc":"Backpex is styled using daisyUI. Make sure you have daisyUI installed in your application. You can install daisyUI by following the [official installation guide](https://daisyui.com/docs/install/).","ref":"installation.html#daisyui"},{"type":"extras","title":"Ecto - Installation","doc":"Backpex currently depends on Ecto as the database layer. Make sure you have a running Ecto repository in your application.\n\n> #### Warning {: .warning}\n>\n> Backpex requires a single primary key field in your database schema. Compound keys are not supported. We tested Backpex with UUID (binary_id), integer (bigserial) and string primary keys. Note that the primary key is used in the URL for Show and Edit Views, so make sure it is always URL-encoded or safe to use in a URL.\n\nIf you meet all these prerequisites, you are ready to install and configure Backpex in your Phoenix application. See our [installation guide](guides/get_started/installation.md) for more information on how to install and configure Backpex.","ref":"installation.html#ecto"},{"type":"extras","title":"Add to list of dependencies - Installation","doc":"In your `mix.exs`:\n\n```elixir\ndefp deps do\n  [\n    ...\n    {:backpex, \"~> 0.6.0\"}\n  ]\nend\n```\n\nSee the [hex.pm page](https://hex.pm/packages/backpex) for the latest version.","ref":"installation.html#add-to-list-of-dependencies"},{"type":"extras","title":"Add files to Tailwind content - Installation","doc":"Backpex uses Tailwind CSS and daisyUI. Make sure to add the Backpex files to your tailwind content in order to include the Backpex styles.\n\nIn your `tailwind.config.js`:\n\n```js\n..,\ncontent: [\n  ...,\n  // add this line\n  '../deps/backpex/**/*.*ex'\n]\n```\n\n> #### Info {: .info}\n>\n> The path to the Backpex files may vary depending on your project setup.","ref":"installation.html#add-files-to-tailwind-content"},{"type":"extras","title":"Setup formatter - Installation","doc":"Backpex ships with a formatter configuration. To use it, add Backpex to the list of dependencies in your `.formatter.exs`.\n\n```elixir\n# my_app/.formatter.exs\n[\n  import_deps: [:backpex]\n]\n```","ref":"installation.html#setup-formatter"},{"type":"extras","title":"Create an example resource - Installation","doc":"To make it more practical, we are going to create a simple resource that we will use in all our examples later in the installation guide. You can skip this step if you want to use your own resource or just follow the guide.\n\nThe example resource will be a `Post` resource with the following fields:\n\n- `title` (string)\n- `views` (integer)\n\nRun the following commands:\n\n```bash\nmix phx.gen.schema Blog.Post blog_posts title:string views:integer\nmix ecto.migrate\n```\n\nThese commands will generate a `Post` schema and a migration file. The migration file will create a `blog_posts` table in your database.\n\nYou are now prepared to set up the Backpex layout and a LiveResource for the `Post` resource.","ref":"installation.html#create-an-example-resource"},{"type":"extras","title":"Create layout - Installation","doc":"Backpex does not ship with a predefined layout by default to give you the freedom to create your own layout. Instead, it provides components that you can use to build your own layout. You can find all Backpex components in the `lib/backpex/components` directory. Layout components are placed in the `lib/backpex/components/layout` directory. To start quickly, Backpex provides an `Backpex.HTML.Layout.app_shell/1` component. You can use this component to add an app shell layout to your application easily.\n\nSee the following example that uses the `Backpex.HTML.Layout.app_shell/1` component and some other Backpex Layout components to create a simple layout:\n\n```elixir\n \n  <:topbar>\n     \n\n     \n      <:label>\n         \n          <.icon name=\"hero-user\" class=\"h-8 w-8\" />\n         \n      </:label>\n       \n        <.link navigate={~p\"/\"} class=\"flex justify-between text-red-600 hover:bg-gray-100\">\n           Logout \n          <.icon name=\"hero-arrow-right-on-rectangle\" class=\"h-5 w-5\" />\n        </.link>\n       \n     \n  </:topbar>\n  <:sidebar>\n     \n      <.icon name=\"hero-book-open\" class=\"h-5 w-5\" /> Posts\n     \n  </:sidebar>\n   \n  <%= @inner_content %>\n \n```\n\nMake sure to add the `Backpex.HTML.Layout.flash_messages` component to display flash messages in your layout and do not forget to add the `@inner_content` variable to render the content of the LiveView.\n\nPlace the layout file in your `lib/myapp_web/templates/layout` directory. You can name it like you want, but we recommend to use `admin.html.heex`. You can also use this layout as the only layout in your application if your application consists of only an admin interface.\n\nWe use the `icon/1` component to render icons in the layout. This component is part of the `core_components` module that ships with new Phoenix projects. See [`core_components.ex`](https://github.com/phoenixframework/phoenix/blob/main/priv/templates/phx.gen.live/core_components.ex). Feel free to use your own icon component or library.\n\n> #### Information {: .info}\n>\n> The `Backpex.HTML.Layout.app_shell/1` component accepts a boolean `fluid` to determine if a `LiveResource` should be rendered full width. There is a `fluid?` option you can configure in a `LiveResource`. See the [Fluid Layout documentation](live_resource/fluid-layout.md) for more information.","ref":"installation.html#create-layout"},{"type":"extras","title":"Configure LiveResource - Installation","doc":"To create a LiveResource for the `Post` resource, you need to create LiveResource module.\n\n```elixir\ndefmodule MyAppWeb.Live.PostLive do\n  use Backpex.LiveResource,\n    layout: {MyAppWeb.Layouts, :admin},\n    schema: MyApp.Blog.Post,\n    repo: MyApp.Repo,\n    update_changeset: &MyApp.Blog.Post.update_changeset/3,\n    create_changeset: &MyApp.Blog.Post.create_changeset/3,\n    pubsub: MyApp.PubSub,\n    topic: \"posts\",\n    event_prefix: \"post_\"\nend\n```\n\n`Backpex.LiveResource` is the module that will generate the corresponding LiveViews for the resource you configured. We provide a macro you have to use to configure the LiveResource. You are required to set some general options to tell Backpex where to find the resource and what changesets should be used. The above example shows the configuration for a `Post` resource.\n\nAll options you can see in the above example are required:\n\n- The `layout` option tells Backpex which layout to use for the LiveResource. In this case, we use the `:admin`(`admin.html.heex`) layout created in the previous step.\n- The `schema` option tells Backpex which schema to use for the resource.\n- The `repo` option tells Backpex which repo to use for the resource.\n- The `update_changeset` and `create_changeset` options tell Backpex which changesets to use for updating and creating the resource.\n- The `pubsub` option tells Backpex which pubsub to use for the resource (see the [Listen to PubSub Events](live_resource/listen-to-pubsub-events.md) guide for more information).\n- The `topic` option tells Backpex which topic to use for the resource when broadcasting events.\n- The `event_prefix` option tells Backpex which event prefix to use for the resource when broadcasting events.\n\nIn addition to the required options, you pass to the `Backpex.LiveResource` macro, you are required to implement the following callback functions in the module:\n\n- [`singular_name/0`](Backpex.LiveResource.html#c:singular_name/0) - This function should return the singular name of the resource.\n- [`plural_name/0`](Backpex.LiveResource.html#c:plural_name/0) - This function should return the plural name of the resource.\n- [`fields/0`](Backpex.LiveResource.html#c:fields/0) - This function should return a list of fields to display in the LiveResource.\n\nAfter implementing the required callback functions, our `PostLive` module looks like this:\n\n```elixir\ndefmodule MyAppWeb.Live.PostLive do\n  use Backpex.LiveResource,\n    layout: {MyAppWeb.Layouts, :admin},\n    schema: MyApp.Blog.Post,\n    repo: MyApp.Repo,\n    update_changeset: &MyApp.Blog.Post.update_changeset/3,\n    create_changeset: &MyApp.Blog.Post.create_changeset/3,\n    pubsub: MyApp.PubSub,\n    topic: \"posts\",\n    event_prefix: \"post_\"\n\n  @impl Backpex.LiveResource\n  def singular_name, do: \"Post\"\n\n  @impl Backpex.LiveResource\n  def plural_name, do: \"Posts\"\n\n  @impl Backpex.LiveResource\n  def fields do\n    [\n      title: %{\n        module: Backpex.Fields.Text,\n        label: \"Title\"\n      },\n      views: %{\n        module: Backpex.Fields.Number,\n        label: \"Views\"\n      }\n    ]\n  end\nend\n```\n\nThe `fields/0` function returns a list of fields to display in the LiveResource. See [What is a Field?](../fields/what-is-a-field.md) for more information.\n\n> #### Information {: .info}\n>\n> We recommend placing the *LiveResource* in the `lib/myapp_web/live` directory. You can name the module like you want, but in this case, we recommend using `post_live.ex`.","ref":"installation.html#configure-liveresource"},{"type":"extras","title":"Configure Routing - Installation","doc":"To make the LiveResource accessible in your application, you first need to configure your router (`router.ex`).","ref":"installation.html#configure-routing"},{"type":"extras","title":"Add Backpex Routes - Installation","doc":"Backpex needs to add a `backpex_cookies` route to your router. This route is used to set the cookies needed for the Backpex LiveResource.\n\nBackpex provides a macro you can use to add the required routes to your router. Make sure to import `Backpex.Router` at the top of your router file or prefix the function calls.#\n\nYou have to do this step only once in your router file, so if you already added the [`backpex_routes/0`](Backpex.Router.html#backpex_routes/0) macro, you can skip this step.\n\n```elixir\n# router.ex\n\nimport Backpex.Router\n\nscope \"/admin\", MyAppWeb do\n  pipe_through :browser\n\n  # add this line\n  backpex_routes()\nend\n```\n\nIt does not matter where you place the [`backpex_routes/0`](Backpex.Router.html#backpex_routes/0) macro in your router file. You can insert it in every scope you want to, but we recommend placing it in the scope you want to use backpex in, e.g. `/admin`.","ref":"installation.html#add-backpex-routes"},{"type":"extras","title":"Add Init Assigns and LiveSession - Installation","doc":"Backpex provides a `Backpex.InitAssigns` module. This will attach the `current_url` to the LiveView. Backpex needs it to highlight the current sidebar item in the layout. You can also use your own init assigns module if you want to attach more assigns to the LiveView, but make sure to add the `current_url` to the assigns.\n\nWe use a live session to add the init assigns to all LiveViews in the `/admin` scope.\n\n```elixir\n# router.ex\n\nimport Backpex.Router\n\nscope \"/admin\", MyAppWeb do\n  pipe_through :browser\n\n  backpex_routes()\n\n  # add this line\n  live_session :default, on_mount: Backpex.InitAssigns do\n  end\nend\n```","ref":"installation.html#add-init-assigns-and-livesession"},{"type":"extras","title":"Add LiveResource routes - Installation","doc":"To make the LiveResource accessible in your application, you need to add routes for it. Backpex makes it easy to add the required routes to your router by providing the [`live_resources/3`](Backpex.Router.html#live_resources/3) macro.\n\n```elixir\n# router.ex\n\nimport Backpex.Router\n\nscope \"/admin\", MyAppWeb do\n  pipe_through :browser\n\n  backpex_routes()\n\n  live_session :default, on_mount: Backpex.InitAssigns do\n    # add this line\n    live_resources \"/posts\", PostLive\n  end\nend\n```\n\nThis macro will add the required routes for the `PostLive` module. You can now access the `PostLive` LiveResource at `/admin/posts`.","ref":"installation.html#add-liveresource-routes"},{"type":"extras","title":"Remove default background color - Installation","doc":"If you start with a new Phoenix project, you may have a default background color set for your body tag. This conflicts with the background color of the Backpex `app_shell`.\n\nSo if you have this in your `root.html.heex`.\n\n```html\n \n \n```\n\nYou should remove the `bg-white` class.\n\nIf you need this color on your body tag to style your application, consider using another root layout for Backpex (see [`put_root_layout/2`](https://hexdocs.pm/phoenix/Phoenix.Controller.html#put_root_layout/2)).","ref":"installation.html#remove-default-background-color"},{"type":"extras","title":"Set daisyUI theme - Installation","doc":"Backpex supports daisyUI themes. The following steps will guide you through setting up daisyUI themes in your application and optionally adding a theme selector to your layout.\n\n**1. Add the themes to your application.**\n\nFirst, you need to add the themes to your `tailwind.config.js` file. You can add the themes to the `daisyui` key in the configuration file. The following example shows how to add the `light`, `dark`, and `cyberpunk` themes to your application.\n\n```js\n// tailwind.config.js\nmodule.exports = {\n  daisyui: {\n    themes: [\n      {\n        light: {\n          ...require('daisyui/src/theming/themes').light,\n          primary: '#1d4ed8',\n          'primary-content': 'white',\n          secondary: '#f39325',\n          'secondary-content': 'white'\n        }\n      },\n        \"dark\",\n        \"cyberpunk\"\n    ]\n  },\n  ...\n}\n```\n\nThe full list of themes can be found at the [daisyUI website](https://daisyui.com/docs/themes/).\n\n**2. Set the assign and the default daisyUI theme in your layout.**\n\nWe fetch the theme from the assigns and set the `data-theme` attribute on the `html` tag. If no theme is set, we default to the `light` theme.\n\n```elixir\n# root.html.heex\n \n  ...\n \n```\n\nIf you just want to use a single theme, you can set the `data-theme` attribute to the theme name. You can skip the next steps and are done with the theme setup.\n\n```elixir\n# root.html.heex\n \n  ...\n \n```\n\n**3. Add `Backpex.ThemeSelectorPlug` to the pipeline in the router**\n\nTo add the saved theme to the assigns, you can add the `Backpex.ThemeSelectorPlug` to the pipeline in your router. This plug will fetch the selected theme from the session and put it in the assigns.\n\n```elixir\n# router.ex\n  pipeline :browser do\n    ...\n    # Add this plug\n    plug Backpex.ThemeSelectorPlug\n  end\n```\n\n**4. Add the theme selector component to the app shell**\n\nYou can add a theme selector to your layout to allow users to change the theme. The following example shows how to add a theme selector to the `admin.html.heex` layout. The list of themes should match the themes you added to your `tailwind.config.js` file.\n\n```elixir\n# admin.html.heex\n \n  <:topbar>\n     \n    # Add this\n     \n     \n      <:label>\n         \n          <.icon name=\"hero-user\" class=\"h-8 w-8\" />\n         \n      </:label>\n       \n        <.link navigate={~p\"/\"} class=\"flex justify-between text-red-600 hover:bg-gray-100\">\n           Logout \n          <.icon name=\"hero-arrow-right-on-rectangle\" class=\"h-5 w-5\" />\n        </.link>\n       \n     \n  </:topbar>\n  <:sidebar>\n     \n      <.icon name=\"hero-book-open\" class=\"h-5 w-5\" /> Posts\n     \n  </:sidebar>\n   \n  <%= @inner_content %>\n \n```\n\n**5. Add a hook to persist the selected theme**\n\nTo persist the selected theme, you can add a hook to your `app.js` file. This hook will listen for the `backpex:theme-change` event and store the selected theme in the session and in the local storage. The hook will also send a request to the server to store the selected theme in the session.\n\n```js\n// app.js\n// We want this to run as soon as possible to minimize\n// flashes with the old theme in some situations\nconst storedTheme = window.localStorage.getItem('backpexTheme')\nif (storedTheme != null) {\n  document.documentElement.setAttribute('data-theme', storedTheme)\n}\n\nconst Hooks = {}\n\nHooks.BackpexThemeSelector = {\n  mounted () {\n    const form = document.querySelector('#backpex-theme-selector-form')\n    const storedTheme = window.localStorage.getItem('backpexTheme')\n\n    // Marking current theme as active\n    if (storedTheme != null) {\n      const activeThemeRadio = form.querySelector(\n        `input[name='theme-selector'][value='${storedTheme}']`\n      )\n      activeThemeRadio.checked = true\n    }\n\n    // Event listener that handles the theme changes and store\n    // the selected theme in the session and also in localStorage\n    window.addEventListener('backpex:theme-change', async (event) => {\n      const cookiePath = form.dataset.cookiePath\n      const selectedTheme = form.querySelector(\n        'input[name=\"theme-selector\"]:checked'\n      )\n      if (selectedTheme) {\n        window.localStorage.setItem('backpexTheme', selectedTheme.value)\n        document.documentElement.setAttribute(\n          'data-theme',\n          selectedTheme.value\n        )\n        await fetch(cookiePath, {\n          body: `select_theme=${selectedTheme.value}`,\n          method: 'POST',\n          headers: {\n            'Content-type': 'application/x-www-form-urlencoded',\n            'x-csrf-token': csrfToken\n          }\n        })\n      }\n    })\n  }\n}\n\nlet liveSocket = new LiveSocket(\"/live\", Socket, {\n  hooks: Hooks,\n  dom: {\n    onBeforeElUpdated (from, to) {\n      if (from._x_dataStack) {\n        window.Alpine.clone(from, to);\n      }\n    },\n  },\n  params: { _csrf_token: csrfToken },\n});\n```","ref":"installation.html#set-daisyui-theme"},{"type":"extras","title":"Remove `@tailwindcss/forms` plugin - Installation","doc":"There is a conflict between the `@tailwindcss/forms` plugin and daisyUI. You should remove the `@tailwindcss/forms` plugin from your `tailwind.config.js` to prevent styling issues.\n\n```js\n// tailwind.config.js\nmodule.exports = {\n  ...\n  plugins: [\n    ...\n    // remove this line\n    // require('@tailwindcss/forms'),\n  ],\n}\n```\n\nIf your application depends on the `@tailwindcss/forms` plugin, you can keep the plugin and [change the strategy to `'class'`](https://github.com/tailwindlabs/tailwindcss-forms?tab=readme-ov-file#using-only-global-styles-or-only-classes). This will prevent the plugin from conflicting with daisyUI. Note that you then have to add the form classes provided by the `@tailwindcss/forms` plugin to your inputs manually.","ref":"installation.html#remove-tailwindcss-forms-plugin"},{"type":"extras","title":"Provide Tailwind Plugin for heroicons - Installation","doc":"Backpex uses the [heroicons](https://heroicons.com/) icon set. Backpex provides a `Backpex.HTML.CoreComponents.icon/1` component, but you need to provide the icons and a Tailwind CSS plugin to generate the necessary styles to display them. If you generated your Phoenix project with the latest version of the `mix phx.new` generator, you already have the dependency and plugin installed. If not, follow the steps below.","ref":"installation.html#provide-tailwind-plugin-for-heroicons"},{"type":"extras","title":"Track the heroicons GitHub repository - Installation","doc":"Track the heroicons GitHub repository with Mix:\n\n```elixir\ndef deps do\n  [\n    ...\n    {:heroicons,\n      github: \"tailwindlabs/heroicons\",\n      tag: \"v2.1.1\",\n      sparse: \"optimized\",\n      app: false,\n      compile: false,\n      depth: 1}\n  ]\nend\n```\n\nThis will add the heroicons repository as a dependency to your project. You can find the optimized SVG icons in the `deps/heroicons` directory.","ref":"installation.html#track-the-heroicons-github-repository"},{"type":"extras","title":"Add the Tailwind CSS plugin - Installation","doc":"Add the following plugin to your `tailwind.config.js` to generate the necessary styles to display the icons.\n\n```js\n// add fs and path to the top of the file\nconst fs = require('fs')\nconst path = require('path')\n\nmodule.exports = {\n  ...\n  plugins: [\n    ...\n    // add this plugin\n    plugin(function ({ matchComponents, theme }) {\n      let iconsDir = path.join(__dirname, \"../deps/heroicons/optimized\")\n      let values = {}\n      let icons = [\n        [\"\", \"/24/outline\"],\n        [\"-solid\", \"/24/solid\"],\n        [\"-mini\", \"/20/solid\"],\n        [\"-micro\", \"/16/solid\"]\n      ]\n      icons.forEach(([suffix, dir]) => {\n        fs.readdirSync(path.join(iconsDir, dir)).forEach(file => {\n          let name = path.basename(file, \".svg\") + suffix\n          values[name] = { name, fullPath: path.join(iconsDir, dir, file) }\n        })\n      })\n      matchComponents({\n        \"hero\": ({ name, fullPath }) => {\n          let content = fs.readFileSync(fullPath).toString().replace(/\\r?\\n|\\r/g, \"\")\n          let size = theme(\"spacing.6\")\n          if (name.endsWith(\"-mini\")) {\n            size = theme(\"spacing.5\")\n          } else if (name.endsWith(\"-micro\")) {\n            size = theme(\"spacing.4\")\n          }\n          return {\n            [`--hero-${name}`]: `url('data:image/svg+xml;utf8,${content}')`,\n            \"-webkit-mask\": `var(--hero-${name})`,\n            \"mask\": `var(--hero-${name})`,\n            \"mask-repeat\": \"no-repeat\",\n            \"background-color\": \"currentColor\",\n            \"vertical-align\": \"middle\",\n            \"display\": \"inline-block\",\n            \"width\": size,\n            \"height\": size\n          }\n        }\n      }, { values })\n    })\n  ],\n}\n```\n\nThis plugin will generate the necessary styles to display the heroicons in your application. You can now use the `Backpex.HTML.CoreComponents.icon/1` component to render the icons in your application.\n\nFor example, to render the `user` icon, you can use the following code:\n\n```elixir\n \n```","ref":"installation.html#add-the-tailwind-css-plugin"},{"type":"extras","title":"What is a LiveResource?","doc":"# What is a LiveResource?\n\nWhen refer to a *LiveResource* in Backpex, we are talking about a module that contains the configuration for a resource. This module is responsible for defining the resource's schema, the actions that can be performed on it, and the fields that will be rendered.\n\nIn the documentation, we also talk about the resource configuration file. With this, we refer to the module that implements the `Backpex.LiveResource` behavior. This is a Backpex *LiveResource* module.","ref":"what-is-a-live-resource.html"},{"type":"extras","title":"Templates","doc":"# Templates\n\nYou can customize certain template parts of Backpex. While you can only use our app shell layout, you can also define functions to provide additional templates to be rendered on the resource LiveView or completely overwrite certain parts like the header or main content.\n\nSee [render_resource_slot/3](Backpex.LiveResource.html#c:render_resource_slot/3) for supported positions.","ref":"templates.html"},{"type":"extras","title":"Configuration - Templates","doc":"To add a custom template to a resource, you need to implement the [render_resource_slot/3](Backpex.LiveResource.html#c:render_resource_slot/3) callback in your resource configuration file.\n\n```elixir\n# in your resource configuration file\n@impl Backpex.LiveResource\ndef render_resource_slot(assigns, :index, :before_main), do: ~H\"Hello World!\"\n```\n\nThe example above will render the string \"Hello World!\" before the main content of the index view.","ref":"templates.html#configuration"},{"type":"extras","title":"Item Query","doc":"# Item Query\n\nIt is possible to manipulate the query when fetching resources for `index`, `show` and `edit` view.\n\nIn all queries we define a `from` query with a named binding to fetch all existing resources on `index` view or a specific resource on `show` / `edit` view.\nAfter that, we call the `item_query` function. By default it returns the incoming query.\n\nThe `item_query` function makes it easy to add custom query expressions.","ref":"item-query.html"},{"type":"extras","title":"Configuration - Item Query","doc":"To add a custom query to a resource, you need to implement the [item_query/3](Backpex.LiveResource.html#c:item_query/3) callback in your resource configuration file:\n\n```elixir\n# in your resource configuration file\n\n@impl Backpex.LiveResource\ndef item_query(query, :index, _assigns) do\nquery\n|> where([post], post.published)\nend\n```\n\nThe example above will filter all posts by a published boolean on `index` view. We also made use of the named binding. It's always the name of the provided schema in `snake_case`. It is recommended to build your `item_query` on top of the incoming query. Otherwise you will likely get binding errors.","ref":"item-query.html#configuration"},{"type":"extras","title":"Ordering","doc":"# Ordering\n\nYou can configure the ordering of the resource index page. By default, the resources are ordered by the `id` field in ascending order.","ref":"ordering.html"},{"type":"extras","title":"Configuration - Ordering","doc":"To configure the ordering of the resource index page, you need to provide an `init_order` option in the resource configuration file:\n\n```elixir\n# in your resource configuration file\n\nuse Backpex.LiveResource,\n    ...,\n    init_order: %{by: :inserted_at, direction: :desc}\n```\n\nThe example above will order the resources by the `inserted_at` field in descending order.","ref":"ordering.html#configuration"},{"type":"extras","title":"Hooks","doc":"# Hooks\n\nYou may define hooks that are called before their respective action. Those hooks are `on_item_created`, `on_item_updated` and `on_item_deleted`.\n\n> #### Info {: .info}\n>\n> Note that the hooks are called after the changes have been persisted to the database.","ref":"hooks.html"},{"type":"extras","title":"Configuration - Hooks","doc":"To add a hook to a resource, you need to implement the [on_item_created/2](Backpex.LiveResource.html#c:on_item_created/2), [on_item_updated/2](Backpex.LiveResource.html#c:on_item_updated/2) or [on_item_deleted/2](Backpex.LiveResource.html#c:on_item_deleted/2) callback in your resource configuration file.\n\n```elixir\n# in your resource configuration file\n\n@impl Backpex.LiveResource\ndef on_item_created(socket, item) do\n    # do something\n    socket\nend\n```\n\nThe example above will call the `on_item_created` hook after an item has been created.","ref":"hooks.html#configuration"},{"type":"extras","title":"Navigation","doc":"# Navigation\n\n\nBy default Backpex redirects to the index page after creating or updating an item. You can customize this behavior.","ref":"navigation.html"},{"type":"extras","title":"Configuration - Navigation","doc":"To define a custom navigation path, you need to implement the [return_to/4](Backpex.LiveResource.html#c:return_to/4) callback in your resource configuration file:\n\n```elixir\n# in your resource configuration file\n\n@impl Backpex.LiveResource\ndef return_to(socket, assigns, live_action, item) do\n    ~p\"/home\"\nend\n```\n\nThe example above will redirect to the `/home` path after saving an item.","ref":"navigation.html#configuration"},{"type":"extras","title":"Panels","doc":"# Panels\n\nYou can define panels to group certain fields together. Panels are displayed in the provided order.","ref":"panels.html"},{"type":"extras","title":"Configuration - Panels","doc":"To add panels to a resource, you need to implement the [panels/0](Backpex.LiveResource.html#c:panels/0) callback in your resource configuration file. It has to return a keyword list with an identifier and label for each panel.\n\n```elixir\n\n# in your resource configuration file\n@impl Backpex.LiveResource\ndef panels do\n  [\n    contact: \"Contact\"\n  ]\nend\n```\n\nThe example above will define a panel with the identifier `contact` and the label `Contact`.","ref":"panels.html#configuration"},{"type":"extras","title":"Usage - Panels","doc":"You can move fields into panels with the `panel` field configuration that has to return the identifier of the corresponding panel. Fields without a panel are displayed in the `:default` panel. The `:default` panel has no label.\n\n```elixir\n# in your fields list\n@impl Backpex.LiveResource\ndef fields do\n  [\n    %{\n      ...,\n      panel: :contact\n    }\n  ]\nend\n```\n\nThe example above will move the field into the `contact` panel.\n\n> #### Info {: .info}\n>\n> Note that a panel is not displayed when there are no fields in it.","ref":"panels.html#usage"},{"type":"extras","title":"Fluid Layout","doc":"# Fluid Layout\n\nBackpex provides a way to create a fluid layout. A fluid layout is a layout that fills the entire width of the screen. This layout is useful for applications that need to display a lot of content on the screen.\n\n> #### Information {: .info}\n>\n> The  `fluid?` options requires you to pass the `fluid?` assign to the `Backpex.HTML.Layout.app_shell/1` component in your layout file. See the [Create layout](get_started/installation.md#create-layout) documentation for more information.","ref":"fluid-layout.html"},{"type":"extras","title":"Configure LiveResource - Fluid Layout","doc":"To create a fluid layout, you need to set the `fluid?` option in a `LiveResource` to `true`. \n\n```elixir\n# in your LiveResource module\ndefmodule MyAppWeb.Live.UserLive do\n  use Backpex.LiveResource, fluid?: true\nend\n```","ref":"fluid-layout.html#configure-liveresource"},{"type":"extras","title":"Listen to PubSub Events","doc":"# Listen to PubSub Events\n\nAs mentioned in the [installation guide](get_started/installation.md) you need to configure PubSub for your *LiveResources*. Backpex will use the configuration to publish `deleted`, `updated` and `created` events. Backpex will listen to these events and update the UI accordingly. Sometimes you may want to listen to these events and perform some custom actions. For example you want to show a toast to all users currently on the resource that a post has been created.","ref":"listen-to-pubsub-events.html"},{"type":"extras","title":"Configuration - Listen to PubSub Events","doc":"You can listen for Backpex PubSub events by implementing the Phoenix.LiveView [`handle_info/2`](Phoenix.LiveView.html#c:handle_info/2) callback in your *LiveResource* module.\n\nWe assume you configured PubSub for your Posts *LiveResource* like this:\n\n```elixir\nuse Backpex.LiveResource,\n    ...,\n    pubsub: Demo.PubSub\n    topic: \"posts\",\n    event_prefix: \"post_\"\n```\n\nYou could implement the following `handle_info/2` callbacks in your *LiveResource*:\n\n```elixir\n# in your resource configuration file\n\n@impl Phoenix.LiveView\ndef handle_info({\"post_created\", item}, socket) do\n    # make something in response to the event\n    {:noreply, socket}\nend\n\n@impl Phoenix.LiveView\ndef handle_info({\"post_updated\", item}, socket) do\n    # make something in response to the event\n    {:noreply, socket}\nend\n\n@impl Phoenix.LiveView\ndef handle_info({\"post_deleted\", item}, socket) do\n    # make something in response to the event\n    {:noreply, socket}\nend\n```","ref":"listen-to-pubsub-events.html#configuration"},{"type":"extras","title":"Additional classes for index table rows","doc":"# Additional classes for index table rows\n\nYou can add additional classes to table rows on the index view. This allows you, for example, to color the rows.","ref":"additional-classes-for-index-table-rows.html"},{"type":"extras","title":"Configuration - Additional classes for index table rows","doc":"To add additional classes to table rows on the index view, you need to implement the [index_row_class/4](Backpex.LiveResource.html#c:index_row_class/4) callback in your resource configuration file.\n\n```elixir\n# in your resource configuration file\n\n@impl Backpex.LiveResource\ndef index_row_class(assigns, item, selected, index), do: \"bg-yellow-100\"\n```\n\nThe example above will add the `bg-yellow-100` class to all table rows on the index view.\n\n> #### Info {: .warning}\n>\n> Note that we call the function twice. Once for the row on the `tr` element and a second time for the item action overlay, because in most cases the overlay should have the same style applied.","ref":"additional-classes-for-index-table-rows.html#configuration"},{"type":"extras","title":"What is a Field?","doc":"# What is a Field?\n\nBackpex fields are the building blocks of a resource. They define the data that will be displayed and manipulated in the resource views. Fields can be of different types, such as text, number, date, and select. Each field type has its own configuration options and behavior. Typically, you want to configure a field for each type of data you want to display in your resource.\n\nBackpex ships with a set of built-in field types, but you can also create custom fields to fit your specific needs.","ref":"what-is-a-field.html"},{"type":"extras","title":"Built-in Field Types - What is a Field?","doc":"Backpex provides the following built-in field types:\n\n- `Backpex.Fields.BelongsTo`\n- `Backpex.Fields.Boolean`\n- `Backpex.Fields.Currency`\n- `Backpex.Fields.DateTime`\n- `Backpex.Fields.Date`\n- `Backpex.Fields.HasManyThrough`\n- `Backpex.Fields.HasMany`\n- `Backpex.Fields.InlineCRUD`\n- `Backpex.Fields.MultiSelect`\n- `Backpex.Fields.Number`\n- `Backpex.Fields.Select`\n- `Backpex.Fields.Text`\n- `Backpex.Fields.Textarea`\n- `Backpex.Fields.Upload`\n- `Backpex.Fields.URL`\n\nYou can click on each field type to see its documentation and configuration options.","ref":"what-is-a-field.html#built-in-field-types"},{"type":"extras","title":"Configuration - What is a Field?","doc":"To define fields for a resource, you need to implement the [`fields/0`](Backpex.LiveResource.html#c:fields/0) callback in your resource module. This function must return a list of field configurations.\n\n```elixir\n@impl Backpex.LiveResource\ndef fields do\n  [\n    username: %{\n      module: Backpex.Fields.Text,\n      label: \"Username\"\n    },\n    age: %{\n      module: Backpex.Fields.Number,\n      label: \"Age\"\n    }\n  ]\nend\n```\n\nThe example above will define two fields: `username` and `age`. Both fields use the built-in field types `Backpex.Fields.Text` and `Backpex.Fields.Number`, respectively.","ref":"what-is-a-field.html#configuration"},{"type":"extras","title":"Field Configuration - What is a Field?","doc":"Each field configuration must contain the following keys:\n\n- `module`: The module that implements the field behavior.\n- `label`: The label that will be displayed for the field.\n\nIn addition to these keys, you can configure each field with additional options specific to the field type. For example, a text field can have a `placeholder` option to set a placeholder text for the input field.\n\n```elixir\n@impl Backpex.LiveResource\ndef fields do\n  [\n    username: %{\n      module: Backpex.Fields.Text,\n      label: \"Username\",\n      placeholder: \"Enter your username\"\n    }\n  ]\nend\n```\n\nThe example above will set the placeholder `\"Enter your username\"` for the `username` field.\n\nThe following sections will cover general field options and how to create custom fields.","ref":"what-is-a-field.html#field-configuration"},{"type":"extras","title":"Custom Fields","doc":"# Custom Fields\n\nBackpex ships with a set of default fields that can be used to create content types. See [Built-in Field Types](what-is-a-field.md#built-in-field-types) for a complete list of the default fields. In addition to the default fields, you can create custom fields for more advanced use cases.\n\nWhen creating your own custom field, you can use the `field` macro from the `BackpexWeb` module. It automatically implements the `Backpex.Field` behavior and defines some aliases and imports.\n\n> #### Information {: .info}\n>\n> A field has to be a [LiveComponent](https://hexdocs.pm/phoenix_live_view/Phoenix.LiveComponent.html).","ref":"custom-fields.html"},{"type":"extras","title":"Creating a Custom Field - Custom Fields","doc":"The simplest version of a custom field would look like this:\n\n```elixir\nuse BackpexWeb, :field\n\n@impl Backpex.Field\ndef render_value(assigns) do\n~H\"\"\"\n \n    <%= HTML.pretty_value(@value) %>\n \n\"\"\"\nend\n\n@impl Backpex.Field\ndef render_form(assigns) do\n~H\"\"\"\n \n     \n    <:label>\n         \n    </:label>\n     \n     \n \n\"\"\"\nend\n```\n\nThe `render_value/1` function returns markup that is used to display a value on `index` and `show` views.\nThe `render_form/1` function returns markup that is used to render a form on `edit` and `new` views.\n\nSee `Backpex.Field` for more information on the available callback functions. For example, you can implement `render_index_form/1` to make the field editable in the index view.","ref":"custom-fields.html#creating-a-custom-field"},{"type":"extras","title":"Alignment","doc":"# Alignment\n\nIt is possible to align the fields of a resource in the index view and the labels of the fields in the edit view.","ref":"alignment.html"},{"type":"extras","title":"Field Alignment (Index View) - Alignment","doc":"You can align the fields of a resource in the index view by setting the `align` option in the field configuration.\n\nThe following alignments are supported: `:left`, `:center` and `:right`\n\n```elixir\n# in your resource configuration file\n\n@impl Backpex.LiveResource\ndef fields do\n[\n    %{\n        ...,\n        align: :center\n    }\n]\nend\n```\n\nThe example above will align the field to the center in the index view.","ref":"alignment.html#field-alignment-index-view"},{"type":"extras","title":"Label Alignment (Edit View) - Alignment","doc":"You can align the labels of the fields in the edit view by setting the `label_align` option in the field configuration.\n\nThe following label orientations are supported: `:top`, `:center` and `:bottom`.\n\n```elixir\n# in your resource configuration file\n@impl Backpex.LiveResource\ndef fields do\n[\n    %{\n        ...,\n        align_label: :top\n    }\n]\nend\n```\n\nThe example above will align the label to the top in the edit view.","ref":"alignment.html#label-alignment-edit-view"},{"type":"extras","title":"Visibility","doc":"# Visibility\n\nYou can change the visibility of fields in certain views.","ref":"visibility.html"},{"type":"extras","title":"Visibility with `only` and `except` - Visibility","doc":"You can use the `only` and `except` options to define the views where a field should be visible. The `only` option will show the field only in the specified views, while the `except` option will show the field in all views except the specified ones. The options have to be a list of view names.\n\nThe following values are supported: `:new`, `:edit`, `:show`, `:index` and `:resource_action`.\n\n```elixir\n# in your resource configuration file\n@impl Backpex.LiveResource\ndef fields do\n[\n    likes: %{\n        module: Backpex.Fields.Number,\n        label: \"Likes\",\n        only: [:show, :edit]\n    }\n]\nend\n```\n\nThe example above will show the `likes` field only in the show and edit views.\n\n```elixir\n# in your resource configuration file\n@impl Backpex.LiveResource\ndef fields do\n[\n    likes: %{\n        module: Backpex.Fields.Number,\n        label: \"Likes\",\n        except: [:new]\n    }\n]\nend\n```\n\nThe example above will show the `likes` field in all views except the new view.","ref":"visibility.html#visibility-with-only-and-except"},{"type":"extras","title":"Visibility with `visible` - Visibility","doc":"> #### Important {: .info}\n>\n> Note that the option `visible` is only available for the show and edit views.\n\nTo change the visibility of a field, you can also set the `visible` option in the field configuration. The `visible` option has to return a function that receives the assigns and returns a boolean value.\n\n```elixir\n# in your resource configuration file\n@impl Backpex.LiveResource\ndef fields do\n[\n    likes: %{\n        module: Backpex.Fields.Number,\n        label: \"Likes\",\n        visible: fn assigns ->\n            assigns.current_user.role in [:admin]\n        end\n    }\n]\nend\n```\n\nThe example above will show the `likes` field only to users with the `admin` role.\n\n\n> #### Warning {: .warning}\n>\n> Note that hidden fields are not exempt from validation by Backpex itself and the visible function is not executed on `:index`.","ref":"visibility.html#visibility-with-visible"},{"type":"extras","title":"Visibility with `can?` - Visibility","doc":"In addition to the `visible` option, we provide a `can?` option that you can use to determine the visibility of a field.\n\nIt can also be used on `:index`. It takes the `assigns` as a parameter and has to return a boolean value.\n\n```elixir\n# in your resource configuration file\n@impl Backpex.LiveResource\ndef fields do\n[\n    inserted_at: %{\n        module: Backpex.Fields.DateTime,\n        label: \"Created At\",\n        can?: fn\n            %{live_action: :show} = _assigns ->\n            true\n\n            _assigns ->\n            false\n        end\n    }\n]\nend\n```\n\nAlso see the [field authorization](/guides/authorization/field-authorization.md) guide.","ref":"visibility.html#visibility-with-can"},{"type":"extras","title":"Advanced Example - Visibility","doc":"Imagine you want to implement a checkbox in order to toggle an input field (post likes). The input field should be visible when it has a certain value (post likes > 0).\n\n```elixir\n# in your resource configuration file\n@impl Backpex.LiveResource\ndef fields do\n[\n    # show_likes is a virtual field in the post schema\n    show_likes: %{\n        module: Backpex.Fields.Boolean,\n        label: \"Show likes\",\n        # initialize the button based on the likes value\n        select: dynamic([post: p], fragment(\"? > 0\", p.likes)),\n    },\n    likes: %{\n        module: Backpex.Fields.Number,\n        label: \"Likes\",\n        # display the field based on the `show_likes` value\n        # the value can be part of the changeset or item (when edit view is opened initially).\n        visible: fn\n            %{live_action: :new} = assigns ->\n            Map.get(assigns.changeset.changes, :show_likes)\n\n            %{live_action: :edit} = assigns ->\n            Map.get(assigns.changeset.changes, :show_likes, Map.get(assigns.item, :show_likes, false))\n\n            _assigns ->\n            true\n        end\n    }\n]\nend\n```","ref":"visibility.html#advanced-example"},{"type":"extras","title":"Defaults","doc":"# Defaults\n\nYou can assign default values to fields in your resource configuration file. This is useful when you want to provide a default value for a field that is not required.","ref":"defaults.html"},{"type":"extras","title":"Configuration - Defaults","doc":"To define a default value for a field, you need to set the `default` option in the field configuration. The `default` option has to return a function that receives the assigns and returns the default value.\n\n```elixir\n# in your resource configuration file\n@impl Backpex.LiveResource\ndef fields do\n[\n    username: %{\n        default: fn _assigns -> \"Default Username\" end\n    }\n]\nend\n```\n\nThe example above will assign the default value `\"Default Username\"` to the `username` field.","ref":"defaults.html#configuration"},{"type":"extras","title":"Readonly","doc":"# Readonly\n\nFields can be configured to be readonly. In edit view, these fields are rendered with the additional HTML attributes `readonly` and `disabled`, ensuring that the user cannot interact with the field or change its value.\n\nIn index view, if readonly and index editable is set to `true`, forms will be rendered with the `readonly` HTML attribute.","ref":"readonly.html"},{"type":"extras","title":"Supported fields - Readonly","doc":"On index view, read-only is supported for all fields with the index editable option (see [Index Edit](index-edit.md)).\n\nOn edit view, read-only is supported for:\n- `Backpex.Fields.Date`\n- `Backpex.Fields.DateTime`\n- `Backpex.Fields.Number`\n- `Backpex.Fields.Text`\n- `Backpex.Fields.Textarea`","ref":"readonly.html#supported-fields"},{"type":"extras","title":"Configuration - Readonly","doc":"To enable read-only for a field, you need to set the `readonly` option to `true` in the field configuration. This key must contain either a boolean value or a function that returns a boolean value.\n\n```elixir\n# in your resource configuration file\ndef fields do\n[\n    rating: %{\n        module: Backpex.Fields.Text,\n        label: \"Rating\",\n        readonly: fn assigns ->\n            assigns.current_user.role in [:employee]\n        end\n    }\n]\nend\n```\n\n```elixir\n# in your resource configuration file\ndef fields do\n[\n    rating: %{\n        module: Backpex.Fields.Text,\n        label: \"Rating\",\n        readonly: true\n    }\n]\nend\n```","ref":"readonly.html#configuration"},{"type":"extras","title":"Readonly for custom fields - Readonly","doc":"You can also add readonly functionality to a custom field. To do this, you need to define a [`render_form_readonly/1`](Backpex.Field.html#c:render_form_readonly/1) function. This function must return markup to be used when readonly is enabled.\n\n```elixir\n@impl Backpex.Field\ndef render_form_readonly(assigns) do\n~H\"\"\"\n \n     \n        <:label>\n             \n        </:label>\n         \n     \n \n\"\"\"\nend\n```\n\nWhen defining a custom field with index editable support, you need to handle the readonly state in the index editable markup. There is a `readonly` value in the assigns, which will be `true` or `false`.","ref":"readonly.html#readonly-for-custom-fields"},{"type":"extras","title":"Custom Alias","doc":"# Custom Alias\n\nBackpex automatically generates aliases for queries in your fields. However, if you try to add two `Backpex.Field.BelongsTo` fields of the same association, you will encounter an error indicating that the alias is already in use by another field. To resolve this issue, Backpex allows the assignment of custom aliases to fields, eliminating naming conflicts in queries.","ref":"custom-alias.html"},{"type":"extras","title":"Configuration - Custom Alias","doc":"To use a custom alias, define the `custom_alias` key in your field configuration. The value of the `custom_alias` key must be a unique atom that is not already in use by another field.\n\n\n```elixir\n@impl Backpex.LiveResource\ndef fields do\n[\n    second_category: %{\n        module: Backpex.Fields.BelongsTo,\n        label: \"Second Category\",\n        display_field: :name,\n        searchable: true,\n        custom_alias: :second_category,\n        select: dynamic([second_category: sc], sc.name)\n    },\n]\nend\n```\n\nThe example above will assign the alias `:second_category` to the `second_category` field. This alias can now be used in queries without causing conflicts with other fields.","ref":"custom-alias.html#configuration"},{"type":"extras","title":"Placeholder","doc":"# Placeholder\n\nYou can configure a placeholder for form fields. The placeholder will be displayed in the input field when the field is empty.\n\n> #### Important {: .info}\n>\n> Note that the option only works for input fields that are **not** type `textarea`, `select`, `toggle` or `checkbox`.\n>","ref":"placeholder.html"},{"type":"extras","title":"Configuration - Placeholder","doc":"To set a placeholder for a field, you need to set the `placeholder` option in the field configuration. The `placeholder` either has to be a string or a function that receives the assigns and returns the placeholder string.\n\n```elixir\n# in your resource configuration file\n@impl Backpex.LiveResource\ndef fields do\n[\n    username: %{\n        module: Backpex.Fields.Text,\n        label: \"Username\",\n        placeholder: \"Enter your username\"\n    }\n]\nend\n```\n\nThe example above will set the placeholder `\"Enter your username\"` for the `username` field.","ref":"placeholder.html#configuration"},{"type":"extras","title":"Debounce and Throttle","doc":"# Debounce and Throttle\n\nYou can debounce and throttle the input of a field in the edit view. This is useful when you want to reduce the number of requests sent to the server.","ref":"debounce-and-throttle.html"},{"type":"extras","title":"Configuration - Debounce and Throttle","doc":"To enable debounce or throttle for a field, you need to set the `debounce` or `throttle` option in the field configuration.\n\n- `debounce`: Has to return either an integer timeout value (in milliseconds), or \"blur\". When an integer is provided, emitting the event is delayed by the specified milliseconds. When \"blur\" is provided, emitting the event is delayed until the field is blurred by the user.\n- `throttle`: Has to return an integer timeout value (in milliseconds). The event is emitted at most once every specified milliseconds.\n\nSee Phoenix LiveView documentation for more information on [debouncing and throttling](https://hexdocs.pm/phoenix_live_view/bindings.html#rate-limiting-events-with-debounce-and-throttle).\n\nThe options can be set to a function that receives the assigns and returns the debounce or throttle value or a static value.\n\n```elixir\n# in your resource configuration file\n@impl Backpex.LiveResource\ndef fields do\n[\n    username: %{\n        module: Backpex.Fields.Text,\n        label: \"Username\",\n        debounce: 500\n    }\n]\nend\n```\n\nThe example above will debounce the input of the `username` field by 500 milliseconds.\n\n```elixir\n# in your resource configuration file\n@impl Backpex.LiveResource\ndef fields do\n[\n    username: %{\n        module: Backpex.Fields.Text,\n        label: \"Username\",\n        debounce: fn _assigns -> 500 end\n    }\n]\nend\n```\n\nThe example above will debounce the input of the `username` field by 500 milliseconds.\n\n```elixir\n# in your resource configuration file\n@impl Backpex.LiveResource\ndef fields do\n[\n    username: %{\n        module: Backpex.Fields.Text,\n        label: \"Username\",\n        debounce: \"blur\"\n    }\n]\nend\n```\n\nThe example above will debounce the input of the `username` field until the field is blurred by the user.\n\n```elixir\n# in your resource configuration file\n@impl Backpex.LiveResource\ndef fields do\n[\n    username: %{\n        module: Backpex.Fields.Text,\n        label: \"Username\",\n        throttle: 500\n    }\n]\nend\n```\n\nThe example above will throttle the input of the `username` field by 500 milliseconds.\n\n```elixir\n# in your resource configuration file\n@impl Backpex.LiveResource\ndef fields do\n[\n    username: %{\n        module: Backpex.Fields.Text,\n        label: \"Username\",\n        throttle: fn _assigns -> 500 end\n    }\n]\nend\n```\n\nThe example above will throttle the input of the `username` field by 500 milliseconds.","ref":"debounce-and-throttle.html#configuration"},{"type":"extras","title":"Index Edit","doc":"# Index Edit\n\nA small number of fields support index editable. These fields can be edited inline on the index view.","ref":"index-edit.html"},{"type":"extras","title":"Configuration - Index Edit","doc":"To enable index editable for a field, you need to set the `index_editable` option to `true` in the field configuration.\n\n```elixir\n# in your resource configuration file\ndef fields do\n[\n    name: %{\n        module: Backpex.Fields.Text,\n        label: \"Name\",\n        index_editable: true\n    }\n]\nend\n```\n\nThe example above will enable index editable for the `name` text field.","ref":"index-edit.html#configuration"},{"type":"extras","title":"Supported fields - Index Edit","doc":"- `Backpex.Fields.BelongsTo`\n- `Backpex.Fields.Date`\n- `Backpex.Fields.DateTime`\n- `Backpex.Fields.Number`\n- `Backpex.Fields.Select`\n- `Backpex.Fields.Text`","ref":"index-edit.html#supported-fields"},{"type":"extras","title":"Custom index editable implementation - Index Edit","doc":"You can add index editable support to your custom fields by defining the [render_index_form/1](Backpex.Field.html#c:render_index_form/1) function and enabling index editable for your field.","ref":"index-edit.html#custom-index-editable-implementation"},{"type":"extras","title":"Error Customization","doc":"# Error Customization\n\nYou can customize the error messages for each field in your resource configuration file.","ref":"error-customization.html"},{"type":"extras","title":"Configuration - Error Customization","doc":"To customize the error messages for a field, you need to define a `translate_error/1` function in the field configuration. The function receives the error tuple and must return a tuple with the message and metadata.\n\n```elixir\n@impl Backpex.LiveResource\ndef fields do\n[\n    number: %{\n        module: Backpex.Fields.Number,\n        label: \"Number\",\n        translate_error: fn\n            {_msg, [type: :integer, validation: :cast] = metadata} = _error ->\n                {\"has to be a number\", metadata}\n\n            error ->\n                error\n        end\n    }\n]\nend\n```\n\nThe example above will return the message `\"has to be a number\"` when the input is not a number.","ref":"error-customization.html#configuration"},{"type":"extras","title":"Computed Fields","doc":"# Computed Fields\n\nIn some cases you want to compute new fields based on existing fields. Backpex adds a way to support this.","ref":"computed-fields.html"},{"type":"extras","title":"Configuration - Computed Fields","doc":"There is a `select` option you may add to a field. This option has to return a `dynamic`. This query will then be executed to select fields when listing your resources. In addition this query will also be used to order / search this field.\n\n```elixir\n# in your resource configuration file\n\n@impl Backpex.LiveResource\ndef fields do\n[\n    total: %{\n        module: Backpex.Fields.Integer,\n        label: \"Total\",\n        select: dynamic([post: p], fragment(\"likes + dislikes\")),\n    }\n]\nend\n```\n\nThe example above will compute the value of the total field based on the `likes` and `dislikes` fields.","ref":"computed-fields.html#configuration"},{"type":"extras","title":"Example - Computed Fields","doc":"Imagine there is a user table with `first_name` and `last_name`. Now, on your index view you want to add a column to display the `full_name`. You could create a generated column in you database, but there are several reasons for not adding generated columns for all computed fields you want to display in your application.\n\nYou can display the `full_name` of your users by adding the following field to the resource configuration file.\n\n```elixir\n# in your resource configuration file\n\n@impl Backpex.LiveResource\ndef fields do\n[\n    full_name: %{\n        module: Backpex.Fields.Text,\n        label: \"Full Name\",\n        searchable: true,\n        except: [:edit],\n        select: dynamic([user: u], fragment(\"concat(?, ' ', ?)\", u.first_name, u.last_name))\n    }\n]\nend\n```\n\nWe are using a database fragment to build the `full_name` based on the `first_name` and `last_name` of an user. Backpex will select this field when listing resources automatically. Ordering and searching works the same like on all other fields, because Backpex uses the query you provided in the `dynamic` in order / search queries, too.\n\nWe recommend to display this field on `index` and `show` view only.\n\n> #### Important {: .info}\n>\n> Note: You are required to add a virtual field `full_name` to your user schema. Otherwise, Backpex is not able to select this field.","ref":"computed-fields.html#example"},{"type":"extras","title":"Computed Fields with Associations - Computed Fields","doc":"Computed fields also work with associations.\n\nFor example, you are able to add a `select` query to a `Backpex.Field.BelongsTo` field.\n\nImagine you want to display a list of posts with the corresponding authors (users). The user column should be a `full_name` computed by the `first_name` and `last_name`:\n\n```elixir\n# in your resource configuration file\n\n@impl Backpex.LiveResource\ndef fields do\n[\n    user: %{\n        module: Backpex.Fields.BelongsTo,\n        label: \"Full Name\",\n        display_field: :full_name,\n        select: dynamic([user: u], fragment(\"concat(?, ' ', ?)\", u.first_name, u.last_name)),\n        options_query: fn query, _assigns ->\n            query |> select_merge([user], %{full_name: fragment(\"concat(?, ' ', ?)\", user.first_name, user.last_name)})\n        end\n    }\n]\nend\n```\n\nWe recommend to add a `select_merge` to the `options_query` where you select the same field. Otherwise, displaying the same values in the select form on edit page will not work.\n\nDo not forget to add the virtual field `full_name` to your user schema in this example, too.","ref":"computed-fields.html#computed-fields-with-associations"},{"type":"extras","title":"What is a Filter?","doc":"# What is a Filter?\n\nFilters are used to filter the data that is being displayed in the (index) view. They are used to narrow down the data that is being displayed based on certain criteria.\n\nBackpex allows you to define filters for your *LiveResources*. Backpex handles the filtering of the data for you as well as the UI for the filters. You just need to define the filters and Backpex will take care of the rest.\n\nBackpex ships with a set of default filters that can be used to filter the data. In addition to the default filters, you can create custom filters for more advanced use cases.","ref":"what-is-a-filter.html"},{"type":"extras","title":"Built-in Filters - What is a Filter?","doc":"Backpex provides the following built-in filters:\n\n- `Backpex.Filters.Boolean`\n- `Backpex.Filters.Range`\n- `Backpex.Filters.Select`\n- `Backpex.Filters.MultiSelect`\n\nYou can click on each filter type to see its documentation and configuration options.\n\nWe will go through how to define filters for a *LiveResource* in [the next section](how-to-add-a-filter.md).","ref":"what-is-a-filter.html#built-in-filters"},{"type":"extras","title":"How to add a Filter?","doc":"# How to add a Filter?\n\nAdding a filter to your *LiveResource* is a two step process:","ref":"how-to-add-a-filter.html"},{"type":"extras","title":"Defining a Filter module - How to add a Filter?","doc":"First, you need to define a filter module that implements one of the behaviors from the `Backpex.Filters` namespace., This may be one of the [built-in filters](what-is-a-filter.md#built-in-filters) or a [custom filter](custom-filter.md).\n\nWe suggest to use a `MyAppWeb.Filters. ` convention.\n\nIf you want to add one of the built-in filters, you can click on the filter type in the list of [Built-in Filters](what-is-a-filter.md#built-in-filters) to see how to define a filter module for that filter type.\n\nFor example, the following example shows how to define a filter module for a select filter that filters posts based on a category:\n\n```elixir\ndefmodule MyAppWeb.Filters.PostCategorySelect do\n  use Backpex.Filters.Select\n\n  alias MyApp.Category\n  alias MyApp.Post\n  alias MyApp.Repo\n\n  @impl Backpex.Filter\n  def label, do: \"Category\"\n\n  @impl Backpex.Filters.Select\n  def prompt, do: \"Select category ...\"\n\n  @impl Backpex.Filters.Select\n  def options do\n    query =\n      from p in Post,\n        join: c in Category,\n        on: p.category_id == c.id,\n        distinct: c.name,\n        select: {c.name, c.id}\n\n    Repo.all(query)\n  end\nend\n```","ref":"how-to-add-a-filter.html#defining-a-filter-module"},{"type":"extras","title":"Adding the Filter to your LiveResource - How to add a Filter?","doc":"After you have defined the filter module, you need to add the filter to your *LiveResource*.\n\nTo do this, you need to define the filter in the [filters/0](Backpex.LiveResource.html#c:filters/0) callback in your *LiveResource* module.\n\nHere is an example of how to add a filter to your *LiveResource*:\n\n```elixir\n@impl Backpex.LiveResource\ndef filters, do: [\n    category_id: %{\n        module: MyAppWeb.Filters.PostCategorySelect,\n    }\n]\n```\n\nIn this example, we add a filter with the name `category_id` to the *LiveResource*. The filter uses the `MyAppWeb.Filters.PostCategorySelect` module we defined earlier.","ref":"how-to-add-a-filter.html#adding-the-filter-to-your-liveresource"},{"type":"extras","title":"Overwriting the Filter Label - How to add a Filter?","doc":"You can also overwrite the filter label defined in the filter label by adding a `label` key to the filter map:\n\n```elixir\n@impl Backpex.LiveResource\ndef filters, do: [\n    category_id: %{\n        module: MyAppWeb.Filters.PostCategorySelect,\n        label: \"Category\"\n    }\n]\n```","ref":"how-to-add-a-filter.html#overwriting-the-filter-label"},{"type":"extras","title":"Filter Presets","doc":"# Filter Presets\n\nBackpex allows you to define filter presets for your filters. Filter presets are used to define a set of filter configurations that can easily be applied to the data being displayed in the index view. Filter Presets consist of a name and a list of values that are used to filter the data. For example, you can define a filter preset for a date filter that filters the data based on the current month. Then the user can easily apply this filter by selecting the preset from the filter dropdown.","ref":"filter-presets.html"},{"type":"extras","title":"Defining a Filter Preset - Filter Presets","doc":"To define presets for your filters, you need to add a list of maps under the key of `:presets` to your filter in your LiveResource.\n\nEach of those maps has two keys:\n1. `:label` – the name of the preset shown to the user\n2. `:values` – a function with arity 0 that returns the values corresponding to your used filter\n\nSee the example below for some preset examples. We add a preset for a date filter that filters the data based on the last 7 days and a preset for a select filter that filters the data based on the published status of an event.\n\n```elixir\n@impl Backpex.LiveResource\ndef filters, do: [\n    begins_at: %{\n        module: MyAppWeb.Filters.DateRange,\n        label: \"Begins At\",\n        presets: [\n            %{\n                label: \"Last 7 Days\",\n                values: fn -> %{\n                    \"start\" => Date.add(Date.utc_today(), -7),\n                    \"end\" => Date.utc_today()\n                } end\n            }\n        ]\n    },\n    published: %{\n        module: MyAppWeb.Filters.EventPublished,\n        presets: [\n            %{\n                label: \"Both\",\n                values: fn -> [:published, :not_published] end\n            },\n            %{\n                label: \"Only published\",\n                values: fn -> [:published] end\n            }\n        ]\n    }\n]\n```","ref":"filter-presets.html#defining-a-filter-preset"},{"type":"extras","title":"Custom Filter","doc":"# Custom Filter\n\nBackpex ships with a set of default filters that can be used to filter the data. In addition to the default filters, you can create custom filters for more advanced use cases.","ref":"custom-filter.html"},{"type":"extras","title":"Creating a Custom Filter - Custom Filter","doc":"You can create a custom filter by using the `filter` macro from the `BackpexWeb` module.. It automatically implements the `Backpex.Filter` behavior and defines some aliases and imports.\n\nWhen creating a custom filter, you need to implement the following callbacks: `query/3`, `render/1` and `render_form/1`. The `query/3` function is used to filter the data based on the filter values. It receives the query, the attribute and the values of the filter and should return the filtered query. The `render/1` function returns the markup that is used to display the filter on the index view. The `render_form/1` function returns the markup that is used to render the filter form on the index view.\n\nHere is an example of a custom select filter:\n\n```elixir\ndefmodule MyApp.Filters.CustomSelectFilter do\n    use BackpexWeb, :filter\n\n    @impl Backpex.Filter\n    def label, do: \"Event status\"\n\n    @impl Backpex.Filter\n    def render(assigns) do\n        assigns = assign(assigns, :label, option_value_to_label(options(), assigns.value))\n\n        ~H\"\"\"\n        <%= @label %>\n        \"\"\"\n    end\n\n    @impl Backpex.Filter\n    def render_form(assigns) do\n        ~H\"\"\"\n        <.form_field\n            type=\"select\"\n            selected={selected(@value)}\n            options={my_options()}\n            form={@form}\n            field={@field}\n            label=\"\"\n        />\n        \"\"\"\n    end\n\n    @impl Backpex.Filter\n    def query(query, attribute, value) do\n        where(query, [x], field(x, ^attribute) == ^value)\n    end\n\n    defp option_value_to_label(options, value) do\n        Enum.find_value(options, fn {option_label, option_value} ->\n        if option_value == value, do: option_label\n        end)\n    end\n\n    defp my_options, do: [\n        {\"Select an option...\", nil},\n        {\"Open\", :open},\n        {\"Close\", :close},\n    ]\n\n    defp selected(\"\"), do: nil\n    defp selected(value), do: value\nend\n```\n\nIn this example, we define a custom select filter that filters the data based on the event status. The `query/3` function filters the data based on the selected value.\n\nSee `Backpex.Filter` for available callback functions.","ref":"custom-filter.html#creating-a-custom-filter"},{"type":"extras","title":"Visibility and Authorization","doc":"# Visibility and Authorization\n\nYou can control whether a filter is visible or not by implementing the [can?/1](Backpex.Filter.html#c:can?/1) callback in your filter module.","ref":"visibility-and-authorization.html"},{"type":"extras","title":"Configuration - Visibility and Authorization","doc":"The [can?/1](Backpex.Filter.html#c:can?/1) callback receives the assigns and has to return a boolean value. If the callback returns `true`, the filter will be visible. If it returns `false`, the filter will be hidden. If you don't implement the `can?/1` callback, the filter will be visible by default.\n\nHere is an example of how to hide a filter based on the user's role:\n\n```elixir\ndefmodule MyAppWeb.Filters.MyFilter do\n  use BackpexWeb, :filter\n\n  @impl Backpex.Filter\n  def can?(assigns), do: assigns.current_user.role == :admin\nend\n```\n\nIn this example, the `MyFilter` filter will only be visible if the user's role is `admin`.","ref":"visibility-and-authorization.html#configuration"},{"type":"extras","title":"Item Actions","doc":"# Item Actions\n\nAn item action defines an action (such as deleting a user) that can be performed on one or more items. Unlike resource actions, item actions are not automatically performed on all items in a resource.\n\nAn item action could be something like deleting a user, or sending an email to a specific user.\n\nThere are multiple ways to perform an Item Action:\n- use the checkboxes in the first column of the resource table to select 1-n items and trigger the action later on\n- use an icon in the last column of the resource table to perform the Item Action for one item\n\nIf you use the first method, you must trigger the item action using the button above the resource action. If you use the second method, the item action is triggered immediately.\n\nBackpex ships with a few built-in item actions, such as `delete`, `show`, and `edit`.","ref":"item-actions.html"},{"type":"extras","title":"Configuration - Item Actions","doc":"To add an item action to a resource, you need to implement the [`item_actions/1`](Backpex.LiveResource.html#c:item_actions/1) callback in your resource configuration module. The function has to return a list of maps, where each map represents an item action. It takes the default item actions as an argument. This way you can add your custom item actions to the default ones or even replace them.\n\nLet's say we want to add a `show` item action to navigate to the show view of a user and replace all other default item actions.\n\nFirst, we need to add the item action to our resource configuration module.\n\n```elixir\n# in your resource configuration file\n@impl Backpex.LiveResource\ndef item_actions([_show, _edit, _delete]) do\n    [\n        show: %{\n            module: DemoWeb.ItemAction.Show\n        }\n    ]\nend\n```\n\nIn the above example, we only return the `show` item action. This way we replace the default `show`, `edit`, and `delete` item actions with our custom `show` item action.","ref":"item-actions.html#configuration"},{"type":"extras","title":"Implementing an Item Action - Item Actions","doc":"An item action is a module that uses the `Backpex.ItemAction` module. To get started, you can use the `BackpexWeb` module and provide the `:item_action` option. This will import the necessary functions and macros to define an item action.\n\nIn the following example, we define an item action to navigate to the show view of a user.\n\n```elixir\ndefmodule DemoWeb.ItemAction.Show do\n  use BackpexWeb, :item_action\n\n  @impl Backpex.ItemAction\n  def icon(assigns, _item) do\n    ~H\"\"\"\n     \n    \"\"\"\n  end\n\n  @impl Backpex.ItemAction\n  def label(_assigns, _item), do: Backpex.translate(\"Show\")\n\n  @impl Backpex.ItemAction\n  def handle(socket, [item | _items], _data) do\n    path = Router.get_path(socket, socket.assigns.live_resource, socket.assigns.params, :show, item)\n    {:noreply, Phoenix.LiveView.push_patch(socket, to: path)}\n  end\nend\n```\n\nAs with resource actions, the `c:Backpex.ItemAction.handle/3` function is called when the item action is triggered. The handle function receives the socket, the items to be affected by the action, and the parameters passed by the user.\n\nIn the example above, we define an item action to navigate to a user's show view. The function `c:Backpex.ItemAction.handle/3` is used to navigate to the corresponding view. The `Backpex.Router.get_path/6` function is used to generate the path needed.\n\nThe callbacks `c:Backpex.ItemAction.icon/2` and `c:Backpex.ItemAction.label/2` get the item on which the action is executed. You can use the item to customize this function depending on the item.\n\n> #### Important {: .warning}\n>\n> Note that the item in the `c:Backpex.ItemAction.label/2` callback is nil if the callback is used to display the label of the item action button above the resource table or the label of the confirmation dialog. The item is present if the callback is used to determine the tooltip for the item action icon.\n> \n\nSee `Backpex.ItemAction` for a list of all available callbacks.","ref":"item-actions.html#implementing-an-item-action"},{"type":"extras","title":"Placement of Item Actions - Item Actions","doc":"Item actions can be placed in the resource table or at the top of it. You can specify the placement of the item action by using the `only` key.\n\nThe only key must provide a list and accepts the following options\n\n* `:row` - display an icon for each element in the table that can trigger the Item Action for the corresponding element\n* `:index` - display a button at the top of the resource table, which triggers the Item Action for selected items\n\nThe following example shows how to place the `show` item action on the index table rows only.\n\n```elixir\n# in your resource configuration file\n@impl Backpex.LiveResource\ndef item_actions([_show, _edit, _delete]) do\n    [\n        show: %{\n            module: DemoWeb.ItemAction.Show,\n            only: [:row]\n        }\n    ]\nend\n```","ref":"item-actions.html#placement-of-item-actions"},{"type":"extras","title":"Advanced Item Action - Item Actions","doc":"In the following example, we define an item action to soft delete users. The item action will also asked the user for a reason before the user can be deleted.\n\nFirst, wee need to add the item action to our resource configuration module.\n\n```elixir\n# in your resource configuration file\n\n@impl Backpex.LiveResource\ndef item_actions([show, edit, _delete]) do\n    Enum.concat([show, edit],\n        soft_delete: %{module: DemoWeb.ItemAction.SoftDelete}\n    )\nend\n```\n\nIn the above example, we add the `soft_delete` item action to the default item actions. We do not add the default `delete` item action to the list of item actions. This way we replace the default `delete` item action with our custom `soft_delete` item action.\n\nNext, we need to implement the item action module.\n\n```elixir\ndefmodule DemoWeb.ItemAction.SoftDelete do\n    use BackpexWeb, :item_action\n\n    alias Backpex.Resource\n\n    @impl Backpex.ItemAction\n    def icon(assigns, _item) do\n    ~H\"\"\"\n     \n    \"\"\"\n    end\n\n    @impl Backpex.ItemAction\n    def fields do\n        [\n            reason: %{\n                module: Backpex.Fields.Textarea,\n                label: \"Reason\",\n                type: :string\n            }\n        ]       \n    end\n\n    @required_fields ~w[reason]a\n\n    @impl Backpex.ItemAction\n    def changeset(change, attrs) do\n        change\n        |> cast(attrs, @required_fields)\n        |> validate_required(@required_fields)\n    end\n\n    @impl Backpex.ItemAction\n    def label(_assigns, _item), do: Backpex.translate(\"Delete\")\n\n    @impl Backpex.ItemAction\n    def confirm_label(_assigns), do: Backpex.translate(\"Delete\")\n\n    @impl Backpex.ItemAction\n    def cancel_label(_assigns), do: Backpex.translate(\"Cancel\")\n\n    @impl Backpex.ItemAction\n    def handle(socket, items, data) do\n        datetime = DateTime.truncate(DateTime.utc_now(), :second)\n\n        socket =\n            try do\n                {:ok, _items} =\n                Backpex.Resource.update_all(\n                    socket.assigns,\n                    items,\n                    [set: [deleted_at: datetime, reason: data.reason]],\n                    \"deleted\"\n                )\n\n                socket\n                |> clear_flash()\n                |> put_flash(:info, \"Item(s) successfully deleted.\")\n            rescue\n                socket\n                |> clear_flash()\n                |> put_flash(:error, error)\n            end\n\n        {:noreply, socket}\n    end\nend\n```\n\nIn the above example, we define an item action to soft delete users. The item action will also ask the user for a reason before the user can be deleted. The user needs to fill out the reason field before the item action can be performed. The reason field is defined in the `c:Backpex.ItemAction.fields/0` function. The `c:Backpex.ItemAction.changeset/3` function is used to validate the user input.\n\nThe `c:Backpex.ItemAction.handle/3` function is called when the item action is triggered. The handle function receives the socket, the items that should be affected by the action, and the parameters that were submitted by the user.\n\nBy default an item action is triggered immediately when the user clicks on the corresponding icon in the resource table or in the show view, but an item actions also supports a confirmation dialog. To enable the confirmation dialog you need to implement the `c:Backpex.ItemAction.confirm_label/1` function and return a string that will be displayed in the confirmation dialog. The confirmation dialog will be displayed when the user clicks on the icon in the resource table.","ref":"item-actions.html#advanced-item-action"},{"type":"extras","title":"Resource Actions","doc":"# Resource Actions\n\nResource actions are a way to define custom actions that can be performed on a whole resource.\n\nA resource action could be something like exporting a resource to a CSV file, or sending an email to all users in a resource.","ref":"resource-actions.html"},{"type":"extras","title":"Configuration - Resource Actions","doc":"You define resource actions by implementing the [`resource_actions/0`](Backpex.LiveResource.html#c:resource_actions/0) callback in your resource configuration module.\n\nLet's say you have a resource called `User` and you want to add a resource action to invite users to your application.\n\nFirst, you need to add the resource action to your resource configuration module.\n\n```elixir\n# in your resource configuration file\n\n@impl Backpex.LiveResource\ndef resource_actions() do\n[\n    invite: %{\n        module: MyWebApp.Admin.ResourceActions.Invite,\n    }\n]\nend\n```\n\nEach resource action is a map with at least the module key. The module key should point to the module that implements the resource action. The key in the keyword list is the unique `id` of the resource action.","ref":"resource-actions.html#configuration"},{"type":"extras","title":"Implementing a Resource Action - Resource Actions","doc":"A resource action is a module that uses the `Backpex.ResourceAction` module.\n\n```elixir\ndefmodule MyAppWeb.Admin.Actions.Invite do\n    use Backpex.ResourceAction\n\n    import Ecto.Changeset\n\n    @impl Backpex.ResourceAction\n    def label, do: \"Invite\"\n\n    @impl Backpex.ResourceAction\n    def title, do: \"Invite user\"\n\n    # you can reuse Backpex fields in the field definition\n    @impl Backpex.ResourceAction\n    def fields do\n        [\n            email: %{\n                module: Backpex.Fields.Text,\n                label: \"Email\",\n                type: :string\n            }\n        ]\n    end\n\n    @impl Backpex.ResourceAction\n    def changeset(change, attrs) do\n        change\n        |> cast(attrs, [:email])\n        |> validate_required([:email])\n        |> validate_email(:email)\n    end\n\n    @impl Backpex.ResourceAction\n    def handle(_socket, data) do\n        # Send mail\n\n        # We suppose there was no error.\n        if true do\n            {:ok, \"An invitation email to #{data.email} was sent successfully.\"}\n        else\n            {:error, \"An error occurred while sending an invitation email to  #{data.email}!\"}\n        end\n    end\nend\n```\n\nSee `Backpex.ResourceAction` for a documentation of the callbacks.\n\nThe [`handle/2`](Backpex.ResourceAction.html#c:handle/2) callback is called when the user submits the form to perform the action. In this example, we suppose there was no error sending the invitation email and return a success message.\n\nYou can access the email entered by the user in the `data` argument. The `data` argument is a map that contains the casted and validated data from the form (received from [`Ecto.Changeset.apply_action/2`](https://hexdocs.pm/ecto/Ecto.Changeset.html#apply_action/2)).\n\nWe validate the email address using the `validate_email/2` function provided by the `Ecto.Changeset` module.\n\n> #### Info {: .info}\n>\n> Each resource action has its own route. The route is defined by the `id` of the resource action. If you use the [`live_resource/3`](Backpex.Router.html#live_resources/3) macro, the route is automatically added to the live resource.","ref":"resource-actions.html#implementing-a-resource-action"},{"type":"extras","title":"LiveResource Authorization","doc":"# LiveResource Authorization\n\nYou are able to define authorization rules for your resources. The authorization rules are defined in the resource configuration file and are used to control access to certain actions.","ref":"live-resource-authorization.html"},{"type":"extras","title":"Configuration - LiveResource Authorization","doc":"To define authorization rules for a resource, you need to implement the [`can/3`](Backpex.LiveResource.html#c:can?/3) callback in the resource configuration file.\n\n```elixir\n# in your resource configuration file\n@impl Backpex.LiveResource\ndef can?(assigns, :show, item), do: false\ndef can?(assigns, action, item), do: true\n```\n\nThe example above will deny access to the `show` action and allow access to all other actions.\n\n```elixir\n# in your resource configuration file\n@impl Backpex.LiveResource\ndef can?(assigns, :show, item) do\n    user = assigns.current_user\n\n    item.user_id == user.id\nend‚\n\ndef can?(assigns, action, item), do: true\n```\n\nThe example above will deny access to the `show` action if the `user_id` of the item does not match the `id` of the current user.\n\nYou can also use [`can/3`](Backpex.LiveResource.html#c:can?/3) to restrict access to item or resource actions.\n\n```elixir\n# in your resource configuration file\n@impl Backpex.LiveResource\ndef can?(_assigns, :my_item_action, item), do: item.role == :admin\ndef can?(assigns, action, item), do: true\n```\n\nThe example above will deny access to the `my_item_action` action if the `role` of the item is not `:admin`.","ref":"live-resource-authorization.html#configuration"},{"type":"extras","title":"Parameters - LiveResource Authorization","doc":"The `can?` callback receives the following parameters:\n\n- `assigns` - the assigns of the LiveView\n- `action` - the action that is being authorized (available actions are: `:index` , `:new`, `:show`, `:edit`, `:delete`, `:your_item_action_key`, `:your_resource_action_key`)\n- `item` - the item that is being authorized","ref":"live-resource-authorization.html#parameters"},{"type":"extras","title":"Return value - LiveResource Authorization","doc":"The `can?` callback must return a boolean value. If the return value is `true`, the action is allowed. If the return value is `false`, the action is denied.","ref":"live-resource-authorization.html#return-value"},{"type":"extras","title":"Field Authorization","doc":"# Field Authorization\n\nYou can define authorization rules for your fields.","ref":"field-authorization.html"},{"type":"extras","title":"Configuration - Field Authorization","doc":"To define authorization rules for a field, you may use the `can?/1` callback for a field configuration. It takes the assigns and has to return a boolean value.\n\n```elixir\n# in your resource configuration file\n@impl Backpex.LiveResource\ndef fields do\n[\n    inserted_at: %{\n        module: Backpex.Fields.DateTime,\n        label: \"Created At\",\n        can?: fn\n            %{live_action: :show} = _assigns ->\n            true\n\n            _assigns ->\n            false\n        end\n    }\n]\nend\n```\n\nThe above example will show the `inserted_at` field only in the show view.","ref":"field-authorization.html#configuration"},{"type":"extras","title":"Search","doc":"# Search\n\nBackpex provides a simple search feature that allows you to search for records in your resources. You can search for records based on the values of the fields in your resources.\n\n> #### Info {: .info}\n>\n> Note that fields are searched using a case-insensitive `ilike` query.","ref":"basic-search.html"},{"type":"extras","title":"Configuration - Search","doc":"To enable searching, you need to flag the fields you want to search on as `searchable`.\n\n```elixir\n# in your resource configuration file\n@impl Backpex.LiveResource\ndef fields do\n[\n    %{\n        ...,\n        searchable: true\n    }\n]\nend\n```\n\nA search input will appear automatically on the resource index view.","ref":"basic-search.html#configuration"},{"type":"extras","title":"Custom Placeholder - Search","doc":"You can provide a custom placeholder for the search input by implementing the `search_placeholder/0` callback in your resource configuration file.\n\n```elixir\n# in your resource configuration file\n@impl Backpex.LiveResource\ndef search_placeholder, do: \"This will be shown in the search input.\"\n```\n\nIn addition to basic searching, Backpex allows you to perform full-text searches on resources (see [Full-Text Search Guide](full-text-search.md)).","ref":"basic-search.html#custom-placeholder"},{"type":"extras","title":"Full-Text Search","doc":"# Full-Text Search\n\nBackpex allows you to perform full-text searches on resources. It uses the built-in [PostgreSQL full-text search functionality](https://www.postgresql.org/docs/current/textsearch.html).","ref":"full-text-search.html"},{"type":"extras","title":"Create a Generated Column - Full-Text Search","doc":"Backpex forces you to create a generated column to use the full-text search functionality. It must contain a tsvector that is generated from all the columns that you want to be considered when searching. You are free to choose a name for this column.\n\nBelow is an example of a generated column for a movie review resource with a title column and an overview column. Both columns should be searchable.\n\n```elixir\n# in the database up migration\n\nexecute(\"\"\"\nALTER TABLE film_reviews\n  ADD COLUMN generated_tsvector tsvector\n  GENERATED ALWAYS AS (\n    to_tsvector('english', coalesce(title, '') || ' ' || coalesce(overview, ''))\n  ) STORED;\n\"\"\")\n```\n\nYou can also concat multiple tsvectors in the generated column. This is useful if the table contains data in different languages. We recommend that you specify the language when using the `to_tsvector` function. Otherwise the default language will be used.","ref":"full-text-search.html#create-a-generated-column"},{"type":"extras","title":"Create an Index - Full-Text Search","doc":"To increase the speed of full-text searches, especially for resources with large amounts of data, you should create an index on the generated column created in the previous step.\n\nWe strongly recommend that you use a GIN index, as it makes full-text searches really fast. The disadvantage is that a GIN index takes up a lot of disk space, so if you are limited in disk space, feel free to use a GiST index instead.\n\n```elixir\n# in the database up migration\n\nexecute(\"\"\"\nCREATE INDEX film_reviews_search_idx ON film_reviews USING GIN(generated_tsvector);\n\"\"\")\n```\n\n```elixir\n# in the database down migration\n\nexecute(\"\"\"\nDROP INDEX film_reviews_search_idx;\n\"\"\")\n\ndrop table(:film_reviews)\n```\n\n> #### Important {: .info}\n>\n> Note that you must explicitly define up and down migrations. Otherwise, the index cannot be dropped.\n\nTo enable full-text search, you need to specify the name of the generated column in the live resource of the corresponding resource:\n\n```elixir\n# in the live resource\n\nuse Backpex.LiveResource,\n  full_text_search: :generated_tsvector\n```\n\nYou can now perform full-text searches on the resource index view.","ref":"full-text-search.html#create-an-index"},{"type":"extras","title":"Custom Labels and Translations","doc":"# Custom Labels and Translations","ref":"custom-labels-and-translations.html"},{"type":"extras","title":"Custom Labels - Custom Labels and Translations","doc":"You can customize the label of the buttons and messages that are displayed in the Live Resource. This is useful if you want to display a different label than the default one.\n\nWe currently support customizing the label of the create button and the message of the flash message when a resource has been created successfully.","ref":"custom-labels-and-translations.html#custom-labels"},{"type":"extras","title":"Configuration for the create button label - Custom Labels and Translations","doc":"```elixir\n# in your resource configuration file\n\n@impl Backpex.LiveResource\ndef create_button_label, do: \"Create a new user\"\n```\n\nThe create button will now display the label \"Create a new user\" instead of the default \"Create %{resource}\".","ref":"custom-labels-and-translations.html#configuration-for-the-create-button-label"},{"type":"extras","title":"Configuration for the resource created message - Custom Labels and Translations","doc":"```elixir\n# in your resource configuration file\n\n@impl Backpex.LiveResource\ndef resource_created_message, do: \"A User has been added.\"\n```\n\nThe message will no display the label \"A User has been added.\" instead of the default \"New %{resource} has been created successfully.\".","ref":"custom-labels-and-translations.html#configuration-for-the-resource-created-message"},{"type":"extras","title":"Translations - Custom Labels and Translations","doc":"You are able to translate all strings used by Backpex. This includes general strings like \"New\", \"Edit\", \"Delete\", etc., as well as error messages.","ref":"custom-labels-and-translations.html#translations"},{"type":"extras","title":"Configuration - Custom Labels and Translations","doc":"In order to translate strings, you need to configure two translator functions in your application config:\n\n```elixir\nconfig :backpex,\n  translator_function: {MyAppWeb.CoreComponents, :translate_backpex},\n  error_translator_function: {MyAppWeb.CoreComponents, :translate_error}\n```\n\nThe first one is being used to translate general strings. The second one is being used to translate (changeset) errors.","ref":"custom-labels-and-translations.html#configuration"},{"type":"extras","title":"Using Gettext - Custom Labels and Translations","doc":"We recommend using Gettext for translations. If you want to use it, the translator functions should look like this:\n\n```elixir\ndef translate_backpex({msg, opts}) do\n  if count = opts[:count] do\n    Gettext.dngettext(MyAppWeb.Gettext, \"backpex\", msg, msg, count, opts)\n  else\n    Gettext.dgettext(MyAppWeb.Gettext, \"backpex\", msg, opts)\n  end\nend\n\ndef translate_error({msg, opts}) do\n  if count = opts[:count] do\n    Gettext.dngettext(DemoWeb.Gettext, \"errors\", msg, msg, count, opts)\n  else\n    Gettext.dgettext(DemoWeb.Gettext, \"errors\", msg, opts)\n  end\nend\n```\n\nYou can place the functions in a module of your choice. In this example, we use `MyAppWeb.CoreComponents`. Don't forget to use the correct module in your config as well.\n\nIn addition, you need to create a Gettext template file in your application. You may use the following template. It contains all translations used by Backpex.\n\n```po","ref":"custom-labels-and-translations.html#using-gettext"},{"type":"extras","title":"This file is a PO Template file. - Custom Labels and Translations","doc":"msgid \"\"\nmsgstr \"\"\n\nmsgid \"New %{resource}\"\nmsgstr \"\"\n\nmsgid \"Edit %{resource}\"\nmsgstr \"\"\n\nmsgid \"Delete\"\nmsgstr \"\"\n\nmsgid \"Edit\"\nmsgstr \"\"\n\nmsgid \"Save\"\nmsgstr \"\"\n\nmsgid \"Cancel\"\nmsgstr \"\"\n\nmsgid \"Search\"\nmsgstr \"\"\n\nmsgid \"Filters\"\nmsgstr \"\"\n\nmsgid \"Are you sure you want to delete %{count} items?\"\nmsgstr \"\"\n\nmsgid \"Are you sure you want to delete the item?\"\nmsgstr \"\"\n\nmsgid \"New %{resource} has been created successfully.\"\nmsgstr \"\"\n\nmsgid \"%{resource} has been edited successfully.\"\nmsgstr \"\"\n\nmsgid \"%{resource} has been deleted successfully.\"\nmsgstr \"\"\n\nmsgid \"%{count} %{resources} have been deleted successfully.\"\nmsgstr \"\"\n\nmsgid \"An error occurred while deleting the %{resource}!\"\nmsgstr \"\"\n\nmsgid \"An error occurred while deleting %{count} %{resources}!\"\nmsgstr \"\"\n\nmsgid \"The item is used elsewhere.\"\nmsgstr \"\"\n\nmsgid \"The items are used elsewhere.\"\nmsgstr \"\"\n\nmsgid \"You are not allowed to do this!\"\nmsgstr \"\"\n\nmsgid \"Upload a file\"\nmsgstr \"\"\n\nmsgid \"or drag and drop\"\nmsgstr \"\"\n\nmsgid \"too large\"\nmsgstr \"\"\n\nmsgid \"too many files\"\nmsgstr \"\"\n\nmsgid \"unacceptable file type\"\nmsgstr \"\"\n\nmsgid \"clear\"\nmsgstr \"\"\n\nmsgid \"No %{resources} found\"\nmsgstr \"\"\n\nmsgid \"Try a different search term.\"\nmsgstr \"\"\n\nmsgid \"Try a different filter setting or clear all filters.\"\nmsgstr \"\"\n\nmsgid \"Select options...\"\nmsgstr \"\"\n\nmsgid \"No options found\"\nmsgstr \"\"\n\nmsgid \"Select all\"\nmsgstr \"\"\n\nmsgid \"Deselect all\"\nmsgstr \"\"\n\nmsgid \"Show more\"\nmsgstr \"\"\n\nmsgid \"Items %{from} to %{to}\"\nmsgstr \"\"\n\nmsgid \"total\"\nmsgstr \"\"\n\nmsgid \"There are errors in the form.\"\nmsgstr \"\"\n\nmsgid \"Add entry\"\nmsgstr \"\"\n\nmsgid \"Apply\"\nmsgstr \"\"\n\nmsgid \"Attach %{resource}\"\nmsgstr \"\"\n\nmsgid \"Choose %{resource} ...\"\nmsgstr \"\"\n\nmsgid \"Toggle metrics\"\nmsgstr \"\"\n\nmsgid \"Toggle columns\"\nmsgstr \"\"\n\nmsgid \"Select all items\"\nmsgstr \"\"\n\nmsgid \"Close alert\"\nmsgstr \"\"\n\nmsgid \"Select item with id: %{id}\"\nmsgstr \"\"\n\nmsgid \"Clear %{name} filter\"\nmsgstr \"\"\n\nmsgid \"Edit relation with index %{index}\"\nmsgstr \"\"\n\nmsgid \"Detach relation with index %{index}\"\nmsgstr \"\"\n\nmsgid \"Error in relation with index %{index}\"\nmsgstr \"\"\n\nmsgid \"Close modal\"\nmsgstr \"\"\n\nmsgid \"Unselect %{label}\"\nmsgstr \"\"\n\nmsgid \"selected\"\nmsgstr \"\"\n\nmsgid \"From\"\nmsgstr \"\"\n\nmsgid \"To\"\nmsgstr \"\"\n```","ref":"custom-labels-and-translations.html#this-file-is-a-po-template-file"},{"type":"extras","title":"Upgrading to v0.7","doc":"# Upgrading to v0.7","ref":"v0-7.html"},{"type":"extras","title":"Update calls to [`Backpex.Field.handle_index_editable/2`](Backpex.Field.html#handle_index_editable/3) - Upgrading to v0.7","doc":"We have updated the arity and syntax of [`Backpex.Field.handle_index_editable/2`](Backpex.Field.html#handle_index_editable/3). It is now [`Backpex.Field.handle_index_editable/3`](Backpex.Field.html#handle_index_editable/3) and accepts the `socket`, the `value` and the `change`. We now need the value to update the form accordingly.\n\nIf you had code like this, e.g. for custom fields:\n\n```elixir\n@impl Phoenix.LiveComponent\ndef handle_event(\"update-field\", %{\"index_form\" => %{\"value\" => value}}, socket) do\n  Backpex.Field.handle_index_editable(socket, %{} |> Map.put(socket.assigns.name, value))\nend\n```\n\nit should now look like this\n\n```elixir\n@impl Phoenix.LiveComponent\ndef handle_event(\"update-field\", %{\"index_form\" => %{\"value\" => value}}, socket) do\n  Backpex.Field.handle_index_editable(socket, value, Map.put(%{}, socket.assigns.name, value))\nend\n```","ref":"v0-7.html#update-calls-to-backpex-field-handle_index_editable-2-backpex-field-html-handle_index_editable-3"},{"type":"extras","title":"Update calls to `Backpex.Resource` - Upgrading to v0.7","doc":"We have updated certain functions in `Backpex.Resource`.\n\nThe following functions are affected:\n- `Backpex.Resource.update/6` (`update/5` before)\n- `Backpex.Resource.insert/6` (`insert/5` before)\n- `Backpex.Resource.change/7`\n- [`Backpex.Resource.put_assocs/2`]() (has been removed)\n\nIf you call one of these functions in your application, you will probably need to update the function call.\n\nSee `Backpex.Resource` for the updated documentation of the functions.","ref":"v0-7.html#update-calls-to-backpex-resource"},{"type":"extras","title":"Update your Item Actions - Upgrading to v0.7","doc":"We've changed the arity of some item action callback functions.\n\n- `icon/1` becomes `icon/2`\n- `label/1` becomes `label/2` \n\nBoth callback functions now receive the item as the second parameter. This allows you to construct the icon and label based on the corresponding item.\n\nIf you had an item action with code like this\n\n```elixir\n@impl Backpex.ItemAction\ndef icon(assigns) do\n ...\nend\n\n@impl Backpex.ItemAction\ndef label(_assigns) do\n  ...\nend\n```\n\nit should now look like this\n\n```elixir\n@impl Backpex.ItemAction\ndef icon(assigns, _item) do\n ...\nend\n\n@impl Backpex.ItemAction\ndef label(_assigns, _item) do\n  ...\nend\n```\n\nRead more about the new `item` parameter in [the item action guide](/guides/actions/item-actions.md#implementing-an-item-action).","ref":"v0-7.html#update-your-item-actions"},{"type":"extras","title":"Upgrading to v0.6","doc":"# Upgrading to v0.6\n\n# Change `Backpex.Fields.ManyToMany` to `Backpex.Fields.HasMany`\n\nWith version 0.6, we have combined the `Backpex.Fields.ManyToMany` and `Backpex.Fields.HasMany` field. The functionality of the fields is now combined in the `Backpex.Fields.HasMany` field. The API of the field has not changed, so you can simply replace `Backpex.Fields.ManyToMany` with `Backpex.Fields.HasMany` in your resource configuration.","ref":"v0-6.html"},{"type":"extras","title":"Upgrading to v0.5","doc":"# Upgrading to v0.5","ref":"v0-5.html"},{"type":"extras","title":"Uploads: Item in `consume_upload/4` now contains changes - Upgrading to v0.5","doc":"Previously, we passed the item without its changes to the `consume_upload/4` callback function. With 0.5, we now pass the persisted item (with its changes) to the function.","ref":"v0-5.html#uploads-item-in-consume_upload-4-now-contains-changes"},{"type":"extras","title":"Resource Actions now receive the data instead of the params - Upgrading to v0.5","doc":"Previously, Resource Actions received the params from the form. With 0.5, Resource Actions now receive the data from the form. The data is a map that contains the casted and validated data from the form (received from [`Ecto.Changeset.apply_action/2`](https://hexdocs.pm/ecto/Ecto.Changeset.html#apply_action/2)).\n\nIf you had a resource action like this:\n\n```elixir\ndefmodule MyAppWeb.Admin.ResourceActions.Invite do\n    # ...\n\n    @impl Backpex.ResourceAction\n    def handle(_socket, params) do\n        # Send invite mail to users\n\n        # We suppose there was no error sending the mail.\n        if true do\n            {:ok, \"An invitation email to #{params[\"email\"]} was sent successfully.\"}\n        else\n            {:error, \"An error occurred while sending an invitation email to  #{params[\"email\"]}!\"}\n        end\n    end\nend\n```\n\nYou should update it to:\n\n```elixir\ndefmodule MyAppWeb.Admin.ResourceActions.Invite do\n    # ...\n\n    @impl Backpex.ResourceAction\n    def handle(_socket, data) do\n        # Send invite mail to users\n\n        # We suppose there was no error sending the mail.\n        if true do\n            {:ok, \"An invitation email to #{data.email} was sent successfully.\"}\n        else\n            {:error, \"An error occurred while sending an invitation email to  #{data.email}!\"}\n        end\n    end\nend\n```\n\nNote that the data is now casted. Therefore you now have atom keys instead of string keys.","ref":"v0-5.html#resource-actions-now-receive-the-data-instead-of-the-params"},{"type":"extras","title":"Item Actions now receive the data instead of the params - Upgrading to v0.5","doc":"Previously, Item Actions received the params from the form. With 0.5, Item Actions now receive the data from the form. The data is a map that contains the casted and validated data from the form (received from [`Ecto.Changeset.apply_action/2`](https://hexdocs.pm/ecto/Ecto.Changeset.html#apply_action/2)).\n\nIf you had an item action like this:\n\n```elixir\ndefmodule MyAppWeb.Admin.ItemActions.Delete do\n    # ...\n\n    @impl Backpex.ItemAction\n    def handle(socket, items, params) do\n        datetime = DateTime.truncate(DateTime.utc_now(), :second)\n\n        socket =\n            try do\n                {:ok, _items} =\n                    Backpex.Resource.update_all(\n                        socket.assigns,\n                        items,\n                        [set: [deleted_at: datetime, reason: params[\"reason\"]]],\n                        \"deleted\"\n                    )\n\n                socket\n                |> clear_flash()\n                |> put_flash(:info, \"Item(s) successfully deleted.\")\n            rescue\n                socket\n                |> clear_flash()\n                |> put_flash(:error, error)\n            end\n\n        {:noreply, socket}\n    end\nend\n```\n\nYou should update it to:\n\n```elixir\ndefmodule MyAppWeb.Admin.ItemActions.Delete do\n    # ...\n\n    @impl Backpex.ItemAction\n    def handle(socket, items, data) do\n        datetime = DateTime.truncate(DateTime.utc_now(), :second)\n\n        socket =\n            try do\n                {:ok, _items} =\n                    Backpex.Resource.update_all(\n                        socket.assigns,\n                        items,\n                        [set: [deleted_at: datetime, reason: data.reason]],\n                        \"deleted\"\n                )\n\n                socket\n                |> clear_flash()\n                |> put_flash(:info, \"Item(s) successfully deleted.\")\n            rescue\n                socket\n                |> clear_flash()\n                |> put_flash(:error, error)\n            end\n\n        {:noreply, socket}\n    end\nend\n```\n\nNote that the data is now casted. Therefore you now have atom keys instead of string keys.","ref":"v0-5.html#item-actions-now-receive-the-data-instead-of-the-params"},{"type":"extras","title":"Refactor the use of icons - Upgrading to v0.5","doc":"We have refactored the way we use icons in Backpex. Previously, we installed [the Heroicons hex.pm package](https://hex.pm/packages/heroicons). We now require a Tailwind plugin that generates the styles for a new `Backpex.HTML.CoreComponents.icon/1` component. This is the default way of using heroicons in new Phoenix projects. We documented the new way in the [installation guide](get_started/installation.md#provide-tailwind-plugin-for-icons).","ref":"v0-5.html#refactor-the-use-of-icons"},{"type":"extras","title":"Upgrading to v0.3","doc":"# Upgrading to v0.3","ref":"v0-3.html"},{"type":"extras","title":"Bump Your Deps - Upgrading to v0.3","doc":"Update Backpex to the latest version:\n\n```elixir\n  defp deps do\n    [\n      {:backpex, \"~> 0.3.1\"}\n    ]\n  end\n```","ref":"v0-3.html#bump-your-deps"},{"type":"extras","title":"Update calls to `Backpex.Resource` - Upgrading to v0.3","doc":"We have updated certain functions in `Backpex.Resource` to make them more explicit and usable from outside. \n\nThe following functions are affected:\n- [`Backpex.Resource.get!/5`]() (`get/4` before)\n- [`Backpex.Resource.delete/3`]() (`delete/2` before)\n- [`Backpex.Resource.delete_all/4`]() (`delete_all/2` before)\n- [`Backpex.Resource.update/5`]() (`update/2` before)\n- [`Backpex.Resource.update_all/6`]() (`update_all/4` before)\n- [`Backpex.Resource.insert/5`]() (`insert/2` before)\n\nIf you call one of these functions in your application, you will probably need to update the function call.\n\nWe added extensive documentation to the updated functions in `Backpex.Resource`.\n\nSee [Pull Request #269](https://github.com/naymspace/backpex/pull/269) for more information.","ref":"v0-3.html#update-calls-to-backpex-resource"},{"type":"extras","title":"Update Upload callback functions - Upgrading to v0.3","doc":"We have updated `Backpex.Fields.Upload` and improved uploads in Backpex:\n\n- Uploaded and existing files are now included in the change to allow them to be validated in the changeset\n- Uploads can be required\n- Uploads are not removed until form is saved\n- Form field errors are displayed for upload field\n\nFor these requirements we have simplified the functions in `Backpex.FormComponent` and adapted the validation flow to classic Phoenix applications.\n\nWe also updated the callback functions / options used for `Backpex.Fields.Upload`. Among other things, we have split `consume/2` into several callbacks (`put_upload_change/6` and `consume_upload/4`). This allows developers to put uploaded files to the change before consuming the uploads. This makes it possible to do validation on uploads (e.g. require files to be uploaded).\n\nWe have also rewritten all the upload documentation in `Backpex.Fields.Upload`. It contains full examples for single and multiple upload fields.\n\nWe recommend that you read the new upload documentation and adapt the callback functions in your application accordingly.\n\nSee [Pull Request #269](https://github.com/naymspace/backpex/pull/269) for more information.","ref":"v0-3.html#update-upload-callback-functions"},{"type":"extras","title":"Upgrading to v0.2","doc":"# Upgrading to v0.2","ref":"v0-2.html"},{"type":"extras","title":"Bump Your Deps - Upgrading to v0.2","doc":"Update Backpex to the latest version:\n\n```elixir\n  defp deps do\n    [\n      {:backpex, \"~> 0.2.0\"}\n    ]\n  end\n```","ref":"v0-2.html#bump-your-deps"},{"type":"extras","title":"Pass `assigns` to `init_change` functions - Upgrading to v0.2","doc":"We change the arity of the `init_change/0` function to `init_change/1` for resource and item actions.\n\nThe param will be the assigns. This adds more ways to construct an initial change.\n\nIf you had such a function in your resource or item action:\n\n```elixir\n@impl Backpex.ItemAction\ndef init_change() do\n  # construct init change\nend\n```\n\nYou need to change it to this:\n\n```elixir\n@impl Backpex.ItemAction\ndef init_change(_assigns) do\n  # construct init change\nend\n```","ref":"v0-2.html#pass-assigns-to-init_change-functions"},{"type":"extras","title":"Change arity of changeset functions - Upgrading to v0.2","doc":"See [Pull Request](https://github.com/naymspace/backpex/pull/94).\n\nWe are introducing a new way to pass metadata to changeset functions. Previously, we supported changeset functions with\ndifferent arities to optionally pass the `assigns` and `target` name to changesets.\n\nWith this release, we require the arity of all changeset functions you provide to be `3`.\n\nThe metadata, previously passed as additional parameters, is now passed as a keyword list to changesets as the third parameter.\n\nCurrently we pass the following metadata to changesets:\n\n- `:assigns` - the assigns\n- `:target` - the name of the `form` target that triggered the changeset call\n\n\nWhen you previously had a LiveResource and Schema that looked like the following:\n\n```elixir\ndefmodule MyAppWeb.UserLive do\n  use Backpex.LiveResource,\n      ...\n      update_changeset: &MyApp.User.changeset/2,\n      create_changeset: &MyApp.User.changeset/2,\nend\n\n\ndefmodule MyApp.User do\n  ...\n\n  def changeset(user, attrs) do\n      ...\n  end\nend\n```\n\nYou have to change it to this:\n\n```elixir\ndefmodule MyAppWeb.UserLive do\n  use Backpex.LiveResource,\n    ...\n    update_changeset: &MyApp.User.changeset/3,\n    create_changeset: &MyApp.User.changeset/3,\nend\n\n\ndefmodule MyApp.User do\n  ...\n\n  def changeset(user, attrs, metadata) do\n    # fetch assigns from metadata\n    assigns = Keyword.get(metadata, :assigns)\n\n    # fetch target from metadata\n    assigns = Keyword.get(metadata, :target)\n\n    ...\n  end\nend\n```\n\nThis change applies to Resource and Item Actions as well.\n\nFor example:\n\n```elixir\ndefmodule MyApp.EmailResourceAction\n  use Backpex.ResourceAction\n\n  @impl Backpex.ResourceAction\n  def changeset(change, attrs, _metadata \\\\ []) do\n    ...\n  end\nend\n```","ref":"v0-2.html#change-arity-of-changeset-functions"},{"type":"extras","title":"Update prompt option - Upgrading to v0.2","doc":"With v0.2 we are updating the prompt option for fields. This affects to the following fields: `BelongsTo`, `Select`, `HasMany`, `ManyToMany` and `MultiSelect`. \nThe `prompt` option can be raw text or a function that takes the assigns and returns text. \nWe no longer support adding additional options.\n\nIf you previously had a field that looked like the following:\n\n```elixir\ndef fields do\n  [\n    user: %{\n      module: Backpex.Fields.BelongsTo,\n      label: \"Author\",\n      prompt: [key: \"Please select an author\", disabled: true],\n      ...\n    },\n  ]\nend\n```\n\nYou need to change it to the following:\n\n```elixir\ndef fields do\n  [\n    user: %{\n      module: Backpex.Fields.BelongsTo,\n      label: \"Author\",\n      prompt: \"Please select an author\",\n      ...\n    },\n  ]\nend\n```","ref":"v0-2.html#update-prompt-option"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}